C 02/08/99                                                      DWBA98  LECT-000
      SUBROUTINE LECT(W,NW,IDMT)                                        LECT-001
C READS THE INPUT, CALCULATES THE WAVE FUNCTIONS AND THE MACROSCOPIC    LECT-002
C FORM-FACTORS. DIVIDES UP THE WORKING AREA.                            LECT-003
C THE ARGUMENTS W(I),NW(I) ARE SET IN EQUIVALENCE BY THE CALL.          LECT-004
C               IDMT IS THEIR LENGTH IN SINGLE PRECISION.               LECT-005
C FOR THE SIGNIFICANCE OF THE COMMONS /SAUVE/, /NOMBR/ AND /LIMIT/      LECT-006
C SEE CALC.                                                             LECT-007
C FOR THE SIGNIFICANCE OF THE COMMON /POIN/ SEE FDIS.                   LECT-008
C***********************************************************************LECT-009
      IMPLICIT REAL*8 (A-H,O-Z)                                         LECT-010
      DIMENSION W(1),NW(1),DESC(4)                                      LECT-011
      LOGICAL LO,LOX                                                    LECT-012
      COMMON /SAUVE/ HA,NAB,NA(4),INMA,NBFOND,NTM,NBINT,NBCNF(3)        LECT-013
      COMMON /NOMBR/ H,CCO(5),JMAX,KV,KR,KS,NBCONF,NBPROT,J,KY,ILL(3,4),LECT-014
     1LO(40)                                                            LECT-015
      COMMON /LIMIT/ COEF,TMIN,TMAX,TITRE(18),VAL(21,2),NG(8),JMX,MTJ,NJLECT-016
     1,MPAR,INM,MTETA,NAF,NAMP,NKTF,NCMU,NCH(3),NCZ(3),NCOU,NFA,NFO,NFONLECT-017
     2,NINT,NFF,NMUL,NPLACE,NQU,NSOM,NT1,NT2,NVT,NFB,JMAX1,LX1,NWF,NMF  LECT-018
      COMMON /POIN/ CMY,CCA(2,2),ENE,CRPT,IJMAX,NRY,JMY,LMY,KVA,LOX(8),NLECT-019
     1VTS,NMUS,NTMS                                                     LECT-020
      DATA DESC,ILECT /4HDESC,4HRIPT,4HION ,4HFIN ,6/                   LECT-021
      IF (LO(8).AND.(.NOT.LO(7))) GO TO 29                              LECT-022
    1 READ (5,1000) TITRE                                               LECT-023
      DO 2 I=1,3                                                        LECT-024
      IF (TITRE(I).NE.DESC(I)) GO TO 3                                  LECT-025
    2 CONTINUE                                                          LECT-026
      CALL INPA                                                         LECT-027
      CALL INPB                                                         LECT-028
      GO TO 1                                                           LECT-029
    3 IF (TITRE(1).EQ.DESC(4)) STOP                                     LECT-030
      WRITE (6,1001) TITRE                                              LECT-031
      CALL HORA                                                         LECT-032
      WRITE (6,1002) IDMT                                               LECT-033
      IF (LO(7)) CALL MEMO(IDMT,NPLACE,NQ,1,LO)                         LECT-034
      IF (LO(19)) GO TO 38                                              LECT-035
      DO 4 I=8,15                                                       LECT-036
    4 LO(I)=.FALSE.                                                     LECT-037
      READ (5,1003) (LO(I),I=8,15)                                      LECT-038
      WRITE (6,1004) (LO(I),I=8,15)                                     LECT-039
    5 READ (5,1005) ILECT                                               LECT-040
      IF ((ILECT.LT.1).OR.(ILECT.GT.7)) GO TO 35                        LECT-041
      LO(ILECT)=.FALSE.                                                 LECT-042
      DO 6 I=1,ILECT                                                    LECT-043
      IF (LO(I)) GO TO 36                                               LECT-044
    6 CONTINUE                                                          LECT-045
      GO TO ( 7 , 11 , 14 , 17 , 17 , 29 , 34 ) , ILECT                 LECT-046
C READ INTEGRATION STEP SIZE AND NUMBER OF SINGLE PARTICLE STATES.      LECT-047
    7 READ (5,1005) INM,NBFOND,NBPROT                                   LECT-048
      NQU=4*NBFOND+1                                                    LECT-049
      NFO=(NQU+3*NBFOND)/2+1                                            LECT-050
      NB1=NFO+INM*NBFOND                                                LECT-051
      NX=MAX0(NAB,NB1)                                                  LECT-052
      NY=NX+INM                                                         LECT-053
      IF (2*NY.GT.IDMT) CALL MEMO(IDMT,2*NY,NQ,3,LO)                    LECT-054
      IF (LO(19)) GO TO 38                                              LECT-055
      IDT=IDMT-2*NY                                                     LECT-056
      CALL LEC1(W(NFO),NW(NQU),W,W(NX),W(NY),H,INM,NBFOND,NBPROT,IDMT,IDLECT-057
     1T,LO)                                                             LECT-058
      IF (LO(19)) GO TO 38                                              LECT-059
      NPLACE=2*NY+IDT                                                   LECT-060
      IF (NA(1).NE.0) GO TO 8                                           LECT-061
      NA(1)=NB1                                                         LECT-062
      NAB=NB1                                                           LECT-063
      GO TO 10                                                          LECT-064
    8 IF (NB1.LE.NA(1)) GO TO 9                                         LECT-065
      LO(2)=.TRUE.                                                      LECT-066
      WRITE (6,1006) NB1,NA(1)                                          LECT-067
      WRITE (6,1007)                                                    LECT-068
    9 IF ((H.EQ.HA).AND.(INM.EQ.INMA)) GO TO 10                         LECT-069
      LO(4)=.TRUE.                                                      LECT-070
      LO(5)=.TRUE.                                                      LECT-071
      WRITE (6,1008)                                                    LECT-072
      IF (KY.EQ.1) GO TO 10                                             LECT-073
      LO(2)=.TRUE.                                                      LECT-074
      WRITE (6,1009)                                                    LECT-075
   10 HA=H                                                              LECT-076
      INMA=INM                                                          LECT-077
      GO TO 5                                                           LECT-078
C READ THE INTERACTION                                                  LECT-079
   11 NCH(1)=NA(1)                                                      LECT-080
      READ (5,1005) KV,NBINT,NBCNF(1)                                   LECT-081
      IF (NBINT.LT.KV) NBINT=KV                                         LECT-082
      WRITE (6,1010) KV,NBINT                                           LECT-083
      IF (NBCNF(1).NE.0) GO TO 31                                       LECT-084
   12 NKTF=2*(NA(1)+3*NBCNF(1))-1                                       LECT-085
      NCMU=(NKTF+49*NBINT)/2+1                                          LECT-086
      NMF=NCMU+NBINT                                                    LECT-087
      NINT=NMF+42*NBINT                                                 LECT-088
      NPLACE=2*MAX0(NPLACE,NINT)                                        LECT-089
      IF (NPLACE.GT.IDMT) CALL MEMO(IDMT,NPLACE,NQ,3,LO)                LECT-090
      IF (LO(19)) GO TO 38                                              LECT-091
      NAB=MAX0(NINT,NAB)                                                LECT-092
      IDT=IDMT-2*NAB                                                    LECT-093
      NBCONF=NBCNF(1)                                                   LECT-094
      CALL LEC2(INM,NW(NKTF),W(NCMU),W(NMF),W(NINT),W(NAB),NAB-NINT,W(NFLECT-095
     1O),NW(NCZ(1)),W(NCH(1)),IDMT,IDT)                                 LECT-096
      IF (LO(19)) GO TO 38                                              LECT-097
      NB2=NINT+IDT                                                      LECT-098
      IF (NA(2).EQ.0.OR.NB2.LE.NA(2)) GO TO 13                          LECT-099
      LO(3)=.TRUE.                                                      LECT-100
      WRITE (6,1011) NB2,NA(2)                                          LECT-101
      WRITE (6,1007)                                                    LECT-102
   13 NA(2)=MAX0(NB2,NA(2))                                             LECT-103
      NPLACE=MAX0(2*NA(2),NPLACE)                                       LECT-104
      GO TO 5                                                           LECT-105
C READ THE NUMBER OF PARTIAL WAVES AND OF ANGLES FOR THE RESULTS.       LECT-106
   14 NFB=NA(2)                                                         LECT-107
      WRITE (6,1012)                                                    LECT-108
      READ (5,1005) MTETA,JMAX,JMX,JMAX1,LMX                            LECT-109
      WRITE (6,1013) JMAX,LMX                                           LECT-110
      IF (.NOT.LO(10)) JMAX1=JMAX                                       LECT-111
      IF (LO(10)) WRITE (6,1014) JMAX1                                  LECT-112
      READ (5,1015) TMIN,TMAX                                           LECT-113
      WRITE (6,1016) MTETA,TMIN,TMAX                                    LECT-114
      TMAX=TMAX*3.141592653589793D0/180.D0                              LECT-115
      TMIN=TMIN*3.141592653589793D0/180.D0                              LECT-116
      READ (5,1005) NG                                                  LECT-117
      LO(17)=.FALSE.                                                    LECT-118
      READ (5,1003) LO(17)                                              LECT-119
      IF (.NOT.LO(17)) WRITE (6,1017) JMX                               LECT-120
      WRITE (6,1018) NG                                                 LECT-121
      NFA=2*(JMAX1+4)+LMX                                               LECT-122
      NT2=NFB+NFA                                                       LECT-123
      NB3=NT2+10*MTETA+2                                                LECT-124
      IF (.NOT.LO(8)) NB3=NT2                                           LECT-125
      IF (NA(3).EQ.0.OR.NB3.LE.NA(3)) GO TO 15                          LECT-126
      WRITE (6,1019) NB3,NA(3)                                          LECT-127
      LO(4)=.TRUE.                                                      LECT-128
      WRITE (6,1007)                                                    LECT-129
   15 NA(3)=MAX0(NB3,NA(3))                                             LECT-130
      NPLACE=MAX0(2*NA(3),NPLACE)                                       LECT-131
      NAB=MAX0(NA(3),NAB)                                               LECT-132
      IF (NPLACE.GT.IDMT) CALL MEMO(IDMT,NPLACE,NQ,3,LO)                LECT-133
      IF (LO(19)) GO TO 38                                              LECT-134
      W(NFB)=0.D0                                                       LECT-135
      A1=0.D0                                                           LECT-136
      DO 16 I=2,NFA                                                     LECT-137
      A1=A1+1.D0                                                        LECT-138
   16 W(NFB+I-1)=W(NFB+I-2)+DLOG(A1)                                    LECT-139
      GO TO 5                                                           LECT-140
C READ THE POTENTIAL FOR THE INITIAL OR THE FINAL STATE                 LECT-141
   17 IG=ILECT-3                                                        LECT-142
      IF (ILECT.EQ.4) GO TO 20                                          LECT-143
      WRITE (6,1020)                                                    LECT-144
      DO 18 I=32,37                                                     LECT-145
   18 LO(I)=.FALSE.                                                     LECT-146
      READ (5,1003) (LO(I),I=32,37)                                     LECT-147
      IF (.NOT.LO(32)) GO TO 22                                         LECT-148
      READ (5,1015) VAL(20,2)                                           LECT-149
      DO 19 I=1,19                                                      LECT-150
   19 VAL(I,2)=VAL(I,1)                                                 LECT-151
      VAL(21,2)=VAL(21,1)                                               LECT-152
      LO(36)=LO(38)                                                     LECT-153
      LO(37)=LO(39)                                                     LECT-154
      WRITE (6,1021) (LO(I),I=33,37)                                    LECT-155
      NPOT=NAB                                                          LECT-156
      GO TO 26                                                          LECT-157
   20 WRITE (6,1022)                                                    LECT-158
      DO 21 I=33,37                                                     LECT-159
   21 LO(I)=.FALSE.                                                     LECT-160
      READ (5,1003) (LO(I),I=33,37)                                     LECT-161
      LO(38)=LO(36)                                                     LECT-162
      LO(39)=LO(37)                                                     LECT-163
   22 WRITE (6,1023) (LO(I),I=33,37)                                    LECT-164
      ECL=VAL(20,1)                                                     LECT-165
      READ (5,1024) (VAL(I,IG),I=17,21)                                 LECT-166
      IF ((ILECT.EQ.4).AND.(ECL.NE.VAL(20,1))) LO(5)=.TRUE.             LECT-167
      IF ((.NOT.LO(36)).AND.(.NOT.LO(37))) READ (5,1015) (VAL(I,IG),I=2,LECT-168
     116)                                                               LECT-169
      READ (5,1015) VAL(1,IG)                                           LECT-170
      NFON=NA(3)                                                        LECT-171
      NCOU=NFON+8*INM*JMAX                                              LECT-172
      NFF=NCOU+8*JMAX                                                   LECT-173
      NWF=NFF+12*(JMAX+4)                                               LECT-174
      IF (.NOT.LO(10)) NWF=NFF+8*(JMAX+4)                               LECT-175
      NB4=NWF+3*(JMAX1+4)                                               LECT-176
      IF (.NOT.LO(10)) NB4=NWF                                          LECT-177
      IF (NA(4).EQ.0.OR.NB4.LE.NA(4)) GO TO 23                          LECT-178
      WRITE (6,1026) NB4,NA(4)                                          LECT-179
      LO(6)=.TRUE.                                                      LECT-180
      WRITE (6,1007)                                                    LECT-181
      WRITE (6,1027)                                                    LECT-182
      IF (IG.EQ.2) GO TO 23                                             LECT-183
      LO(5)=.TRUE.                                                      LECT-184
      WRITE (6,1007)                                                    LECT-185
   23 NA(4)=MAX0(NB4,NA(4))                                             LECT-186
      NAB=MAX0(NA(4),NAB)                                               LECT-187
      NPOT=NAB                                                          LECT-188
      IF (.NOT.LO(37)) GO TO 26                                         LECT-189
C DESCRIPTION OF THE TARGET FOR POTENTIAL FROM TWO-BODY INTERACTION     LECT-190
      DO 24 I=1,8                                                       LECT-191
   24 LOX(I)=.FALSE.                                                    LECT-192
      READ (5,1003) (LOX(I),I=1,8)                                      LECT-193
      WRITE (6,1025) (LOX(I),I=1,8)                                     LECT-194
      IF (LOX(5)) GO TO 26                                              LECT-195
      IF (LOX(8)) GO TO 25                                              LECT-196
      READ (5,1005) NBCNF(2)                                            LECT-197
      NCH(2)=NPOT                                                       LECT-198
      NPOT=NCH(2)+3*NBCNF(2)                                            LECT-199
      GO TO 31                                                          LECT-200
   25 NBCNF(2)=NBCNF(1)                                                 LECT-201
      NCZ(2)=NCZ(1)                                                     LECT-202
      NCH(2)=NCH(1)                                                     LECT-203
   26 NIE=NPOT+4*INM                                                    LECT-204
      NBCONF=NBCNF(2)                                                   LECT-205
      NPLACE=MAX0(NPLACE,2*(NIE+JMAX+4))                                LECT-206
      IF (NPLACE.GT.IDMT) CALL MEMO(IDMT,NPLACE,NQ,3,LO)                LECT-207
      IF (LO(19)) GO TO 38                                              LECT-208
      IF (.NOT.LO(37)) GO TO 28                                         LECT-209
      IF ((IG.EQ.2).AND.LO(32)) GO TO 27                                LECT-210
      NVTS=NPLACE                                                       LECT-211
      NMUS=NVTS+68*INM                                                  LECT-212
      NPLACE=MAX0(NPLACE,2*(NMUS+18*INM*KS+2*INM))                      LECT-213
      IF (NPLACE.GT.IDMT) CALL MEMO(IDMT,NPLACE,NQ,3,LO)                LECT-214
      IF (LO(19)) GO TO 38                                              LECT-215
   27 IF (.NOT.LOX(5)) CALL DIRZ(W(NTMS),NW(NTMS),W(NVTS),INM)          LECT-216
      IF (LO(19)) GO TO 38                                              LECT-217
   28 CALL FDIS(W,NW,JMAX+4,INM,W(NCOU+2*IG-2),W(NPOT),W(NFF),W(NFON+4* LECT-218
     1JMAX*INM*(IG-1)),IDMT,IDMT-2*NPOT,W(NIE),W(NWF),JMAX1+4,NIE,IG)   LECT-219
      IF (LO(19)) GO TO 38                                              LECT-220
      GO TO 5                                                           LECT-221
C DESCRIPTION OF THE FINAL STATE OF THE TARGET                          LECT-222
   29 WRITE (6,1028)                                                    LECT-223
      NCH(3)=NA(4)                                                      LECT-224
      IF (.NOT.LO(8)) GO TO 30                                          LECT-225
      LO(18)=.FALSE.                                                    LECT-226
      READ (5,1003) LO(18)                                              LECT-227
      WRITE (6,1029) LO(18)                                             LECT-228
   30 READ (5,1005) J,MPAR,NBCNF(3)                                     LECT-229
      NJ=2*J+1                                                          LECT-230
      MPAR=MPAR*(1-2*MOD(J,2))                                          LECT-231
      JJ=J                                                              LECT-232
      MP=MPAR                                                           LECT-233
      LO(20)=MPAR.GT.0                                                  LECT-234
      LO(21)=.NOT.(LO(10).AND.(J.LE.4).AND.LO(20))                      LECT-235
      GO TO 32                                                          LECT-236
   31 JJ=J                                                              LECT-237
      J=0                                                               LECT-238
      MP=1                                                              LECT-239
   32 IK=ILECT/2                                                        LECT-240
      NCZ(IK)=2*(NCH(IK)+2*NBCNF(IK))-1                                 LECT-241
      NTM=NCH(IK)+3*NBCNF(IK)                                           LECT-242
      NTZ=NCZ(IK)+2*NBCNF(IK)                                           LECT-243
      NBCONF=NBCNF(IK)                                                  LECT-244
      IDT=IDMT-NTM                                                      LECT-245
      NAB=MAX0(NAB,NTM)                                                 LECT-246
      CALL LEC6(W(NT2),MTETA,NW(NCZ(IK)),W(NCH(IK)),NW(NQU),W,MP,W(NTM),LECT-247
     1NW(NTZ),IK.NE.3,IDMT,IDT)                                         LECT-248
      IF (LO(19)) GO TO 38                                              LECT-249
      J=JJ                                                              LECT-250
      GO TO ( 12 , 26 , 33 ), IK                                        LECT-251
   33 NPLACE=2*NTM+IDT                                                  LECT-252
      NAB=NTM+IDT                                                       LECT-253
      GO TO 5                                                           LECT-254
C END OF INPUT                                                          LECT-255
   34 MTJ=1                                                             LECT-256
      IF (LO(8)) MTJ=-MTJ                                               LECT-257
      IF (LO(18).AND.MTJ.EQ.-1) MTJ=0                                   LECT-258
      LO(22)=.FALSE.                                                    LECT-259
      LO(24)=LO(29).AND.LO(30)                                          LECT-260
      NBCONF=NBCNF(3)                                                   LECT-261
      NSOM=NAB                                                          LECT-262
      NTOT=NSOM+4*NJ*JMAX1                                              LECT-263
      NVT=NTOT                                                          LECT-264
      NT1=NVT+2*INM                                                     LECT-265
      NAMP=NT1+6*MTETA                                                  LECT-266
      NAF=NAMP+4*(NJ+1)*(JMAX1+1)                                       LECT-267
      NTOT=NAF+2*NFA+NJ+1                                               LECT-268
      NMUL=NVT+68*INM                                                   LECT-269
      NTX=2*MAX0(NMUL+18*INM*KS+2*INM,2*NTOT)                           LECT-270
      WRITE (6,1030) NTX,NA,NAB                                         LECT-271
      IF (NTX.GT.IDMT) CALL MEMO(IDMT,NTX,NPLACE,5,LO)                  LECT-272
      IF (LO(19)) GO TO 38                                              LECT-273
      IF (NPLACE.GT.NTX) CALL MEMO(IDMT,NPLACE-NTX,NPLACE,2,LO)         LECT-274
      CALL DIRZ(W(NTM),NW(NTM),W(NVT),INM)                              LECT-275
      IF (LO(19)) GO TO 38                                              LECT-276
      RETURN                                                            LECT-277
   35 WRITE (6,1031) ILECT                                              LECT-278
      GO TO 37                                                          LECT-279
   36 WRITE (6,1032)                                                    LECT-280
   37 LO(19)=.TRUE.                                                     LECT-281
   38 WRITE (6,1033)                                                    LECT-282
      RETURN                                                            LECT-283
 1000 FORMAT (18A4)                                                     LECT-284
 1001 FORMAT (1H1/5X,80(1H*)/5X,1H*,78X,1H*/5X,1H*,3X,18A4,3X,1H*/5X,1H*LECT-285
     1,78X,1H*/5X,80(1H*))                                              LECT-286
 1002 FORMAT (//36H DWBA98           TOTAL DIMENSION  =,I10)            LECT-287
 1003 FORMAT (72L1)                                                     LECT-288
 1004 FORMAT (8H LO(8) =,L2,13H - SUM OVER J/8H LO(9) =,L2,26H - RELATIVLECT-289
     1ISTIC KINEMATICS/8H LO(10)=,L2,22H - COULOMB CORRECTIONS/8H LO(11)LECT-290
     2=,L2,27H - NON-LOCALITY CORRECTIONS/8H LO(12)=,L2,21H - RECOIL CORLECT-291
     3RECTIONS/8H LO(13)=,L2,27H - PRINT STORAGE ALLOCATION/8H LO(14)=,LLECT-292
     42,34H - DON'T PRINT DIRECT FORM-FACTORS/8H LO(15)=,L2,46H - PUNCH LECT-293
     5PHASE-SHIFTS AND AMPLITUDES ON TAPE 7)                            LECT-294
 1005 FORMAT (14I5)                                                     LECT-295
 1006 FORMAT (45H STORAGE FOR THE SINGLE PARTICLE BOUND STATES,I10,37H ILECT-296
     1S GREATER THAN THAT USED PREVIOUSLY,I10)                          LECT-297
 1007 FORMAT (53H THE INPUT FOR THE NEXT VALUE OF ILECT MUST BE REREAD) LECT-298
 1008 FORMAT (25H PREVIOUS NUMBER OF STEPS,I5,14H  OR STEP SIZE,E15.6/33LECT-299
     1H HAS BEEN CHANGED INTO THE NUMBER,I5,18H  OR THE STEP SIZE,E15.6/LECT-300
     274H THE OPTICAL POTENTIALS FOR THE INITIAL AND THE FINAL STATE MUSLECT-301
     3T BE REREAD)                                                      LECT-302
 1009 FORMAT (57H THE INPUT OF THE DESCRIPTION OF THE FORCE MUST BE RERELECT-303
     1AD)                                                               LECT-304
 1010 FORMAT (/25H DESCRIPTION OF THE FORCE//3X,I3,18H RANGES ( MAXIMUM:LECT-305
     1,I3,2H ))                                                         LECT-306
 1011 FORMAT (22H STORAGE FOR THE FORCE,I10,37H IS GREATER THAN THAT USELECT-307
     1D PREVIOUSLY,I10)                                                 LECT-308
 1012 FORMAT (/21H MAXIMUM J AND ANGLES/)                               LECT-309
 1013 FORMAT (5X,I6,14H PARTIAL WAVES,8X,I3,22H ADDITIONAL FACTORIALS)  LECT-310
 1014 FORMAT (5X,I6,42H PARTIAL WAVES FOR THE COULOMB CORRECTIONS)      LECT-311
 1015 FORMAT (3F10.5)                                                   LECT-312
 1016 FORMAT (8X,I5,15H ANGLES BETWEEN,F8.3,4H AND,F8.3,8H DEGREES)     LECT-313
 1017 FORMAT (/41H  ****** CALCULATION WITH EXCHANGE ******,10X,I3,11H MLECT-314
     1ULTIPOLES)                                                        LECT-315
 1018 FORMAT (/21H  GRAPHICAL CONTROLS:,5X,8I5)                         LECT-316
 1019 FORMAT (27H STORAGE FOR THE FACTORIALS,I10,37H IS GREATER THAN THALECT-317
     1T USED PREVIOUSLY,I10)                                            LECT-318
 1020 FORMAT (/38H OPTICAL POTENTIAL FOR THE FINAL STATE)               LECT-319
 1021 FORMAT (50H **** SAME POTENTIAL AS FOR THE INITIAL STATE ****/8H LLECT-320
     1O(33)=,L2,29H - PRINT ELASTIC PHASE-SHIFTS/8H LO(34)=,L2,19H - PRILECT-321
     2NT POTENTIALS/8H LO(35)=,L2,38H - PRINT RESULTS OF ELASTIC SCATTERLECT-322
     3ING/8H LO(36)=,L2,51H - POTENTIAL GIVEN BY POINTS OR SUM OF FORM-FLECT-323
     4ACTORS/8H LO(37)=,L2,51H - POTENTIAL COMPUTED FROM THE TWO BODY INLECT-324
     5TERACTION/)                                                       LECT-325
 1022 FORMAT (/40H OPTICAL POTENTIAL FOR THE INITIAL STATE/)            LECT-326
 1023 FORMAT (8H LO(33)=,L2,29H - PRINT ELASTIC PHASE-SHIFTS/8H LO(34)=,LECT-327
     1L2,19H - PRINT POTENTIALS/8H LO(35)=,L2,38H - PRINT RESULTS OF ELALECT-328
     2STIC SCATTERING/8H LO(36)=,L2,51H - POTENTIAL GIVEN BY POINTS OR SLECT-329
     3UM OF FORM-FACTORS/8H LO(37)=,L2,51H - POTENTIAL COMPUTED FROM THELECT-330
     4 TWO BODY INTERACTION/)                                           LECT-331
 1024 FORMAT (5F10.5)                                                   LECT-332
 1025 FORMAT (69H **** COMPUTATION OF THE POTENTIAL FROM THE TWO BODY INLECT-333
     1TERACTION ****/8H LOX(1)=,L2,34H - EXCHANGE NOT TAKEN INTO ACCOUNTLECT-334
     2/8H LOX(2)=,L2,59H - COULOMB POTENTIAL COMPUTED FROM THE TWO BODY LECT-335
     3INTERACTION/8H LOX(3)=,L2,38H - TWO BODY COULOMB POTENTIAL MODIFIELECT-336
     4D/8H LOX(4)=,L2,31H - USE OF A FILE FOR POTENTIALS/8H LOX(5)=,L2,3LECT-337
     50H - READ POTENTIALS FROM A FILE/8H LOX(6)=,L2,89H - EXCHANGE NOT LECT-338
     6TAKEN INTO ACCOUNT BEYOND SOME L VALUE OR USE OF ANOTHER FILE THANLECT-339
     7 FILE 8/8H LOX(7)=,L2,37H - PRINT PROTON AND NEUTRON DENSITIES/8H LECT-340
     8LOX(8)=,L2,55H - USE THE OCCUPATION NUMBERS READ WITH THE INTERACTLECT-341
     9ION)                                                              LECT-342
 1026 FORMAT (31H STORAGE FOR THE WAVE FUNCTIONS,I10,37H IS GREATER THANLECT-343
     1 THAT USED PREVIOUSLY,I10)                                        LECT-344
 1027 FORMAT (46H THE INPUT FOR THE OF ILECT = 6 MUST BE REREAD)        LECT-345
 1028 FORMAT (/45H DESCRIPTION OF THE FINAL STATE OF THE TARGET)        LECT-346
 1029 FORMAT (/34H SUMMATION OVER J ...  LAST VALUE:,L4)                LECT-347
 1030 FORMAT (/14H TOTAL STORAGE,I10,10X,15HPARTIAL STORAGE,5I8)        LECT-348
 1031 FORMAT (24H ILLEGAL VALUE FOR ILECT,I90)                          LECT-349
 1032 FORMAT (17H INPUT INCOMPLETE)                                     LECT-350
 1033 FORMAT (25H ***** STOP IN LECT *****)                             LECT-351
      END                                                               LECT-352
