C 02/08/99                                                      DWBA98  LEC6-000
      SUBROUTINE LEC6(TGS,MTETA,NCHE,X,NQ,VBCS,MPAR,V,NV,LT,IDMT,IDT)   LEC6-001
C DESCRIPTION OF THE EXCITED STATE.                                     LEC6-002
C INPUTS:     MTETA  NUMBER OF ANGLES FOR THE RESULTS.                  LEC6-003
C             NQ     QUANTUM NUMBERS OF SINGLE PARTICLE STATES          LEC6-004
C             VBCS   U/V OF BCS.                                        LEC6-005
C             MPAR   PARITY OF THE EXCITATION ( 1 OR -1).               LEC6-006
C             IDMT   DIMENSION OF THE TOTAL WORKING AREA.               LEC6-007
C             IDT    TOTAL DIMENSION OF THE TABLE V/NV.                 LEC6-008
C             LT     TRUE TO READ ONLY TARGET OCCUPATION NUMBERS.       LEC6-009
C DATA PASSED OVER BY THE COMMON /NOMBR/                                LEC6-010
C     J       SPIN TRANSFER.                                            LEC6-011
C     NBCONF  NUMBER OF CONFIGURATIONS.                                 LEC6-012
C     NBPROT  NUMBER OF SINGLE PARTICLE STATES IDENTICAL TO THE INCIDENTLEC6-013
C              PARTICLE.                                                LEC6-014
C     LO      LOGICAL CONTROLS:                                         LEC6-015
C          LO(7)  .TRUE.  THIS IS FIRST OR THE UNIQUE VALUE OF J.       LEC6-016
C          LO(8)  .TRUE.  SUMMATION OVER DIFFERENT J.                   LEC6-017
C          LO(40) .TRUE.  BCS.                                          LEC6-018
C          LO(20) .TRUE.  NATURAL PARITY.                               LEC6-019
C READ HERE  LO(26) .TRUE.  MACROSCOPIC FORM-FACTOR.                    LEC6-020
C            LO(28) .TRUE.  INDEPENDENT SPIN-ORBIT FORM-FACTORS.        LEC6-021
C            LO(34) .TRUE.  PRINT MACROSCOPIC FORM-FACTOR.              LEC6-022
C CALCULATES LO(30) .TRUE.  REAL MACROSCOPIC FROM-FACTOR.               LEC6-023
C            LO(27) .TRUE.  MACROSCOPIC SPIN-ORBIT FORM-FACTOR.         LEC6-024
C RESULTS:   TGS    TABLE ZEROED ON FIRST PASS FOR THE CASE OF          LEC6-025
C                   SUMMATION OVER J.                                   LEC6-026
C            NCHE   ADDRESS OF THE PARTICLE AND OF THE HOLE.            LEC6-027
C            X      AMPLITUDES X AND Y.                                 LEC6-028
C            IDT    SPACE USED BY THE TABLE V/NV.                       LEC6-029
C            NV,V  EQUIVALENCED BY CALL: MACROSCOPIC INTERACTION.       LEC6-030
C  NV(1)  ADDRESS OF THE END OF THE TABLE OF NUMBER OF COMPONENTS.      LEC6-031
C  NV(2)  ADDRESS OF THE START OF THE RADII OF THE FORM-FACTORS READ    LEC6-032
C               POINT BY POINT.                                         LEC6-033
C  NV(3)  NUMBER OF POINTS.                                             LEC6-034
C  NV(4)  NUMBER OF FORM-FACTORS READ POINT BY POINT.                   LEC6-035
C  NV(I)  FOR I=5 TO 8: NUMBER OF COMPONENTS FOR THE REAL AND IMAGINARY LEC6-036
C              PARTS OF A(R) AND B(R).                                  LEC6-037
C         FOR I=9: OF THE CHARGE DENSITY.                               LEC6-038
C         FOR I=10 AND 11: OF THE REAL AND IMAGINARY SPIN-ORBIT IF      LEC6-039
C              LO(28)=.FALSE.                                           LEC6-040
C              OF THE REAL AND IMAGINARY PARTS OF A1(R) IF LO(28)=.T.   LEC6-041
C         FOR I=12 TO 19: OF THE REAL AND IMAGINARY PARTS OF THE OTHER  LEC6-042
C              FORM-FACTORS FOR NATURAL PARITY AND LO(28)=.TRUE.        LEC6-043
C         THE END OF THIS PART OF THE TABLE IS IN NV(1).                LEC6-044
C THEN, FOR EACH  NON-ZERO NV(I),I=5,11 OR 19 :                         LEC6-045
C   NV(J),NV(J+1) ...  IDENTIFICATION OF THE NV(I) COMPONENTS,          LEC6-046
C   V(K),V(K+1) .... 1 PARAMETER FOR A FORM-FACTOR READ POINT BY POINT  LEC6-047
C                    7 PARAMETERS FOR A DERIVATIVE OF A WOODS-SAXON.    LEC6-048
C          THE END OF THIS PART OF THE TABLE IS IN NV(2).               LEC6-049
C THEN COME THE NV(3) RADII, THEN THE NV(4)*NV(3) VALUES FOR THE        LEC6-050
C          FORM-FACTORS READ IN POINT BY POINT.                         LEC6-051
C***********************************************************************LEC6-052
      IMPLICIT REAL*8 (A-H,O-Z)                                         LEC6-053
      LOGICAL LO,LOO(4),LT                                              LEC6-054
      DIMENSION X(2,1),NCHE(2,1),NQ(3,1),VBCS(2,1),TGS(1),V(1),NV(9),DESLEC6-055
     1(4,7)                                                             LEC6-056
      COMMON /NOMBR/ H,CCO(5),JMAX,KV,KR,KS,NBCONF,NBPROT,J,KY,ILL(3,4),LEC6-057
     1LO(40)                                                            LEC6-058
      DATA DES /4HA(R),4H REA,4HL   ,4H    ,4HA(R),4H IMA,4HGINA,4HRY  ,LEC6-059
     14HB(R),4H REA,4HL   ,4H    ,4HB(R),4H IMA,4HGINA,4HRY  ,4HCOUL,4HOLEC6-060
     2MB ,4H    ,4H    ,4HS.O.,4H REA,4HL   ,4H    ,4HS.O.,4H IMA,4HGINALEC6-061
     3,4HRY  /                                                          LEC6-062
      DO 1 I=1,4                                                        LEC6-063
    1 LOO(I)=.FALSE.                                                    LEC6-064
      IF (LT) GO TO 2                                                   LEC6-065
      IT=0                                                              LEC6-066
      LO(26)=.FALSE.                                                    LEC6-067
      LO(28)=.FALSE.                                                    LEC6-068
      READ (5,1000) LOO,LO(26),LO(28)                                   LEC6-069
      WRITE (6,1001) LOO,LO(26),LO(28)                                  LEC6-070
      GO TO 3                                                           LEC6-071
    2 READ (5,1000) (LOO(I),I=1,4)                                      LEC6-072
      WRITE (6,1002) (LOO(I),I=1,4)                                     LEC6-073
    3 READ (5,1003) CP,CN,AMIN                                          LEC6-074
      IF (AMIN.EQ.0.D0) AMIN=0.001D0                                    LEC6-075
C READ THE PARTICLE-HOLE CONFIGURATION                                  LEC6-076
      DO 6 K=1,NBCONF                                                   LEC6-077
      READ (5,1004) NCHE(1,K),NCHE(2,K)                                 LEC6-078
      READ (5,1003) X(1,K),X(2,K)                                       LEC6-079
      WRITE (6,1005) NCHE(1,K),NCHE(2,K),X(1,K),X(2,K)                  LEC6-080
      IF (NCHE(1,K).GT.NBPROT) GO TO 4                                  LEC6-081
      X(1,K)=CP*X(1,K)                                                  LEC6-082
      X(2,K)=CP*X(2,K)                                                  LEC6-083
      IF (LT.AND.NCHE(2,K).GT.NBPROT) GO TO 20                          LEC6-084
      GO TO 5                                                           LEC6-085
    4 X(1,K)=CN*X(1,K)                                                  LEC6-086
      X(2,K)=CN*X(2,K)                                                  LEC6-087
      IF (LT.AND.NCHE(2,K).LE.NBPROT) GO TO 20                          LEC6-088
    5 K1=NCHE(1,K)                                                      LEC6-089
      K2=NCHE(2,K)                                                      LEC6-090
      IF (1-2*MOD(NQ(2,K1)+NQ(2,K2)+J,2).NE.MPAR) GO TO 21              LEC6-091
      IF (IABS(2*(NQ(2,K1)-NQ(2,K2))+NQ(3,K1)-NQ(3,K2)).GT.2*J) GO TO 22LEC6-092
      IF (2*(NQ(2,K1)+NQ(2,K2))+NQ(3,K1)+NQ(3,K2).LT.2*J) GO TO 23      LEC6-093
      IF (.NOT.(LT.AND.LOO(4))) GO TO 6                                 LEC6-094
      A=DSQRT(DFLOAT(2*NQ(2,K1)+NQ(3,K1)+1))                            LEC6-095
      X(1,K)=A*X(1,K)                                                   LEC6-096
      X(2,K)=A*X(2,K)                                                   LEC6-097
    6 CONTINUE                                                          LEC6-098
      IF (LO(40)) CALL XYIS(NQ,VBCS,NCHE,X,NBCONF,MPAR,4)               LEC6-099
C CHANGE THE NOTATION                                                   LEC6-100
      DO 7 K=1,3                                                        LEC6-101
      IF (LOO(K)) CALL XYIS(NQ,VBCS,NCHE,X,NBCONF,MPAR,K)               LEC6-102
    7 CONTINUE                                                          LEC6-103
      WRITE (6,1006) AMIN                                               LEC6-104
C ELIMINATION OF COMPONENTS THAT ARE TOO SMALL                          LEC6-105
      DO 8 K=1,NBCONF                                                   LEC6-106
      IF (ABS(X(1,K)).LT.AMIN) X(1,K)=0.D0                              LEC6-107
      IF (ABS(X(2,K)).LT.AMIN) X(2,K)=0.D0                              LEC6-108
    8 CONTINUE                                                          LEC6-109
      WRITE (6,1007) J,MPAR,NBCONF,CP,CN                                LEC6-110
      WRITE (6,1005) ((NCHE(I,K),I=1,2),(X(I,K),I=1,2),K=1,NBCONF)      LEC6-111
      IF (LT) GO TO 19                                                  LEC6-112
      IF (.NOT.(LO(7).AND.LO(8))) GO TO 10                              LEC6-113
C PUT ZERO IN A TABLE FOR SUMMATION ON J-VALUES                         LEC6-114
      M=10*MTETA+2                                                      LEC6-115
      DO 9 I=1,M                                                        LEC6-116
    9 TGS(I)=0.D0                                                       LEC6-117
   10 LO(30)=.TRUE.                                                     LEC6-118
      LO(27)=.FALSE.                                                    LEC6-119
      IF (.NOT.LO(26)) GO TO 19                                         LEC6-120
C READ IN THE DESCRIPTIONS OF THE MACROSCOPIC FORM-FACTORS              LEC6-121
      ITM=0                                                             LEC6-122
      WRITE (6,1008) LO(28)                                             LEC6-123
      IT=11                                                             LEC6-124
      IF (LO(28).AND.LO(20)) IT=19                                      LEC6-125
      IF (IT.GT.IDT) CALL MEMO(IDMT,IDMT+IT-IDT,IDT,3,LO)               LEC6-126
      IF (LO(19)) GO TO 25                                              LEC6-127
      READ (5,1004) (NV(I),I=3,IT)                                      LEC6-128
      NV(1)=IT                                                          LEC6-129
      ITT=IT                                                            LEC6-130
      DO 15 II=5,ITT                                                    LEC6-131
      K=NV(II)                                                          LEC6-132
      IF (K.LE.0) GO TO 15                                              LEC6-133
      IF (IT+8*K.GT.IDT) CALL MEMO(IDMT,IDMT+IT+12*K-IDT,IDT,3,LO)      LEC6-134
      IF (LO(19)) GO TO 25                                              LEC6-135
      IV=IT+1                                                           LEC6-136
      IT=IT+K                                                           LEC6-137
      READ (5,1004) (NV(L),L=IV,IT)                                     LEC6-138
      IJ=II-4                                                           LEC6-139
      IF (IJ.GT.7) IJ=MOD(IJ,2)+6                                       LEC6-140
      WRITE (6,1009) (DES(L,IJ),L=1,4),K                                LEC6-141
      IF (IJ.EQ.2.OR.IJ.EQ.4.OR.IJ.EQ.7) LO(30)=.FALSE.                 LEC6-142
      IF (IJ.GE.6) LO(27)=.TRUE.                                        LEC6-143
      JV=IV                                                             LEC6-144
      JT=IT                                                             LEC6-145
      DO 14 M=JV,JT                                                     LEC6-146
      K1=NV(M)                                                          LEC6-147
      K2=IABS(K1)                                                       LEC6-148
      IF (K1.EQ.K2) GO TO 11                                            LEC6-149
      WRITE (6,1010) J                                                  LEC6-150
      IF (M.EQ.JT.AND.JV.NE.JT) GO TO 11                                LEC6-151
      WRITE (6,1011)                                                    LEC6-152
      STOP                                                              LEC6-153
   11 IF (K2.GT.4) GO TO 12                                             LEC6-154
      IV=(IT+1)/2+1                                                     LEC6-155
      IT=IT+7                                                           LEC6-156
      K3=K2-1                                                           LEC6-157
      READ (5,1003) (V(L),L=IV,IT)                                      LEC6-158
      WRITE (6,1012) K3,(V(L),L=IV,IT)                                  LEC6-159
      IT=2*IT                                                           LEC6-160
      GO TO 14                                                          LEC6-161
   12 IF (K2.GT.100.AND.K2.LE.100+NV(4)) GO TO 13                       LEC6-162
      WRITE (6,1013) K2,NV(4)                                           LEC6-163
      STOP                                                              LEC6-164
   13 ITM=ITM+1                                                         LEC6-165
      IT=(IT+1)/2+1                                                     LEC6-166
      READ (5,1003) V(IT)                                               LEC6-167
      K3=K2-100                                                         LEC6-168
      WRITE (6,1014) K3,V(IT)                                           LEC6-169
      IT=2*IT                                                           LEC6-170
   14 CONTINUE                                                          LEC6-171
   15 CONTINUE                                                          LEC6-172
      IF (NV(4).EQ.0.AND.ITM.EQ.0) GO TO 19                             LEC6-173
      NPOI=NV(3)                                                        LEC6-174
      IF (NV(4).NE.0.AND.NPOI.GT.3) GO TO 16                            LEC6-175
      WRITE (6,1015) NV(4),NPOI,ITM                                     LEC6-176
   16 IT=(IT+1)/2                                                       LEC6-177
      NV(2)=(IT+1)/2                                                    LEC6-178
C READ IN FORM-FACTORS POINT BY POINT                                   LEC6-179
      K1=NV(4)+1                                                        LEC6-180
      DO 17 K=1,K1                                                      LEC6-181
      IV=IT+1                                                           LEC6-182
      IT=IT+NPOI                                                        LEC6-183
   17 READ (5,1016) (V(I),I=IV,IT)                                      LEC6-184
C PRINT OUT THE FORM-FACTORS READ IN POINT BY POINT                     LEC6-185
      IF (.NOT.LOO(4)) GO TO 19                                         LEC6-186
      WRITE (6,1017)                                                    LEC6-187
      DO 18 K=1,NPOI                                                    LEC6-188
      K2=NV(2)+K                                                        LEC6-189
   18 WRITE (6,1018) K,(V(L),L=K2,IT,NPOI)                              LEC6-190
   19 IDT=IT                                                            LEC6-191
      IF (.NOT.(LO(27).OR.LO(28))) RETURN                               LEC6-192
      ILL(1,1)=MAX0(5,ILL(1,1))                                         LEC6-193
      ILL(2,1)=MAX0(2,ILL(2,1))                                         LEC6-194
      ILL(1,2)=MAX0(3,ILL(1,2))                                         LEC6-195
      RETURN                                                            LEC6-196
   20 WRITE (6,1019) K,NCHE(1,K),NCHE(2,K)                              LEC6-197
      GO TO 24                                                          LEC6-198
   21 WRITE (6,1020) NQ(2,K1),NQ(2,K2),MPAR                             LEC6-199
      GO TO 24                                                          LEC6-200
   22 WRITE (6,1021) NQ(2,K1),NQ(3,K1),NQ(2,K2),NQ(3,K2),J              LEC6-201
      GO TO 24                                                          LEC6-202
   23 WRITE (6,1022) NQ(2,K1),NQ(3,K1),NQ(2,K2),NQ(3,K2),J              LEC6-203
   24 LO(19)=.TRUE.                                                     LEC6-204
   25 WRITE (6,1023)                                                    LEC6-205
      RETURN                                                            LEC6-206
 1000 FORMAT (72L1)                                                     LEC6-207
 1001 FORMAT (8H LOO(1)=,L2,20H - ISOSPIN FORMALISM/8H LOO(2)=,L2,22H - LEC6-208
     1PHASE 1 FROM GILLET/8H LOO(3)=,L2,22H - PHASE 2 FROM GILLET/8H LOOLEC6-209
     2(4)=,L2,33H - PRINT MACROSCOPIC FORM FACTORS/8H LO(26)=,L2,31H - ULEC6-210
     3SE MACROSCOPIC FORM FACTORS/8H LO(28)=,L2,38H - INDEPENDENT SPIN OLEC6-211
     4RBIT FORM FACTORS)                                                LEC6-212
 1002 FORMAT (8H LOO(1)=,L2,20H - ISOSPIN FORMALISM/8H LOO(2)=,L2,22H - LEC6-213
     1PHASE 1 FROM GILLET/8H LOO(3)=,L2,22H - PHASE 2 FROM GILLET/8H LOOLEC6-214
     2(4)=,L2,36H - VALUES TO MULTIPLY BY SQRT(2*J+1))                  LEC6-215
 1003 FORMAT (7F10.5)                                                   LEC6-216
 1004 FORMAT (14I5)                                                     LEC6-217
 1005 FORMAT (9H PARTICLE,I3,6H  HOLE,I3,5X,3HX =,D15.6,5X,3HY =,D15.6) LEC6-218
 1006 FORMAT (26H    X AND Y   SMALLER THAN,D15.6,11H SUPPRESSED)       LEC6-219
 1007 FORMAT (//15H ********** J =,I2,11H **********,10X,6HMPAR =,I2///1LEC6-220
     10X,I2,15H CONFIGURATIONS/24H PROTONS  MULTIPLIED BY ,D15.6/24H NEULEC6-221
     2TRONS MULTIPLIED BY ,D15.6/)                                      LEC6-222
 1008 FORMAT (/34H READ THE MACROSCOPIC FORM-FACTORS//L5,40H FORM-FACTORLEC6-223
     1S FOR INDEPENDENT SPIN-ORBIT/)                                    LEC6-224
 1009 FORMAT (13H FORM-FACTOR ,4A4,10X,I3,11H COMPONENTS)               LEC6-225
 1010 FORMAT (/109H ELEMENT OF THE FORM-FACTOR NORMALISED TO ONE IN THE LEC6-226
     1ZERO INTEGRAL OF THE TOTAL FORM-FACTOR MULTIPLIED BY R**,I2)      LEC6-227
 1011 FORMAT (40H THIS TERM IS NOT THE LAST AND ONLY TERM)              LEC6-228
 1012 FORMAT (20H DERIVATIVE OF ORDER,I2/18H VOLUME   STRENGTH,D15.6,8H LEC6-229
     1 RADIUS,D15.6,21H  SURFACE DIFFUSENESS,D15.6/18H SURFACE  STRENGTHLEC6-230
     2,D15.6,8H  RADIUS,D15.6,21H  SURFACE DIFFUSENESS,D15.6,18H TO THE LEC6-231
     3POWER (1.+,D15.6,2H ))                                            LEC6-232
 1013 FORMAT (49H THE FORM-FACTOR READ IN BY POINT IDENTIFIED WITH,I4,39LEC6-233
     1H WILL NOT BE READ. NUMBER PROVIDED FOR:,I4,13H ... STOP ...)     LEC6-234
 1014 FORMAT (5X,I5,41HTH FORM-FACTOR READ IN BY POINT  STRENGTH,D15.6) LEC6-235
 1015 FORMAT (2X,I3,26H FORM-FACTORS READ IN WITH,I4,11H POINTS AND,I4, LEC6-236
     118H FORM-FACTORS USED)                                            LEC6-237
 1016 FORMAT (6F10.5)                                                   LEC6-238
 1017 FORMAT (/30H FORM-FACTORS READ IN BY POINT/5X,3HR =)              LEC6-239
 1018 FORMAT (2X,I3,1P,D11.3,8D14.6/(16X,1P,8D14.6))                    LEC6-240
 1019 FORMAT (22H FOR THE CONFIGURATION,I4,31H SINGLE PARTICLE WAVE FUNCLEC6-241
     1TIONS,I3,4H AND,I3,34H ARE NOT BOTH PROTONS NOR NEUTRONS)         LEC6-242
 1020 FORMAT (48H ANGULAR MOMENTA OF THE PARTICLE AND HOLE STATES:,2I4,3LEC6-243
     11H NOT COMPATIBLE WITH THE PARITY,I3,19H OF THE EXCITATION.)      LEC6-244
 1021 FORMAT (48H ANGULAR MOMENTA OF THE PARTICLE AND HOLE STATES:,4I4,1LEC6-245
     18H TOO SMALL FOR J =,I3)                                          LEC6-246
 1022 FORMAT (48H ANGULAR MOMENTA OF THE PARTICLE AND HOLE STATES:,4I4,1LEC6-247
     18H TOO LARGE FOR J =,I3)                                          LEC6-248
 1023 FORMAT (24H  **** STOP IN LEC6 ****)                              LEC6-249
      END                                                               LEC6-250
