C 11/12/99                                                      DWBA98  DIRZ-000
      SUBROUTINE DIRZ(V,NV,VS,INM)                                      DIRZ-001
C INITIALISATION OF THE FORM-FACTORS FOR THE DIRECT TERM.               DIRZ-002
C INPUTS:    V(I),NV(I)  EQUIVALENCED BY CALL ( SEE LEC6) .             DIRZ-003
C            INM   NUMBER OF POINTS.                                    DIRZ-004
C DATA PASSED OVER BY THE COMMON /NOMBR/                                DIRZ-005
C         H   INTEGRATION STEP.                                         DIRZ-006
C         J   MOMENTUM TRANSFER.                                        DIRZ-007
C         LO  LOGICAL CONTROLS: LO(20)=.TRUE.  NATURAL PARITY.          DIRZ-008
C                      LO(26)=.TRUE. MACROSCOPIC POTENTIAL.             DIRZ-009
C                      LO(28)=.TRUE. INDEPENDENT SPIN-ORBIT.            DIRZ-010
C RESULTS:    VS(INM,I)   R FOR I=1.                                    DIRZ-011
C                         R**2 FOR I=2.                                 DIRZ-012
C             MACROSCOPIC POTENTIALS OR PUT TO  0 FOR I=39,52.          DIRZ-013
C IN THE COMMON /NOMBR/ CCO(5) LAST VALUE OF THE COULOMB FORM-FACTOR.   DIRZ-014
C***********************************************************************DIRZ-015
      IMPLICIT REAL*8 (A-H,O-Z)                                         DIRZ-016
      LOGICAL LO,LOO(3)                                                 DIRZ-017
      DIMENSION V(1),NV(9),VS(INM,3),VR(6,2),SE(2),SEP(2),SET(2),AP(2)  DIRZ-018
      COMMON /NOMBR/ H,CCO(5),JMAX,KV,KR,KS,NBCONF,NBPROT,J,KY,ILL(3,4),DIRZ-019
     1LO(40)                                                            DIRZ-020
C INITIALISATION                                                        DIRZ-021
      CCO(5)=0.D0                                                       DIRZ-022
      DO 3 I=1,INM                                                      DIRZ-023
      DO 1 M=3,42                                                       DIRZ-024
    1 VS(I,M)=0.D0                                                      DIRZ-025
      VS(I,1)=H*I                                                       DIRZ-026
      VS(I,2)=VS(I,1)**2                                                DIRZ-027
    3 CONTINUE                                                          DIRZ-028
      IF (.NOT.LO(26)) RETURN                                           DIRZ-029
C MACROSCOPIC FORM-FACTORS                                              DIRZ-030
      IT=NV(1)                                                          DIRZ-031
      ITT=IT                                                            DIRZ-032
      DO 48 II=5,ITT                                                    DIRZ-033
      K3=NV(II)                                                         DIRZ-034
      IF (K3.EQ.0) GO TO 48                                             DIRZ-035
      LOO(3)=II.GT.9.AND.(.NOT.LO(28))                                  DIRZ-036
      IJ=II-4                                                           DIRZ-037
      JV=IT+1                                                           DIRZ-038
      IT=IT+K3                                                          DIRZ-039
      JT=IT                                                             DIRZ-040
      LP=43                                                             DIRZ-041
      IF (II.LT.9) LP=II-2                                              DIRZ-042
      DO 39 L=JV,JT                                                     DIRZ-043
      LX=46                                                             DIRZ-044
      IF (L.EQ.JV) LX=LP                                                DIRZ-045
      K1=NV(L)                                                          DIRZ-046
      K2=IABS(K1)                                                       DIRZ-047
      IF (K2.LT.100) GO TO 8                                            DIRZ-048
C INTERPOLATION OVER THE FORM-FACTOR GIVEN POINT BY POINT               DIRZ-049
      IT=(IT+1)/2+1                                                     DIRZ-050
      AT=V(IT)                                                          DIRZ-051
      IT=2*IT-1                                                         DIRZ-052
      IR=NV(2)+1                                                        DIRZ-053
      ID=NV(2)+NV(3)-3                                                  DIRZ-054
      IE=NV(3)*(K2-100)                                                 DIRZ-055
      DO 6 IS=1,INM                                                     DIRZ-056
    4 IF (VS(IS,1).LT.V(IR+2)) GO TO 5                                  DIRZ-057
      IF (IR.GE.ID) GO TO 5                                             DIRZ-058
      IR=IR+1                                                           DIRZ-059
      GO TO 4                                                           DIRZ-060
    5 X1=(VS(IS,1)-V(IR+1))*(VS(IS,1)-V(IR+2))*(VS(IS,1)-V(IR+3))/((V(IRDIRZ-061
     1)-V(IR+1))*(V(IR)-V(IR+2))*(V(IR)-V(IR+3)))                       DIRZ-062
      X2=(VS(IS,1)-V(IR))*(VS(IS,1)-V(IR+2))*(VS(IS,1)-V(IR+3))/((V(IR+1DIRZ-063
     1)-V(IR))*(V(IR+1)-V(IR+2))*(V(IR+1)-V(IR+3)))                     DIRZ-064
      X3=(VS(IS,1)-V(IR))*(VS(IS,1)-V(IR+1))*(VS(IS,1)-V(IR+3))/((V(IR+2DIRZ-065
     1)-V(IR))*(V(IR+2)-V(IR+1))*(V(IR+2)-V(IR+3)))                     DIRZ-066
      X4=(VS(IS,1)-V(IR))*(VS(IS,1)-V(IR+1))*(VS(IS,1)-V(IR+2))/((V(IR+3DIRZ-067
     1)-V(IR))*(V(IR+3)-V(IR+1))*(V(IR+3)-V(IR+2)))                     DIRZ-068
    6 VS(IS,LX)=(X1*V(IE+IR)+X2*V(IE+IR+1)+X3*V(IE+IR+2)+X4*V(IE+IR+3))*DIRZ-069
     1AT                                                                DIRZ-070
      IF (.NOT.LOO(3)) GO TO 34                                         DIRZ-071
      CALL DERI(VS(1,LX),VS(1,LX+1),INM)                                DIRZ-072
      DO 7 IS=1,INM                                                     DIRZ-073
      VS(IS,LX)=VS(IS,LX)/VS(IS,2)                                      DIRZ-074
    7 VS(IS,LX+1)=VS(IS,LX+1)/VS(IS,1)/H                                DIRZ-075
      GO TO 34                                                          DIRZ-076
    8 IF (II.EQ.9.AND.V(IT+3).EQ.0.) GO TO 28                           DIRZ-077
      K21=K2                                                            DIRZ-078
      IF (LOO(3)) K21=K21+1                                             DIRZ-079
C WOOD-SAXON AND DERIVATIVES TO CERTAIN POWERS                          DIRZ-080
      DO 10 I=1,2                                                       DIRZ-081
      LOO(I)=V(IT+3*I-2).EQ.0.                                          DIRZ-082
      IF (LOO(I)) GO TO 10                                              DIRZ-083
      SE(I)=0.D0                                                        DIRZ-084
      SET(I)=-V(IT+3*I-1)                                               DIRZ-085
      IF (V(IT+3*I).GT.0.02D0*H) GO TO 9                                DIRZ-086
      WRITE (6,1000) V(IT+3*I),IJ,I                                     DIRZ-087
      V(IT+3*I)=DMAX1(-V(IT+3*I),0.02D0*H)                              DIRZ-088
    9 SEP(I)=DEXP(H/V(IT+3*I))                                          DIRZ-089
      AP(I)=V(IT+3*I-2)                                                 DIRZ-090
      IF (K2.GT.1) AP(I)=AP(I)*V(IT+3*I-1)*0.282095D0/DSQRT(2.D0*J+1.D0)DIRZ-091
      IF (K2.GT.2) AP(I)=AP(I)*V(IT+3*I-1)*0.5D0                        DIRZ-092
      IF (K2.GT.3) AP(I)=AP(I)*V(IT+3*I-1)*0.3333333333D0               DIRZ-093
   10 CONTINUE                                                          DIRZ-094
      IF (V(IT+7).GT.-1.D0) GO TO 11                                    DIRZ-095
      WRITE (6,1001) V(IT+7),IJ                                         DIRZ-096
      V(IT+7)=-.8D0                                                     DIRZ-097
   11 A1=V(IT+7)                                                        DIRZ-098
      A3=0.D0                                                           DIRZ-099
      DO 25 IS=1,INM                                                    DIRZ-100
      DO 14 I=1,2                                                       DIRZ-101
      IF (LOO(I)) GO TO 14                                              DIRZ-102
      IF (SE(I).NE.0.D0) GO TO 12                                       DIRZ-103
      SET(I)=SET(I)+H                                                   DIRZ-104
      IF (SET(I)+50.D0*V(IT+3*I).LT.0.D0) GO TO 13                      DIRZ-105
      SE(I)=EXP(SET(I)/V(IT+3*I))                                       DIRZ-106
      SET(I)=SEP(I)                                                     DIRZ-107
      GO TO 13                                                          DIRZ-108
   12 IF (SE(I).LT.1.D15) SE(I)=SE(I)*SET(I)                            DIRZ-109
   13 VR(1,I)=1.D0/(1.D0+SE(I))                                         DIRZ-110
      IF (I+K21.EQ.2) GO TO 14                                          DIRZ-111
      VR(6,I)=VR(1,I)/V(IT+3*I)                                         DIRZ-112
      VR(2,I)=VR(1,I)*VR(6,I)*SE(I)                                     DIRZ-113
      IF (I+K21.EQ.3) GO TO 14                                          DIRZ-114
      VR(3,I)=VR(2,I)*VR(6,I)*(SE(I)-1.D0)                              DIRZ-115
      IF (I+K21.EQ.4) GO TO 14                                          DIRZ-116
      VR(4,I)=VR(2,I)*(SE(I)**2-4.D0*SE(I)+1.D0)*VR(6,I)*VR(6,I)        DIRZ-117
      IF (I+K21.EQ.5) GO TO 14                                          DIRZ-118
      VR(5,I)=VR(3,I)*(SE(I)**2-10.D0*SE(I)+1.D0)*VR(6,I)*VR(6,I)       DIRZ-119
      IF (I+K21.EQ.6) GO TO 14                                          DIRZ-120
      A2=SE(I)**2                                                       DIRZ-121
      VR(6,I)=VR(2,I)*(SE(I)**2+1.D0/SE(I)**2-26.D0*(SE(I)+1.D0/SE(I))+6DIRZ-122
     16.D0)*VR(6,I)**4*A2                                               DIRZ-123
   14 CONTINUE                                                          DIRZ-124
      IF (LOO(2)) GO TO 16                                              DIRZ-125
      DO 15 I=1,K21                                                     DIRZ-126
   15 VR(I,2)=VR(I+1,2)*4.D0*V(IT+6)                                    DIRZ-127
   16 IF (A1.EQ.0.D0) GO TO 23                                          DIRZ-128
      DO 22 I=1,2                                                       DIRZ-129
      IF (LOO(I)) GO TO 22                                              DIRZ-130
      GO TO ( 21 , 20 , 19 , 18 , 17 ),K21                              DIRZ-131
   17 VR(5,I)=(A1+1.D0)*(A1*(A1-1.D0)*((A1-2.D0)*VR(2,I)**2+4.D0*VR(1,I)DIRZ-132
     1*VR(3,I))*VR(2,I)**2+A1*VR(I,1)**2*(3.D0*VR(3,I)**2+4.D0*VR(1,I)*VDIRZ-133
     2R(4,I))+VR(1,I)**3*VR(5,I))*VR(1,I)**(A1-3.D0)                    DIRZ-134
   18 VR(4,I)=(A1+1.D0)*(A1*((A1-1.D0)*VR(2,I)**2+3.D0*VR(1,I)*VR(3,I))*DIRZ-135
     1VR(2,I)+VR(1,I)**2*VR(4,I))*VR(1,I)**(A1-2.D0)                    DIRZ-136
      IF (K2.EQ.4) GO TO 22                                             DIRZ-137
   19 VR(3,I)=(A1+1.D0)*(A1*VR(2,I)**2+VR(3,I)*VR(1,I))*VR(1,I)**(A1-1.DDIRZ-138
     10)                                                                DIRZ-139
      IF (K2.EQ.3) GO TO 22                                             DIRZ-140
   20 VR(2,I)=(A1+1.D0)*VR(1,I)**A1*VR(2,I)                             DIRZ-141
   21 VR(1,I)=VR(1,I)**(A1+1.D0)                                        DIRZ-142
   22 CONTINUE                                                          DIRZ-143
   23 VS(IS,LX)=0.D0                                                    DIRZ-144
      IF (.NOT.LOO(1)) VS(IS,LX)=-AP(1)*VR(K21,1)                       DIRZ-145
      IF (.NOT.LOO(2)) VS(IS,LX)=VS(IS,LX)-AP(2)*VR(K21,2)              DIRZ-146
      IF (II.EQ.9) GO TO 24                                             DIRZ-147
      IF (.NOT.LOO(3)) GO TO 25                                         DIRZ-148
      VS(IS,LX+1)=2.D0*VS(IS,LX)/VS(IS,1)                               DIRZ-149
      VS(IS,LX)=0.D0                                                    DIRZ-150
      IF (.NOT.LOO(1)) VS(IS,LX)=AP(1)*VR(K2,1)                         DIRZ-151
      IF (.NOT.LOO(2)) VS(IS,LX)=VS(IS,LX)+AP(2)*VR(K2,2)               DIRZ-152
      VS(IS,LX+1)=2.D0*VS(IS,LX+1)/VS(IS,2)                             DIRZ-153
      GO TO 25                                                          DIRZ-154
   24 IF (.NOT.LOO(1)) A3=A3-V(IT+1)*VR(1,1)*VS(IS,1)**2                DIRZ-155
      IF (.NOT.LOO(2)) A3=A3-V(IT+4)*VR(1,2)*VS(IS,1)**2                DIRZ-156
   25 CONTINUE                                                          DIRZ-157
      IF (II.NE.9) GO TO 33                                             DIRZ-158
C COULOMB POTENTIAL FOR A NON-UNIFORM CHARGE DENSITY                    DIRZ-159
      C=2*J+1                                                           DIRZ-160
      ZZ=1.43997595D0*V(IT+1)/A3/C                                      DIRZ-161
      C=C*H/12.D0                                                       DIRZ-162
      VS(INM,LX)=0.D0                                                   DIRZ-163
      VS(1,LX+1)=VS(1,LX+1)*VS(1,LX)                                    DIRZ-164
      VS(INM,LX+2)=0.D0                                                 DIRZ-165
      DO 26 IS=2,INM                                                    DIRZ-166
      JS=INM+1-IS                                                       DIRZ-167
      VS(IS,LX+1)=VS(IS-1,LX+1)+VS(IS,1)**(J+1)*VS(IS,LX)               DIRZ-168
   26 VS(JS,LX+2)=VS(JS+1,LX+2)+VS(JS+1,LX)/VS(JS+1,1)**(J-1)           DIRZ-169
      DO 27 IS=1,INM                                                    DIRZ-170
   27 VS(IS,LX)=(VS(IS,LX+1)/VS(IS,1)**(J+1)+VS(IS,LX+2)*VS(IS,1)**J+C*VDIRZ-171
     1S(IS,LX))*ZZ                                                      DIRZ-172
      GO TO 33                                                          DIRZ-173
C COULOMB POTENTIAL FOR A UNIFORMLY CHARGED SPHERE                      DIRZ-174
   28 A3=1.43997595D0*V(IT+1)*0.282095D0*A3*V(IT+2)                     DIRZ-175
      IF (K2.GT.2) A3=0.5D0*A3*V(IT+2)                                  DIRZ-176
      IF (K2.EQ.4) A3=0.3333333333D0*A3*V(IT+2)                         DIRZ-177
      DO 32 IS=1,INM                                                    DIRZ-178
      IF (J.NE.0) GO TO 29                                              DIRZ-179
      A1=0.D0                                                           DIRZ-180
      GO TO 32                                                          DIRZ-181
   29 A4=DMIN1(VS(IS,1),V(IT+2))                                        DIRZ-182
      A5=VS(IS,1)+V(IT+2)-A4                                            DIRZ-183
      A5=1.D0/A5                                                        DIRZ-184
      A4=A4*A5                                                          DIRZ-185
      A1=3.D0*A3/V(IT+2)/(2.D0*J+1.D0)*A5*A4**J                         DIRZ-186
      IF (K2.EQ.2) GO TO 32                                             DIRZ-187
      IF (VS(IS,1).LT.V(IT+2)) GO TO 30                                 DIRZ-188
      A2=J+2                                                            DIRZ-189
      GO TO 31                                                          DIRZ-190
   30 A2=1-J                                                            DIRZ-191
   31 A1=A1*A2/V(IT+2)                                                  DIRZ-192
      IF (K2.NE.3) A1=A1*(A2-1.D0)/V(IT+2)                              DIRZ-193
   32 VS(IS,LX)=A1                                                      DIRZ-194
   33 IT=IT+7                                                           DIRZ-195
   34 IF (L.EQ.JV) GO TO 39                                             DIRZ-196
      AX=1.D0                                                           DIRZ-197
      IF (K2.EQ.K1) GO TO 36                                            DIRZ-198
C FORM-FACTORS WITH ZERO INTEGRAL                                       DIRZ-199
      JX=J+2                                                            DIRZ-200
      IF (LOO(3)) JX=JX+2                                               DIRZ-201
      A1=0.D0                                                           DIRZ-202
      A2=0.D0                                                           DIRZ-203
      DO 35 IS=1,INM                                                    DIRZ-204
      A1=A1+VS(IS,LP)*VS(IS,1)**JX                                      DIRZ-205
   35 A2=A2+VS(IS,LX)*VS(IS,1)**JX                                      DIRZ-206
      IF (A2.NE.0.) AX=-A1/A2                                           DIRZ-207
   36 DO 37 IS=1,INM                                                    DIRZ-208
   37 VS(IS,LP)=VS(IS,LP)+AX*VS(IS,LX)                                  DIRZ-209
      IF (.NOT.LOO(3)) GO TO 39                                         DIRZ-210
      DO 38 IS=1,INM                                                    DIRZ-211
   38 VS(IS,LP+1)=VS(IS,LP+1)+AX*VS(IS,LX+1)                            DIRZ-212
   39 CONTINUE                                                          DIRZ-213
C PUT THE RESULTS INTO PLACE                                            DIRZ-214
      IF (II-9) 48 , 40 , 42                                            DIRZ-215
   40 CCO(5)=VS(INM,LP)                                                 DIRZ-216
      DO 41 IS=1,INM                                                    DIRZ-217
   41 VS(IS,3)=VS(IS,3)+VS(IS,LP)                                       DIRZ-218
      GO TO 48                                                          DIRZ-219
   42 IF (LOO(3)) GO TO 46                                              DIRZ-220
      IF (II.GE.16) GO TO 44                                            DIRZ-221
      DO 43 IS=1,INM                                                    DIRZ-222
   43 VS(IS,II-3)=VS(IS,LP)                                             DIRZ-223
      GO TO 48                                                          DIRZ-224
   44 DO 45 IS=1,INM                                                    DIRZ-225
   45 VS(IS,II+11)=VS(IS,LP)/H                                          DIRZ-226
      GO TO 48                                                          DIRZ-227
C FORM- FACTORS OF NON-INDEPENDENT SPIN-ORBIT                           DIRZ-228
   46 L1=3+MOD(II,2)                                                    DIRZ-229
      A1=(J*(J+1))/2                                                    DIRZ-230
      A2=1.D0                                                           DIRZ-231
      IF (LO(20)) A2=-1.D0                                              DIRZ-232
C ALL PARITIES            A(R)+J*(J+1)/2*V/R**2 -1/R D/DR               DIRZ-233
C                         A1(R)-J*(J+1)/2*V/R**2                        DIRZ-234
C NON-NATURAL PARITY      B(R)+RAC(J*(J+1))/2*(V/R**2+1/R*D/DR)         DIRZ-235
C NATURAL PARITY          B(R)+RAC(J*(J+1))/2*(-V/R**2+1/R*D/DR)        DIRZ-236
C                         B2(R)+RAC(J*(J+1))/2*V/R**2                   DIRZ-237
C                         B3(R)+RAC(J*(J+1))*H*V/R                      DIRZ-238
      DO 47 IS=1,INM                                                    DIRZ-239
      VS(IS,L1)=VS(IS,L1)+A1*VS(IS,LP)-VS(IS,LP+1)                      DIRZ-240
      VS(IS,L1+2)=VS(IS,L1+2)+.5D0*(A2*VS(IS,LP)+VS(IS,LP+1))           DIRZ-241
      IF (.NOT.LO(20)) GO TO 47                                         DIRZ-242
      VS(IS,L1+8)=A1*VS(IS,LP)                                          DIRZ-243
      VS(IS,L1+12)=VS(IS,LP)*H*VS(IS,1)                                 DIRZ-244
   47 VS(IS,L1+4)=VS(IS,L1+4)-A1*VS(IS,LP)                              DIRZ-245
   48 CONTINUE                                                          DIRZ-246
      RETURN                                                            DIRZ-247
 1000 FORMAT (22H SURFACE DIFFUSENESS =,D15.8,67H TOO SMALL CHANGED TO IDIRZ-248
     1TS MINIMUM VALUE IN DIRZ FOR THE FORM-FACTOR,I3,9H  AND I =,I2)   DIRZ-249
 1001 FORMAT (9H POWER 1+,D15.6,36H  CHANGED TO .2 FOR THE FORM-FACTOR ,DIRZ-250
     1I4)                                                               DIRZ-251
      END                                                               DIRZ-252
