C 11/12/99                                                      DWBA98  DIRA-000
      SUBROUTINE DIRA(AM,VS,PH,FO,INM,SOM,NSOM,FAC,NFA,NQUA,NCHE,AX,KTF,DIRA-001
     1CMU,CVF,VX,F,JM1,WF,JM2,CC,LX1)                                   DIRA-002
C CALCULATE THE DIRECT TERM                                             DIRA-003
C DATA PASSED OVER BY ARGUMENT:                                         DIRA-004
C  AM(INM,18,I)  TABLES OF MULTIPOLES.                                  DIRA-005
C  VS(INM,I)    R FOR I=1, R**2 FOR I=2.                                DIRA-006
C  PH(INM,I)    WAVE FUNCTIONS, ORDERED WITH RESPECT TO INCREASING J.   DIRA-007
C               REAL PART THEN IMAGINARY PART, ANGULAR MOMENTUM L=J-1/2 DIRA-008
C               THEN J=L+1/2, ENTRANCE CHANNEL THEN EXIT CHANNEL.       DIRA-009
C  FO(INM,I)    SINGLE PARTICLE FUNCTIONS.                              DIRA-010
C  INM          NUMBER OF INTEGRATION POINTS.                           DIRA-011
C  NSOM         DIMENSION OF SOM, EQUAL TO 2*J+1.                       DIRA-012
C  FAC(I)       TABLE OF THE LOGARITHMS OF FACTORIALS.                  DIRA-013
C  NFAC         LENGTH OF THE TABLE FAC.                                DIRA-014
C  NQUA(3,I)    TABLE OF THE QUANTUM NUMBERS OF THE SINGLE PARTICLE     DIRA-015
C               STATES.                                                 DIRA-016
C  NCHE(2,I),AX(2,I)  EQUIVALENCED BY CALL, TABLE OF CONFIGURATIONS     DIRA-017
C               CONTAINING THE SPECIFICATION OF THE PARTICLE, THE HOLE  DIRA-018
C               AND THE COEFFICIENTS X AND Y.                           DIRA-019
C  KTF,CMU,CVF  INTERACTION (SEE LEC2).                                 DIRA-020
C  VX(INM,I)    RADIAL DEPENDENCE OF THE INTERACTIONS.                  DIRA-021
C  F(JM1,4,I)   COULOMB FUNCTION OF THE INITIAL STATE FOR I=1, THE FINALDIRA-022
C               FOR I=2 AND FINITE INTEGRALS FOR I=3.                   DIRA-023
C  WF(JM2,I)    COULOMB PHASE SHIFTS FOR THE INITIAL STATE FOR I=1,     DIRA-024
C               THE FINAL STATE FOR I=2 AND INTEGRALS FOR I=3.          DIRA-025
C  CC(I,J)      NUCLEAR PHASE SHIFTS FOR THE INITIAL STATE FOR I=1,2    DIRA-026
C               AND THE FINAL STATE FOR I=3,4.                          DIRA-027
C  JM1          STARTING DIMENSION OF FF, EQUAL TO JMAX+4.              DIRA-028
C  JM2          STARTING DIMENSION OF WF, EQUAL TO JMAX1+4.             DIRA-029
C  LX1          LAST COULOMB FUNCTION THAT CAN BE USED.                 DIRA-030
C DATA PASSED OVER BY COMMON /NOMBR/:                                   DIRA-031
C  H            INTEGRATION STEP.                                       DIRA-032
C  CCO(I)       COULOMB INTERACTION FOR I=1,4.                          DIRA-033
C  JMAX         NUMBER OF PARTIAL WAVES.                                DIRA-034
C  NBCONF       NUMBER OF CONFIGURATIONS.                               DIRA-035
C  J            SPIN TRANSFER ( DIRECT ).                               DIRA-036
C  LO LOGICAL CONTROLS: LO(14)=.TRUE. NO PRINTOUT OF FORM FACTORS.      DIRA-037
C                       LO(20)=.TRUE. NATURAL PARITY EXCITATION.        DIRA-038
C                       LO(21)=.TRUE. NO COULOMB CORRECTIONS.           DIRA-039
C                       LO(23)=.TRUE. ZERO RANGE INTERACTION.           DIRA-040
C                       LO(24)=.TRUE. NO COMPLEX INTERACTION.           DIRA-041
C                       LO(31)=.TRUE. NATURAL PARITY.                   DIRA-042
C DATA PASSED OVER BY COMMON /GABJ/:                                    DIRA-043
C  JX           EXCHANGE SPIN TRANSFER.                                 DIRA-044
C  AA,AB        HELICITY FORMALISM ALPHA COEFFICIENTS MULTIPLIED BY     DIRA-045
C               SQRT(JX*(JX+1)) WITH RESPECT TO PREVIOUS PUBLICATIONS.  DIRA-046
C STORAGE IN THE COMMON /GARDE/ IN DOUBLE PRECISION                     DIRA-047
C  SK           WAVE NUMBERS.                                           DIRA-048
C  ETA          COULOMB PARAMETERS.                                     DIRA-049
C COULOMB WAVES, REDUCED MASSES, COULOMB PHASE SHIFTS FOR  L=0.         DIRA-050
C RESULTS:    SOM(4,NSOM,I)  DIRECT AMPLITUDE .                         DIRA-051
C             CCO(5)    TAIL END OF THE COULOMB FORM-FACTOR.            DIRA-052
C WORKING AREA: VS(INM,I) FOR I=3 TO 38.                                DIRA-053
C***********************************************************************DIRA-054
      IMPLICIT REAL*8 (A-H,O-Z)                                         DIRA-055
      LOGICAL LO,LOO                                                    DIRA-056
      DIMENSION VS(INM,68),AM(INM,18,1),AX(2,1),NCHE(2,1),NQUA(3,1),KTF(DIRA-057
     17,7,1),FO(INM,1),PH(INM,1),VX(INM,1),CMU(1),CVF(7,6,1),FAC(1),SOM(DIRA-058
     24,NSOM,1),F(JM1,4,3),WF(JM2,3),CC(4,1),B(4),C(4),D(5)             DIRA-059
      COMMON /NOMBR/ H,CCO(5),JMAX,KV,KR,KS,NBCONF,NBPROT,J,KY,ILL(3,4),DIRA-060
     1LO(40)                                                            DIRA-061
      COMMON /GABJ/ AA,AB,AJ,BJ,CJ,DJ,XG(11),JX                         DIRA-062
      COMMON /GARDE/ ECM(2),SK(2),ETA(2),AMRED(2),SGL(2)                DIRA-063
      I=2                                                               DIRA-064
      IF (LO(20)) I=1                                                   DIRA-065
      NC1=ILL(1,I)                                                      DIRA-066
      NC2=ILL(2,I)                                                      DIRA-067
      NC3=ILL(3,I)                                                      DIRA-068
      NC=NC1-1                                                          DIRA-069
      LO(31)=LO(20)                                                     DIRA-070
      JX=J                                                              DIRA-071
      CALL MULT(AM,INM,CMU,-1)                                          DIRA-072
C LOOP OVER THE CONFIGURATIONS                                          DIRA-073
      DO 6 K=1,NBCONF                                                   DIRA-074
      DO 5 M=1,2                                                        DIRA-075
      IF (AX(M,K).EQ.0.) GO TO 5                                        DIRA-076
      NPAR=NCHE(M,K)                                                    DIRA-077
      NTRO=NCHE(-M+3,K)                                                 DIRA-078
      AK=NQUA(3,NPAR)*NQUA(3,NTRO)                                      DIRA-079
      IF (LO(20)) AK=-AK                                                DIRA-080
      IJP=2*NQUA(2,NPAR)+NQUA(3,NPAR)                                   DIRA-081
      IJT=2*NQUA(2,NTRO)+NQUA(3,NTRO)                                   DIRA-082
C CALCULATE THE GEOMETRY                                                DIRA-083
      G=DCGS(2*JX,IJT,IJP,FAC,NFA)*AX(M,K)                              DIRA-084
      IF (G.EQ.0.) GO TO 5                                              DIRA-085
      NT=1                                                              DIRA-086
      IF (NTRO.GT.NBPROT) NT=2                                          DIRA-087
      AP=(IJP+1)/2                                                      DIRA-088
      AT=(IJT+1)/2                                                      DIRA-089
      AJT=NQUA(3,NTRO)                                                  DIRA-090
      AB=AJT*(AT-AK*AP)                                                 DIRA-091
      AA=AJT*(AT+AK*AP)                                                 DIRA-092
      CALL GEOM                                                         DIRA-093
      DO 1 I=1,INM                                                      DIRA-094
      VS(I,43)=FO(I,NPAR)*FO(I,NTRO)                                    DIRA-095
    1 VS(I,44)=0.D0                                                     DIRA-096
      IF (NC2.EQ.0) GO TO 4                                             DIRA-097
      CALL DERI(FO(1,NTRO),VS(1,45),INM)                                DIRA-098
      DO 2 I=1,INM                                                      DIRA-099
      VS(I,45)=VS(I,45)*FO(I,NPAR)                                      DIRA-100
    2 VS(I,46)=0.D0                                                     DIRA-101
      IF (NC3.EQ.0) GO TO 4                                             DIRA-102
      CALL DER2(FO(1,NTRO),VS(1,47),INM)                                DIRA-103
      DO 3 I=1,INM                                                      DIRA-104
      VS(I,47)=VS(I,47)*FO(I,NPAR)                                      DIRA-105
    3 VS(I,48)=0.D0                                                     DIRA-106
    4 IF (LO(31)) CALL PTIP(KTF,CMU,CVF,VX,AM,VS,VS(1,3),VS(1,43),INM,NTDIRA-107
     1,G)                                                               DIRA-108
      IF (.NOT.LO(31)) CALL PTII(KTF,CMU,CVF,VX,AM,VS,VS(1,3),VS(1,43),IDIRA-109
     1NM,NT,G)                                                          DIRA-110
      IF (LO(23)) CALL PTI0(KTF(1,1,KS+1),CVF(1,1,KS+1),VX,VS,VS(1,3),VSDIRA-111
     1(1,43),FO(1,NPAR),FO(1,NTRO),INM,NT,G)                            DIRA-112
    5 CONTINUE                                                          DIRA-113
    6 CONTINUE                                                          DIRA-114
C PRINT OUT OF THE FORM-FACTORS                                         DIRA-115
      IF (LO(14)) GO TO 12                                              DIRA-116
      K2=2                                                              DIRA-117
      KI=0                                                              DIRA-118
      K3=2+2*NC1                                                        DIRA-119
    7 KI=KI+1                                                           DIRA-120
      K1=K2+1                                                           DIRA-121
      WRITE (6,1000) KI                                                 DIRA-122
      K2=MIN0(K1+7,K3)                                                  DIRA-123
      DO 8 I=1,INM                                                      DIRA-124
    8 WRITE (6,1001) I,VS(I,1),(VS(I,K),K=K1,K2)                        DIRA-125
      IF (K2.NE.K3) GO TO 7                                             DIRA-126
      IF (NC2.EQ.0) GO TO 12                                            DIRA-127
      K2=26                                                             DIRA-128
      KI=0                                                              DIRA-129
      K3=26+2*NC2                                                       DIRA-130
    9 KI=KI+1                                                           DIRA-131
      K1=K2+1                                                           DIRA-132
      WRITE (6,1002) KI                                                 DIRA-133
      K2=MIN0(K1+7,K3)                                                  DIRA-134
      DO 10 I=1,INM                                                     DIRA-135
   10 WRITE (6,1001) I,VS(I,1),(VS(I,K),K=K1,K2)                        DIRA-136
      IF (K2.NE.K3) GO TO 9                                             DIRA-137
      IF (NC3.EQ.0) GO TO 12                                            DIRA-138
      WRITE (6,1003)                                                    DIRA-139
      DO 11 I=1,INM                                                     DIRA-140
   11 WRITE (6,1001) I,VS(I,1),(VS(I,K),K=39,42)                        DIRA-141
   12 CALL HORA                                                         DIRA-142
      KPA=J                                                             DIRA-143
      IF (LO(20)) KPA=J+1                                               DIRA-144
      AT=0.D0                                                           DIRA-145
      JMAX1=JM2-4                                                       DIRA-146
      IF (LO(21)) GO TO 13                                              DIRA-147
C CONSTANTS FOR THE  COULOMB CORRECTIONS                                DIRA-148
      B1=H*INM                                                          DIRA-149
      YC=1.D0/(B1*DSQRT(SK(1)*SK(2)))                                   DIRA-150
      YT=H**2*YC**J/12.D0/B1                                            DIRA-151
      XC=-(J+1)*YC+6.D0/H                                               DIRA-152
      CCC=INM*CCO(5)/YC**J                                              DIRA-153
      DD=DSQRT(ETA(1)*ETA(2))                                           DIRA-154
      MI1=-1                                                            DIRA-155
      MI2=-1                                                            DIRA-156
      MI3=-1                                                            DIRA-157
C CALCULATE THE AMPLITUDES                                              DIRA-158
C LOOP OVER THE INITIAL CHANNEL FUNCTIONS                               DIRA-159
   13 DO 42 JI=1,JMAX1                                                  DIRA-160
      AT=AT+1.D0                                                        DIRA-161
      JLIU=2*JI-1                                                       DIRA-162
      JRI=2*JLIU                                                        DIRA-163
      JRR=JRI-1                                                         DIRA-164
      JFMAX=MIN0(JI+J,JMAX1)                                            DIRA-165
      JFMIN=MAX0(JI-J,J-JI+1)                                           DIRA-166
      DO 41 KX=1,2                                                      DIRA-167
      KF=0                                                              DIRA-168
      IF (JI.GT.JMAX) GO TO 25                                          DIRA-169
C MULTIPLICATION OF THE FORM-FACTORS BY THE JI FUNCTIONS                DIRA-170
      IF (NC2.EQ.0) GO TO 14                                            DIRA-171
      CALL DERI(PH(1,JRR),VS(1,65),INM)                                 DIRA-172
      CALL DERI(PH(1,JRI),VS(1,66),INM)                                 DIRA-173
   14 IF (NC3.EQ.0) GO TO 15                                            DIRA-174
      CALL DER2(PH(1,JRR),VS(1,63),INM)                                 DIRA-175
      CALL DER2(PH(1,JRI),VS(1,64),INM)                                 DIRA-176
   15 DO 24 K=1,NC1                                                     DIRA-177
      KK=2*K-1                                                          DIRA-178
      DO 16 I=1,INM                                                     DIRA-179
      VS(I,KK+42)=VS(I,KK+2)*PH(I,JRR)                                  DIRA-180
   16 VS(I,KK+43)=VS(I,KK+2)*PH(I,JRI)                                  DIRA-181
      IF (LO(24)) GO TO 18                                              DIRA-182
      DO 17 I=1,INM                                                     DIRA-183
      VS(I,KK+42)=VS(I,KK+42)-VS(I,KK+3)*PH(I,JRI)                      DIRA-184
   17 VS(I,KK+43)=VS(I,KK+43)+VS(I,KK+3)*PH(I,JRR)                      DIRA-185
   18 IF (K.GT.NC2) GO TO 21                                            DIRA-186
      DO 19 I=1,INM                                                     DIRA-187
      VS(I,KK+42)=VS(I,KK+42)+VS(I,KK+26)*VS(I,65)                      DIRA-188
   19 VS(I,KK+43)=VS(I,KK+43)+VS(I,KK+26)*VS(I,66)                      DIRA-189
      IF (LO(24)) GO TO 21                                              DIRA-190
      DO 20 I=1,INM                                                     DIRA-191
      VS(I,KK+42)=VS(I,KK+42)-VS(I,KK+27)*VS(I,66)                      DIRA-192
   20 VS(I,KK+43)=VS(I,KK+43)+VS(I,KK+27)*VS(I,65)                      DIRA-193
   21 IF (K.GT.NC3) GO TO 24                                            DIRA-194
      DO 22 I=1,INM                                                     DIRA-195
      VS(I,KK+42)=VS(I,KK+42)+VS(I,KK+38)*VS(I,63)                      DIRA-196
   22 VS(I,KK+43)=VS(I,KK+43)+VS(I,KK+38)*VS(I,64)                      DIRA-197
      IF (LO(24)) GO TO 24                                              DIRA-198
      DO 23 I=1,INM                                                     DIRA-199
      VS(I,KK+42)=VS(I,KK+42)-VS(I,KK+39)*VS(I,64)                      DIRA-200
   23 VS(I,KK+43)=VS(I,KK+43)+VS(I,KK+39)*VS(I,63)                      DIRA-201
   24 CONTINUE                                                          DIRA-202
C LOOP OVER THE EXIT CHANNEL FUNCTIONS                                  DIRA-203
   25 DO 40 JF=JFMIN,JFMAX                                              DIRA-204
      KF=KF+1                                                           DIRA-205
      IJP=2*JF-1                                                        DIRA-206
C CALCULATE THE GEOMETRY                                                DIRA-207
      CCX=H*DCGS(2*J,IJP,JLIU,FAC,NFA)                                  DIRA-208
      AP=JF                                                             DIRA-209
      IF (MOD(J+JI+JF,2).NE.1) AP=-AP                                   DIRA-210
      AA=(AT+AP)*(2*MOD(KX,2)-1)                                        DIRA-211
      AB=(AT-AP)*(2*MOD(KX,2)-1)                                        DIRA-212
      CALL GEOM                                                         DIRA-213
      KPB=1-2*MOD(JI+JF+KPA,2)                                          DIRA-214
      KI=(KPB+1)/2                                                      DIRA-215
      JLF=IJP+KI                                                        DIRA-216
      IF (KX.EQ.2) JLF=IJP+1-KI                                         DIRA-217
      JTI=4*JMAX+2*JLF                                                  DIRA-218
      JTR=JTI-1                                                         DIRA-219
      IF (KPB.GT.0) CCX=-CCX                                            DIRA-220
      GR=0.D0                                                           DIRA-221
      GI=0.D0                                                           DIRA-222
      IF (LO(21)) GO TO 32                                              DIRA-223
      NLO=0                                                             DIRA-224
      LOO=(JF.GT.JMAX).OR.(JI.GT.JMAX)                                  DIRA-225
      IF (LOO) NLO=1                                                    DIRA-226
C CALCULATE THE COULOMB CORRECTIONS                                     DIRA-227
      L1=(JLIU+KX-1)/2                                                  DIRA-228
      L2=JLF/2                                                          DIRA-229
      IF (L1.EQ.MI1.AND.L2.EQ.MI2.AND.MI3.LE.NLO) GO TO 29              DIRA-230
      MI1=L1                                                            DIRA-231
      MI2=L2                                                            DIRA-232
      MI3=NLO                                                           DIRA-233
      LI=MIN0(L1,L2)                                                    DIRA-234
      LF=MAX0(L1,L2)                                                    DIRA-235
      NI=1                                                              DIRA-236
      IF (LI.EQ.L2) NI=2                                                DIRA-237
      CALL CORA(LI,B,C,DD,ETA(NI),ETA(3-NI),YC,J,LF-LI,LOO)             DIRA-238
      L3=(L1+L2-J)/2                                                    DIRA-239
      IF (LOO) GO TO 28                                                 DIRA-240
      IF (MAX0(L3+4,LF+2).GT.LX1) GO TO 43                              DIRA-241
      IF (LI.NE.L2) GO TO 26                                            DIRA-242
      A1=C(3)                                                           DIRA-243
      C(3)=C(2)                                                         DIRA-244
      C(2)=A1                                                           DIRA-245
   26 DO 27 L=1,4                                                       DIRA-246
      M=2*((L-1)/2)+1                                                   DIRA-247
      N=2*(L-M)+1                                                       DIRA-248
   27 D(L)=B(1)*F(L3+1,L,3)+B(2)*F(L3+2,L,3)+B(3)*F(L3+3,L,3)+B(4)*F(L3+DIRA-249
     14,L,3)-C(1)*F(L1+1,N,1)*F(L2+1,M,2)-C(2)*F(L1+1,N,1)*F(L2+2,M,2)-CDIRA-250
     2(3)*F(L1+2,N,1)*F(L2+1,M,2)-C(4)*F(L1+2,N,1)*F(L2+2,M,2)          DIRA-251
C FINITE STEP CORRECTIONS                                               DIRA-252
      D(1)=D(1)-YT*(SK(1)*F(L1+1,2,1)*F(L2+1,1,2)+SK(2)*F(L1+1,1,1)*F(L2DIRA-253
     1+1,2,2)+XC*F(L1+1,1,1)*F(L2+1,1,2))                               DIRA-254
      D(2)=D(2)-YT*(SK(1)*F(L1+1,4,1)*F(L2+1,1,2)+SK(2)*F(L1+1,3,1)*F(L2DIRA-255
     1+1,2,2)+XC*F(L1+1,3,1)*F(L2+1,1,2))                               DIRA-256
      D(3)=D(3)-YT*(SK(1)*F(L1+1,2,1)*F(L2+1,3,2)+SK(2)*F(L1+1,1,1)*F(L2DIRA-257
     1+1,4,2)+XC*F(L1+1,1,1)*F(L2+1,3,2))                               DIRA-258
      D(4)=D(4)-YT*(SK(1)*F(L1+1,4,1)*F(L2+1,3,2)+SK(2)*F(L1+1,3,1)*F(L2DIRA-259
     1+1,4,2)+XC*F(L1+1,3,1)*F(L2+1,3,2))                               DIRA-260
   28 IF (L3+4.GT.JM2) GO TO 44                                         DIRA-261
C INTEGRAL FROM 0 TO INFINITY                                           DIRA-262
      D(5)=B(1)*WF(L3+1,3)+B(2)*WF(L3+2,3)+B(3)*WF(L3+3,3)+B(4)*WF(L3+4,DIRA-263
     13)                                                                DIRA-264
   29 IF (LOO) GO TO 30                                                 DIRA-265
      L1=(JLIU+KX-1)                                                    DIRA-266
      L2=JLF                                                            DIRA-267
C MULTIPLICATION BY THE NUCLEAR PHASE SHIFTS                            DIRA-268
      A4=CC(1,L1)*CC(3,L2)-CC(2,L1)*CC(4,L2)                            DIRA-269
      B4=CC(1,L1)*CC(4,L2)+CC(2,L1)*CC(3,L2)                            DIRA-270
      A3=CC(3,L2)-B4                                                    DIRA-271
      B3=CC(4,L2)+A4                                                    DIRA-272
      A2=CC(1,L1)-B4                                                    DIRA-273
      B2=CC(2,L1)+A4                                                    DIRA-274
      A1=1.D0+A4-B2-B3                                                  DIRA-275
      B1=B4+A2+A3                                                       DIRA-276
      A3=A1*D(1)+A2*D(2)+A3*D(3)+A4*D(4)                                DIRA-277
      B3=B1*D(1)+B2*D(2)+B3*D(3)+B4*D(4)                                DIRA-278
      GO TO 31                                                          DIRA-279
   30 A3=D(5)                                                           DIRA-280
      B3=0.D0                                                           DIRA-281
C MULTIPLICATION BY THE COULOMB PHASE SHIFTS                            DIRA-282
   31 L2=JLF/2+1                                                        DIRA-283
      L1=(JLIU+KX-1)/2+1                                                DIRA-284
      A1=WF(L1,1)+WF(L2,2)                                              DIRA-285
      B1=DCOS(A1)                                                       DIRA-286
      B2=DSIN(A1)                                                       DIRA-287
      A1=B1*A3-B2*B3                                                    DIRA-288
      GI=CCC*(B1*B3+B2*A3)                                              DIRA-289
      GR=CCC*A1                                                         DIRA-290
      IF (LOO) GO TO 36                                                 DIRA-291
C INTEGRATION                                                           DIRA-292
   32 DO 34 I=1,INM                                                     DIRA-293
      VS(I,67)=VS(I,43)                                                 DIRA-294
      VS(I,68)=VS(I,44)                                                 DIRA-295
      DO 33 K=1,NC                                                      DIRA-296
      VS(I,67)=VS(I,67)+VS(I,2*K+43)*XG(K)                              DIRA-297
   33 VS(I,68)=VS(I,68)+VS(I,2*K+44)*XG(K)                              DIRA-298
   34 CONTINUE                                                          DIRA-299
      DO 35 I=1,INM                                                     DIRA-300
      GR=GR+VS(I,67)*PH(I,JTR)-VS(I,68)*PH(I,JTI)                       DIRA-301
   35 GI=GI+VS(I,67)*PH(I,JTI)+VS(I,68)*PH(I,JTR)                       DIRA-302
   36 IF (KX.EQ.2) GO TO 39                                             DIRA-303
      SOM(1,KF,JI)=CCX*GR                                               DIRA-304
      SOM(2,KF,JI)=CCX*GI                                               DIRA-305
      SOM(3,KF,JI)=-CCX*GR                                              DIRA-306
      SOM(4,KF,JI)=-CCX*GI                                              DIRA-307
      GO TO 40                                                          DIRA-308
   39 SOM(1,KF,JI)=SOM(1,KF,JI)-CCX*GR                                  DIRA-309
      SOM(2,KF,JI)=SOM(2,KF,JI)-CCX*GI                                  DIRA-310
      SOM(3,KF,JI)=SOM(3,KF,JI)-CCX*GR                                  DIRA-311
      SOM(4,KF,JI)=SOM(4,KF,JI)-CCX*GI                                  DIRA-312
   40 CONTINUE                                                          DIRA-313
      JRR=JRR+2                                                         DIRA-314
      JRI=JRI+2                                                         DIRA-315
   41 CONTINUE                                                          DIRA-316
   42 CONTINUE                                                          DIRA-317
      RETURN                                                            DIRA-318
   43 WRITE (6,1004)                                                    DIRA-319
      GO TO 45                                                          DIRA-320
   44 WRITE (6,1005)                                                    DIRA-321
   45 LO(19)=.TRUE.                                                     DIRA-322
      WRITE (6,1006)                                                    DIRA-323
      RETURN                                                            DIRA-324
 1000 FORMAT (28H NON DERIVATIVE FORM-FACTORS,I10)                      DIRA-325
 1001 FORMAT (2X,I3,1P,D11.3,8D14.6)                                    DIRA-326
 1002 FORMAT (30H FIRST DERIVATIVE FORM-FACTORS,I10)                    DIRA-327
 1003 FORMAT (31H SECOND DERIVATIVE FORM-FACTORS)                       DIRA-328
 1004 FORMAT (24H STOP IN FINITE INTEGRAL)                              DIRA-329
 1005 FORMAT (26H STOP IN INFINITE INTEGRAL)                            DIRA-330
 1006 FORMAT (25H ***** STOP IN DIRA *****)                             DIRA-331
      END                                                               DIRA-332
