C 29/03/98                                                      DWBA98  PTCP-000
      SUBROUTINE PTCP(KTF,KS,H,S0,S1,S2)                                PTCP-001
C CONSTANTS FOR L**2, (L.S1)(L.S2) AND L**2(S1.S2) FOR NATURAL PARITY.  PTCP-002
C INPUT:  KTF   USED TO SEE IF SUCH INTERACTIONS ARE USED.              PTCP-003
C         KS    NUMBER OF RANGES.                                       PTCP-004
C         H     STEP SIZE.                                              PTCP-005
C DATA PASSED OVER BY THE COMMON /GABJ/:  ( SEE MULT )                  PTCP-006
C  AJ,BJ,CJ,DJ  SPIN TRANSFER J, J*(J+1), 2*J+1, 1.D0/(J*(J+1)).        PTCP-007
C  XG           VARIOUS DEPENDENCES ON QUANTUM NUMBERS                  PTCP-008
C OUTPUT: S0    NON DERIVATIVE TERMS IN THE ORDER C6,C9,C7,C8 AND C5    PTCP-009
C         S1    FIRST DERIVATIVE TERMS IN THE ORDER D2,C3,D4,C4,C2,D3   PTCP-010
C         S2    SECOND DERIVATIVE TERMS  C1 ( SEE NOTES )               PTCP-011
C***********************************************************************PTCP-012
      IMPLICIT REAL*8 (A-H,O-Z)                                         PTCP-013
      DIMENSION KTF(7,7,1),S0(3,12,13),S1(3,6,14),S2(3,2,3)             PTCP-014
      COMMON /GABJ/ AA,AB,AJ,BJ,CJ,DJ,XG(11),JX                         PTCP-015
      DO 2 K=1,KS                                                       PTCP-016
      DO 1 I=5,7                                                        PTCP-017
      IF (KTF(I,1,K).NE.0) GO TO 3                                      PTCP-018
    1 CONTINUE                                                          PTCP-019
    2 CONTINUE                                                          PTCP-020
      RETURN                                                            PTCP-021
    3 DO 10 L=1,3                                                       PTCP-022
      DO 5 K=1,13                                                       PTCP-023
      DO 4 I=1,12                                                       PTCP-024
    4 S0(L,I,K)=0.D0                                                    PTCP-025
    5 CONTINUE                                                          PTCP-026
      DO 7 K=1,8                                                        PTCP-027
      DO 6 I=1,6                                                        PTCP-028
    6 S1(L,I,K)=0.D0                                                    PTCP-029
    7 CONTINUE                                                          PTCP-030
      DO 9 K=1,3                                                        PTCP-031
      DO 8 I=1,2                                                        PTCP-032
    8 S2(L,I,K)=0.D0                                                    PTCP-033
    9 CONTINUE                                                          PTCP-034
   10 CONTINUE                                                          PTCP-035
C  1-5-6-7-10 ONLY                                                      PTCP-036
      S0(1,1,2)=.0625D0*CJ*(XG(2)+XG(1)-XG(3)-2.D0*XG(4)+XG(6)-3.D0*BJ+(PTCP-037
     132.D0-43.D0*BJ-XG(1)+XG(3))/((2.D0*AJ-1.D0)*(2.D0*AJ+3.D0)))      PTCP-038
      S0(1,7,2)=.0625D0*CJ                                              PTCP-039
      S0(1,5,2)=-2.D0*S0(1,7,2)                                         PTCP-040
      S0(1,1,3)=-(AJ+2.D0)**2*((AJ+1.D0)*(AJ+2.D0)-XG(1)+XG(3))/(16.D0*APTCP-041
     1J+24.D0)                                                          PTCP-042
      S0(1,1,5)=.125D0*((AJ+2.D0)*(BJ+XG(1)-XG(3))+(AJ+1.D0)*(2.D0*XG(4)PTCP-043
     1-XG(2)-XG(6)))                                                    PTCP-044
      S0(1,1,7)=-CJ*((BJ-2.D0)*(BJ+2.D0*XG(1)-2.D0*XG(3))-2.D0*(BJ-1.D0)PTCP-045
     1*(XG(2)-2.D0*XG(4)+XG(6))-2.D0*XG(5)+XG(9))/((16.D0*AJ-8.D0)*(2.D0PTCP-046
     1*AJ+3.D0))                                                        PTCP-047
      S0(1,1,8)=((AJ+2.D0)*((AJ+4.D0)*((AJ+1.D0)*(AJ+3.D0)-2.D0*XG(1)+2.PTCP-048
     1D0*XG(3))+XG(2)-2.D0*XG(4)+XG(6))-2.D0*XG(5)+XG(9))/(32.D0*AJ+48.DPTCP-049
     20)                                                                PTCP-050
      S0(1,7,10)=-.125D0*(AJ+1.D0)                                      PTCP-051
      S0(1,5,10)=-2.D0*S0(1,7,10)                                       PTCP-052
      S0(1,1,13)=(AJ+1.D0)*(AJ+3.D0)*(AJ+4.D0)*(AJ+2.D0)/(32.D0*AJ+48.D0PTCP-053
     1)                                                                 PTCP-054
      S1(1,1,2)=(3.D0*BJ-2.D0)*CJ/((8.D0*AJ-4.D0)*(2.D0*AJ+3.D0))/H     PTCP-055
      S1(1,1,3)=(AJ+1.D0)*(AJ+2.D0)**2/(8.D0*AJ+12.D0)/H                PTCP-056
      S1(1,1,5)=-(BJ+XG(1)-XG(3))*CJ/((8.D0*AJ-4.D0)*(2.D0*AJ+3.D0))/H  PTCP-057
      S1(1,1,6)=-(AJ+2.D0)*((AJ+1.D0)*(AJ+3.D0)-XG(1)+XG(3))/(8.D0*AJ+12PTCP-058
     1.D0)/H                                                            PTCP-059
      S2(1,1,3)=(AJ+1.D0)*(AJ+2.D0)/(8.D0*AJ+12.D0)/H**2                PTCP-060
      S0(2,1,2)=-CJ*(4.D0*BJ**2-36.D0*BJ+24.D0+(7.D0*BJ-6.D0)*XG(1)-(4.DPTCP-061
     10*BJ-3.D0)*XG(2)+(18.D0*BJ-15.D0)*XG(4)-3.D0*XG(5))/((2.D0*AJ+3.D0PTCP-062
     2)*(32.D0*AJ-16.D0))                                               PTCP-063
      S0(2,1,3)=((AJ+2.D0)*((AJ+1.D0)*((2.D0*AJ+6.D0)*AJ+6.D0)-(AJ+2.D0)PTCP-064
     1*(AJ+3.D0)*XG(1)-(2.D0*AJ+3.D0)*XG(2)-((2.D0*AJ+4.D0)*AJ+3.D0)*XG(PTCP-065
     24))+AJ*XG(5))/(32.D0*AJ+48.D0)                                    PTCP-066
      S0(2,5,3)=-((AJ+2.D0)*((AJ+1.D0)*(2.D0*BJ+2.D0*AJ+3.D0)-(AJ+2.D0)*PTCP-067
     1*2*XG(1)-CJ*XG(2)-2.D0*(BJ+1.D0)*XG(4))+(AJ-1.D0)*XG(5))/((AJ+1.D0PTCP-068
     2)*(32.D0*AJ+48.D0))                                               PTCP-069
      S0(2,1,5)=-.1875D0*((AJ+2.D0)*(AJ+1.D0-XG(1))-XG(2)-(AJ+1.D0)*XG(4PTCP-070
     1))                                                                PTCP-071
      S0(2,1,10)=-.0625D0*((AJ+2.D0)*(3.D0*(AJ+1.D0)+3.D0*XG(1)-CJ*XG(4)PTCP-072
     1)+XG(5))                                                          PTCP-073
      S0(3,1,2)=.125D0*CJ*(BJ+2.D0-XG(2)-XG(4))                         PTCP-074
      S0(3,1,3)=.125D0*(2.D0-XG(4))                                     PTCP-075
      S0(3,5,3)=.0625D0*(XG(4)-2.D0)                                    PTCP-076
      S0(3,1,5)=-.125D0*((AJ+2.D0)*((AJ+1.D0)**2-XG(2)-AJ*XG(4))+XG(5)) PTCP-077
      S0(3,1,10)=-.125D0*((AJ+1.D0)**2*(AJ+2.D0-XG(4))-(AJ+2.D0)*XG(2)+(PTCP-078
     1XG(4)+XG(5)))                                                     PTCP-079
      IF (JX.NE.0) GO TO 11                                             PTCP-080
      S0(1,5,12)=-1.D0/12.D0                                            PTCP-081
      S0(1,7,12)=1.D0/24.D0                                             PTCP-082
      S0(1,5,13)=-1.D0/24.D0                                            PTCP-083
      S0(1,7,13)=1.D0/48.D0                                             PTCP-084
      S0(2,5,2)=-.5D0*S0(2,1,2)                                         PTCP-085
      S0(2,5,5)=-.5D0*S0(2,1,5)                                         PTCP-086
      S0(2,5,10)=-.5D0*S0(2,1,10)                                       PTCP-087
      S0(3,5,2)=-.5D0*S0(3,1,2)                                         PTCP-088
      S0(3,5,5)=-.5D0*S0(3,1,5)                                         PTCP-089
      S0(3,5,10)=-.5D0*S0(3,1,10)                                       PTCP-090
      GO TO 12                                                          PTCP-091
C 1-2-3-4-5-7-8-9  ONLY                                                 PTCP-092
   11 S0(1,2,2)=.125D0*CJ*(2.D0*BJ-2.D0-(6.D0-3.D0*DJ)*(XG(1)-XG(3)))/((PTCP-093
     12.D0*AJ-1.D0)*(2.D0*AJ+3.D0))                                     PTCP-094
      S0(1,4,2)=-S0(1,2,2)                                              PTCP-095
      S0(1,3,2)=S0(1,7,2)                                               PTCP-096
      S0(1,2,3)=-S0(1,1,3)/((AJ+2.D0)*(AJ+1.D0))                        PTCP-097
      S0(1,4,3)=-S0(1,2,3)                                              PTCP-098
      S0(1,1,4)=.125D0*((AJ-1.D0)*(BJ+XG(1)-XG(3))+AJ*(2.D0*XG(4)-XG(2)-PTCP-099
     1XG(6)))                                                           PTCP-100
      S0(1,2,4)=-.125D0*(AJ-1.D0-(XG(1)-XG(3))/AJ)                      PTCP-101
      S0(1,4,4)=-S0(1,2,4)                                              PTCP-102
      S0(1,2,5)=-.125D0*(AJ+2.D0-(XG(1)-XG(3))/(AJ+1.D0))               PTCP-103
      S0(1,4,5)=-S0(1,2,5)                                              PTCP-104
      S0(1,2,9)=.125D0*(AJ*(AJ-1.D0)+XG(1)-XG(3))/AJ                    PTCP-105
      S0(1,3,9)=-.125D0*AJ                                              PTCP-106
      S0(1,4,9)=-S0(1,2,9)                                              PTCP-107
      S0(1,5,9)=-2.D0*S0(1,3,9)                                         PTCP-108
      S0(1,7,9)=S0(1,3,9)                                               PTCP-109
      S0(1,1,10)=.125D0*(AJ+2.D0)*(BJ-XG(1)+XG(3))                      PTCP-110
      S0(1,2,10)=.125D0*((AJ+1.D0)*(AJ+2.D0)+XG(1)-XG(3))/(AJ+1.D0)     PTCP-111
      S0(1,3,10)=S0(1,7,10)                                             PTCP-112
      S0(1,4,10)=-S0(1,2,10)                                            PTCP-113
      S0(1,7,12)=CJ*(BJ-1.D0)/((8.D0*AJ-4.D0)*(2.D0*AJ+3.D0))           PTCP-114
      S0(1,5,12)=-2.D0*S0(1,7,12)                                       PTCP-115
      S0(1,3,12)=S0(1,7,12)                                             PTCP-116
      S0(1,4,12)=-(2.D0-BJ)*S0(1,7,12)/(BJ-1.D0)                        PTCP-117
      S0(1,2,12)=-S0(1,4,12)                                            PTCP-118
      S0(1,1,12)=-.5D0*BJ*S0(1,4,12)                                    PTCP-119
      S0(1,2,13)=-2.D0*S0(1,1,13)/((AJ+1.D0)*(AJ+3.D0))                 PTCP-120
      S0(1,4,13)=-S0(1,2,13)                                            PTCP-121
      S0(1,5,13)=-S0(1,4,13)/(AJ+4.D0)                                  PTCP-122
      S0(1,3,13)=-.5D0*S0(1,5,13)                                       PTCP-123
      S0(1,7,13)=S0(1,3,13)                                             PTCP-124
      S1(1,4,2)=-CJ/((8.D0*AJ-4.D0)*(2.D0*AJ+3.D0))/H                   PTCP-125
      S1(1,2,2)=-S1(1,4,2)                                              PTCP-126
      S1(1,4,3)=(AJ+2.D0)/(8.D0*AJ+12.D0)/H                             PTCP-127
      S1(1,2,3)=-S1(1,4,3)                                              PTCP-128
      S1(1,1,7)=-.25D0*(XG(1)-XG(3))/H                                  PTCP-129
      S1(1,2,7)=.25D0/H                                                 PTCP-130
      S1(1,4,7)=-S1(1,2,7)                                              PTCP-131
      S2(1,1,1)=AJ*(AJ-1.D0)/(8.D0*AJ-4.D0)/H**2                        PTCP-132
      S0(2,2,2)=-CJ*((7.D0*BJ-6.D0-(2.D0*BJ-1.D0)*(2.D0*XG(1)+XG(4))-XG(PTCP-133
     12)-2.D0*XG(5))/((2.D0*AJ+3.D0)*(32.D0*AJ-16.D0))-.0625D0*(3.D0*XG(PTCP-134
     23)-XG(8))*DJ)                                                     PTCP-135
      S0(2,3,2)=CJ*(4.D0*BJ-3.D0+XG(1)-4.D0*XG(2)-3.D0*(XG(4)+XG(5)-2.D0PTCP-136
     1*XG(2))*DJ)/((2.D0*AJ+3.D0)*(32.D0*AJ-16.D0))                     PTCP-137
      S0(2,4,2)=.1875D0*CJ*XG(1)*DJ                                     PTCP-138
      S0(2,5,2)=-CJ*(18.D0*BJ-15.D0-(2.D0*BJ-1.D0)*XG(1)-(12.D0*BJ-18.D0PTCP-139
     1)*XG(4)+6*XG(5)-(12.D0*(XG(4)+XG(5))-3.D0*XG(2))*DJ)/((2.D0*AJ+3.DPTCP-140
     20)*(32.D0*AJ-16.D0))                                              PTCP-141
      S0(2,9,2)=-.0625D0*CJ*XG(1)*DJ                                    PTCP-142
      S0(2,2,3)=-(AJ+2.D0)*((AJ+2.D0)*((AJ+1.D0)*(AJ+3.D0)-(AJ+2.D0)*(2.PTCP-143
     1D0*XG(1)+XG(4))-XG(2))-XG(5))/((AJ+1.D0)*(32.D0*AJ+48.D0))        PTCP-144
      S0(2,3,3)=-((AJ+2.D0)*((AJ+1.D0)*(2.D0*AJ+3.D0)-(AJ+2.D0)*XG(1)-2.PTCP-145
     1D0*XG(2)-CJ*XG(4))+XG(5))/((AJ+1.D0)*(32.D0*AJ+48.D0))            PTCP-146
      S0(2,1,4)=.1875D0*((AJ-1)*(AJ+XG(1))-XG(2)+AJ*XG(4))              PTCP-147
      S0(2,2,4)=-.0625D0*((AJ-1.D0)*(3.D0*BJ-(BJ+1.D0)*XG(4)-XG(5))-3.D0PTCP-148
     1*(AJ+1.D0)*XG(1)-((AJ-5.D0)*AJ-5.D0)*XG(3)-(2.D0*AJ+1.D0)*XG(8)+XGPTCP-149
     2(11))*DJ                                                          PTCP-150
      S0(2,5,4)=-.0625D0*((AJ-1.D0)*(2.D0*AJ+1.D0+XG(1))-2.D0*XG(2)+(2.DPTCP-151
     10*AJ+1.D0)*XG(4)+(XG(2)+(AJ-1.D0)*XG(1)-(AJ+2.D0)*(XG(4)+XG(5)))*DPTCP-152
     2J)                                                                PTCP-153
      S0(2,2,5)=-.0625D0*((AJ+2.D0)*(3.D0*BJ-(1.D0+BJ)*XG(4)-XG(5))-3.D0PTCP-154
     1*AJ*XG(1)+((AJ+7.D0)*AJ+1.D0)*XG(3)-(2.D0*AJ+1.D0)*XG(8)-XG(11))*DPTCP-155
     2J                                                                 PTCP-156
      S0(2,5,5)=.0625D0*((AJ+2.D0)*(2.D0*AJ+1.D0-XG(1))-(2.D0*AJ+1.D0)*XPTCP-157
     1G(4)-2.D0*XG(2)-((AJ+2.D0)*XG(1)-XG(2)-(AJ-1.D0)*(XG(4)+XG(5)))*DJPTCP-158
     2)                                                                 PTCP-159
      S0(2,2,7)=CJ*(BJ*(3.D0-2.D0*XG(1)-2.D0*XG(4))-6.D0+3.D0*XG(1)+3.D0PTCP-160
     1*XG(2)+9.D0*XG(3)+7.D0*XG(4)-2.D0*XG(5)-2.D0*XG(8)-6.D0*(XG(1)+XG(PTCP-161
     22)+XG(3)+XG(4)+XG(5)+.5D0*XG(11))*DJ)/((32.D0*AJ-16.D0)*(2.D0*AJ+3PTCP-162
     3.D0))                                                             PTCP-163
      S0(2,2,8)=((AJ+2.D0)*((AJ+4.D0)*((AJ+3.D0)*(AJ+1.D0)-XG(2)-(AJ+2.DPTCP-164
     10)*XG(4))-((AJ+8.D0)*AJ+13.D0)*XG(1)+(AJ+2.D0)*XG(3)-XG(8))-(AJ+4.PTCP-165
     2D0)*XG(5)-XG(11))/((AJ+1.D0)*(32.D0*AJ+48.D0))                    PTCP-166
      S0(2,2,9)=.0625D0*((AJ-1.D0)*(3.D0-XG(4))+(3.D0*(AJ+1.D0)*XG(1)-(APTCP-167
     1J-1.D0)*(XG(4)+XG(5)))*DJ)                                        PTCP-168
      S0(2,3,9)=-.0625D0*(3.D0-2.D0*XG(4)+(XG(4)+XG(5))*DJ)             PTCP-169
      S0(2,4,9)=.0625D0*((AJ-5.D0)*AJ-5.D0)*XG(1)*DJ                    PTCP-170
      S0(2,5,9)=.0625D0*(3.D0*AJ+(AJ-1.D0)*XG(1)-CJ*XG(4)+((AJ-1.D0)*XG(PTCP-171
     11)+(AJ+2.D0)*(XG(4)+XG(5)))*DJ)                                   PTCP-172
      S0(2,9,9)=.0625D0*XG(1)*CJ*DJ                                     PTCP-173
      S0(2,2,10)=.0625D0*((AJ+2.D0)*(3.D0-XG(4))+(3.D0*AJ*XG(1)-(AJ+2.D0PTCP-174
     1)*(XG(4)+XG(5)))*DJ)                                              PTCP-175
      S0(2,5,10)=.0625D0*(3.D0*AJ+3.D0+(AJ+2.D0)*XG(1)-CJ*XG(4)+((AJ+2.DPTCP-176
     10)*XG(1)+(AJ-1.D0)*(XG(4)+XG(5)))*DJ)                             PTCP-177
      S0(2,3,10)=.0625D0*(3.D0-2.D0*XG(4)+(XG(4)+XG(5))*DJ)             PTCP-178
      S0(2,9,10)=.0625D0*XG(1)*DJ*CJ                                    PTCP-179
      S0(2,4,10)=-((AJ+7.D0)*AJ+1.D0)*S0(2,9,10)/CJ                     PTCP-180
      S0(2,9,12)=-CJ*XG(1)/((16.D0*AJ-8.D0)*(2.D0*AJ+3.D0))             PTCP-181
      S0(2,2,12)=(BJ-1.5D0+3.D0*DJ)*S0(2,9,12)                          PTCP-182
      S0(2,4,12)=-(4.5D0-3.D0*DJ)*S0(2,9,12)                            PTCP-183
      S0(2,9,13)=-(AJ+2.D0)*XG(1)/((AJ+1.D0)*(32.D0*AJ+48.D0))          PTCP-184
      S0(2,4,13)=-(AJ+2.D0)*S0(2,9,13)                                  PTCP-185
      S0(2,3,13)=(AJ+4.D0)*S0(2,9,13)                                   PTCP-186
      S0(2,5,13)=(AJ+2.D0)*S0(2,3,13)                                   PTCP-187
      S0(2,1,13)=-(AJ+1.D0)*(AJ+3.D0)*S0(2,3,13)                        PTCP-188
      S0(2,2,13)=((AJ+8.D0)*AJ+13.D0)*S0(2,9,13)                        PTCP-189
      S1(2,2,2)=-XG(1)*CJ/((8.D0*AJ-4.D0)*(2.D0*AJ+3.D0))/H             PTCP-190
      S1(2,1,2)=BJ*S1(2,2,2)                                            PTCP-191
      S1(2,3,2)=(1.5D0*DJ-1.D0)*S1(2,2,2)                               PTCP-192
      S1(2,5,2)=1.5D0*(DJ-1.D0)*S1(2,2,2)                               PTCP-193
      S1(2,3,3)=-(AJ+2.D0)*XG(1)/((AJ+1.D0)*(16.D0*AJ+24.D0))/H         PTCP-194
      S1(2,5,3)=(AJ+2.D0)*S1(2,3,3)                                     PTCP-195
      S1(2,2,3)=2.D0*S1(2,5,3)                                          PTCP-196
      S1(2,1,3)=-(AJ+1.D0)*(AJ+3.D0)*S1(2,3,3)                          PTCP-197
      S1(2,2,5)=-(-2.D0*BJ+2.D0*XG(1)+2.D0*XG(2)+3.D0*XG(4)-3.D0*(2.D0*XPTCP-198
     1G(1)+XG(2)+XG(4)+XG(5))*DJ)*CJ/((16.D0*AJ-8.D0)*(2.D0*AJ+3.D0))/H PTCP-199
      S1(2,2,6)=-((AJ+2.D0)*((AJ+3.D0)*(AJ+1.D0-2.D0*XG(1))-(XG(2)+(AJ+2PTCP-200
     1.D0)*XG(4)))-XG(5))/((AJ+1.D0)*(16.D0*AJ+24.D0))/H                PTCP-201
      S1(2,1,7)=-.375D0*XG(1)/H                                         PTCP-202
      S1(2,5,7)=.125D0*(BJ+1.D0)*XG(1)*DJ/H                             PTCP-203
      S1(2,2,7)=.125D0*(3.D0-XG(4)-(XG(4)+XG(5))*DJ)/H                  PTCP-204
      S2(2,2,3)=-(AJ+2.D0)*XG(1)/((AJ+1.D0)*(8.D0*AJ+12.D0))/H**2       PTCP-205
      S0(3,2,2)=CJ*((12.D0*BJ+34.D0)*XG(1)+8.D0*XG(3)-4.D0*(XG(2)-XG(4)-PTCP-206
     1XG(5)+XG(7)+XG(8))-(32.D0*XG(1)-4.D0*(XG(2)-XG(4)-XG(5))+6.D0*XG(3PTCP-207
     2)-3.D0*(XG(7)+XG(8)))*DJ)/((32.D0*AJ-16.D0)*(2.D0*AJ+3.D0))       PTCP-208
      S0(3,3,2)=-.125D0*CJ*(1.D0+(2.D0*XG(1)-4.D0*XG(2)-(2.D0*XG(1)-XG(2PTCP-209
     1)-2*XG(4)-2.D0*XG(5))*DJ)/((2.D0*AJ-1.D0)*(2.D0*AJ+3.D0)))        PTCP-210
      S0(3,4,2)=.125D0*CJ*XG(1)*DJ                                      PTCP-211
      S0(3,5,2)=.125D0*CJ*(XG(4)-1.D0-((2.D0*(XG(1)+XG(2))-5.D0*(XG(4)+XPTCP-212
     1G(5)))*DJ-2.D0*XG(1)+4.D0*(XG(4)+XG(5)))/((2.D0*AJ-1.D0)*(2.D0*AJ+PTCP-213
     23.D0)))                                                           PTCP-214
      S0(3,8,2)=-.5D0*S0(3,4,2)                                         PTCP-215
      S0(3,9,2)=S0(3,8,2)                                               PTCP-216
      S0(3,1,3)=.125D0*((AJ+2.D0)*((AJ+1.D0)**2-XG(2)-AJ*XG(4))+XG(5))  PTCP-217
      S0(3,2,3)=(AJ+2.D0)**2*((AJ+1.D0)*(AJ+2.D0)*XG(1)-XG(2)+XG(4)+XG(5PTCP-218
     1))*DJ/(16*AJ+24.D0)                                               PTCP-219
      S0(3,3,3)=-.125D0*(AJ+2.D0-XG(4)+((AJ+2.D0)**2*XG(1)-(AJ+2.D0)*(2.PTCP-220
     1D0*AJ+1.D0)*XG(2)+2.D0*(AJ+1.D0)*(XG(4)+XG(5)))*DJ/(2.D0*AJ+3.D0))PTCP-221
      S0(3,5,3)=-.125D0*(AJ*(AJ+2.D0)-XG(2)-AJ*XG(4)-((AJ+2.D0)**2*XG(1)PTCP-222
     1-2.D0*(AJ+1.D0)*XG(2)-(2.D0*AJ**2+AJ-2.D0)*(XG(4)+XG(5)))*DJ/(2.D0PTCP-223
     2*AJ+3.D0))                                                        PTCP-224
      S0(3,1,4)=-.125D0*((AJ-1.D0)*(AJ**2-XG(2)+(AJ+1.D0)*XG(4))-XG(5)) PTCP-225
      S0(3,2,4)=-.125D0*((AJ-1.D0)*(BJ*XG(1)+XG(2)-XG(4)-XG(5))+AJ*(2.D0PTCP-226
     1*XG(3)-XG(7)-XG(8)))*DJ                                           PTCP-227
      S0(3,3,4)=.125D0*(AJ-1.D0+XG(4)+((AJ-1.D0)*XG(1)-AJ*XG(2)-XG(4)-XGPTCP-228
     1(5))*DJ)                                                          PTCP-229
      S0(3,5,4)=-.125D0*((AJ+1.D0)*(AJ-1.D0+XG(4))-XG(2)+((AJ-1.D0)*XG(1PTCP-230
     1)+XG(2)-(AJ+2.D0)*(XG(4)+XG(5)))*DJ)                              PTCP-231
      S0(3,2,5)=-.125D0*((AJ+2.D0)*XG(1)+((AJ+2.D0)*(XG(2)-XG(4)-XG(5))-PTCP-232
     1(AJ+1.D0)*(XG(7)+XG(8)-2.D0*XG(3)))*DJ)                           PTCP-233
      S0(3,3,5)=.125D0*(AJ+2.D0-XG(4)+((AJ+2.D0)*XG(1)-(AJ+1.D0)*XG(2)+XPTCP-234
     1G(4)+XG(5))*DJ)                                                   PTCP-235
      S0(3,5,5)=.125D0*(AJ*(AJ+2.D0)-XG(2)-AJ*XG(4)-((AJ+2.D0)*XG(1)-XG(PTCP-236
     12)-(AJ-1.D0)*(XG(4)+XG(5)))*DJ)                                   PTCP-237
      S0(3,2,7)=CJ*((BJ-2.D0)*(BJ*XG(1)+2.D0*XG(2)-2.D0*XG(4)-2.D0*XG(5)PTCP-238
     1)+2.D0*(BJ-1.D0)*(2.D0*XG(3)-XG(7)-XG(8))+XG(10)-2.D0*XG(11))*DJ/(PTCP-239
     2(16.D0*AJ-8.D0)*(2.D0*AJ+3.D0))                                   PTCP-240
      S0(3,2,8)=-((AJ+2.D0)*((AJ+4.D0)*((AJ+1.D0)*(AJ+3.D0)*XG(1)-2.D0*(PTCP-241
     1XG(2)-XG(4)-XG(5)))-2.D0*XG(3)+XG(7)+XG(8))+XG(10)-2.D0*XG(11))*DJPTCP-242
     2/(32.D0*AJ+48.D0)                                                 PTCP-243
      S0(3,3,9)=.125D0*(AJ-1.D0+XG(4)-((AJ-1.D0)*XG(1)+AJ*XG(2)+XG(4)+XGPTCP-244
     1(5))*DJ)                                                          PTCP-245
      S0(3,5,9)=-.125D0*(AJ**2-1.D0-XG(2)+(AJ+1.D0)*XG(4)-((AJ-1.D0)*XG(PTCP-246
     11)-XG(2)+(AJ+2.D0)*(XG(4)+XG(5)))*DJ)                             PTCP-247
      S0(3,8,9)=.125D0*XG(1)/(AJ+1.D0)                                  PTCP-248
      S0(3,4,9)=-2.D0*S0(3,8,9)                                         PTCP-249
      S0(3,9,9)=S0(3,8,9)                                               PTCP-250
      S0(3,2,10)=-.125D0*(AJ+2.D0)*(XG(1)-(XG(2)-XG(4)-XG(5))*DJ)       PTCP-251
      S0(3,3,10)=.125D0*(AJ+2.D0-XG(4)-((AJ+2.D0)*XG(1)+(AJ+1.D0)*XG(2)-PTCP-252
     1XG(4)-XG(5))*DJ)                                                  PTCP-253
      S0(3,5,10)=.125D0*(AJ*(AJ+2.D0-XG(4))-XG(2)+((AJ+2.D0)*XG(1)+XG(2)PTCP-254
     1+(AJ-1.D0)*(XG(4)+XG(5)))*DJ)                                     PTCP-255
      S0(3,8,10)=.125D0*(AJ+1.D0)*XG(1)*DJ                              PTCP-256
      S0(3,4,10)=-2.D0*S0(3,8,10)                                       PTCP-257
      S0(3,9,10)=S0(3,8,10)                                             PTCP-258
      S0(3,8,12)=CJ*(DJ-1.D0)*XG(1)/((8.D0*AJ-4.D0)*(2.D0*AJ+3.D0))     PTCP-259
      S0(3,9,12)=S0(3,8,12)                                             PTCP-260
      S0(3,4,12)=-2.D0*S0(3,8,12)                                       PTCP-261
      S0(3,8,13)=-(AJ+2.D0)*XG(1)*DJ/(32.D0*AJ+48.D0)                   PTCP-262
      S0(3,9,13)=S0(3,8,13)                                             PTCP-263
      S0(3,4,13)=-2.D0*S0(3,8,13)                                       PTCP-264
      S0(3,5,13)=-(AJ+4.D0)*S0(3,4,13)                                  PTCP-265
      S0(3,3,13)=-S0(3,5,13)                                            PTCP-266
      S0(3,2,13)=-.5D0*(AJ+1.D0)*(AJ+3.D0)*S0(3,3,13)                   PTCP-267
      S1(3,3,2)=-XG(1)*CJ*DJ/((8.D0*AJ-4.D0)*(2.D0*AJ+3.D0))/H          PTCP-268
      S1(3,2,2)=-(2.D0-3.D0*BJ)*S1(3,3,2)                               PTCP-269
      S1(3,5,2)=-S1(3,3,2)                                              PTCP-270
      S1(3,3,3)=(AJ+2.D0)*XG(1)*DJ/(8.D0*AJ+12.D0)/H                    PTCP-271
      S1(3,2,3)=-(AJ+1.D0)*(AJ+2.D0)*S1(3,3,3)                          PTCP-272
      S1(3,5,3)=-S1(3,3,3)                                              PTCP-273
      S1(3,2,5)=(XG(1)-(XG(4)+XG(5)-XG(2))*DJ)*CJ/((8.D0*AJ-4.D0)*(2.D0*PTCP-274
     1AJ+3.D0))/H                                                       PTCP-275
      S1(3,2,6)=(AJ+2.D0)*((AJ+1.D0)*(AJ+3.D0)*XG(1)-XG(2)+XG(4)+XG(5))*PTCP-276
     1DJ/(8.D0*AJ+12.D0)/H                                              PTCP-277
      S1(3,2,7)=-.25D0*(XG(4)-XG(2)+XG(5))*DJ/H                         PTCP-278
      S1(3,3,7)=-.25D0*XG(1)*DJ/H                                       PTCP-279
      S1(3,5,7)=-S1(3,3,7)                                              PTCP-280
      S2(3,2,3)=-(AJ+2.D0)*XG(1)/(AJ*(8.D0*AJ+12.D0))/H**2              PTCP-281
      IF (JX.LE.1) GO TO 12                                             PTCP-282
C  6-10-11-12 ONLY                                                      PTCP-283
      S0(1,4,1)=-(AJ-1.D0)*(AJ*(AJ-1.D0)-XG(1)+XG(3))/(AJ*(16.D0*AJ-8.D0PTCP-284
     1))                                                                PTCP-285
      S0(1,2,1)=-S0(1,4,1)                                              PTCP-286
      S0(1,1,1)=-AJ*(AJ-1.D0)*S0(1,2,1)                                 PTCP-287
      S0(1,1,6)=((AJ-1.D0)*((AJ-3.D0)*(AJ*(AJ-2.D0)-2.D0*XG(1)+2.D0*XG(3PTCP-288
     1))-XG(2)+2.D0*XG(4)-XG(6))-2.D0*XG(5)+XG(9))/(32.D0*AJ-16.D0)     PTCP-289
      S0(1,1,9)=.125D0*(AJ-1.D0)*(BJ-XG(1)+XG(3))                       PTCP-290
      S0(1,7,11)=-(AJ-1.D0)/(32.D0*AJ-16.D0)                            PTCP-291
      S0(1,3,11)=S0(1,7,11)                                             PTCP-292
      S0(1,5,11)=-2.D0*S0(1,7,11)                                       PTCP-293
      S0(1,2,11)=-(AJ-3.D0)*S0(1,5,11)                                  PTCP-294
      S0(1,4,11)=-S0(1,2,11)                                            PTCP-295
      S0(1,1,11)=-.5D0*AJ*(AJ-2.D0)*S0(1,2,11)                          PTCP-296
      S0(1,10,11)=-S0(1,7,11)/(AJ-1.D0)                                 PTCP-297
      S0(1,6,11)=-2.D0*S0(1,10,11)                                      PTCP-298
      S0(1,6,12)=S0(1,7,12)/(BJ-1.D0)                                   PTCP-299
      S0(1,10,12)=-.5D0*S0(1,6,12)                                      PTCP-300
      S0(1,10,13)=S0(1,7,13)/(AJ+2.D0)                                  PTCP-301
      S0(1,6,13)=-2.D0*S0(1,10,13)                                      PTCP-302
      S1(1,1,1)=-(AJ-1.D0)*AJ*(AJ-1.D0)/(8.D0*AJ-4.D0)/H                PTCP-303
      S1(1,2,1)=(AJ-1.D0)/(8.D0*AJ-4.D0)/H                              PTCP-304
      S1(1,4,1)=-S1(1,2,1)                                              PTCP-305
      S1(1,1,4)=(AJ-1.D0)*((AJ-2.D0)*AJ-XG(1)+XG(3))/(8.D0*AJ-4.D0)/H   PTCP-306
      S0(2,1,1)=((AJ-1.D0)*(2.D0*AJ*((AJ-1.D0)*AJ+1.D0)+(AJ-1.D0)*(AJ-2.PTCP-307
     1D0)*XG(1)-(2.D0*AJ-1.D0)*XG(2)+(2.D0*AJ**2+1.D0)*XG(4))-(AJ+1.D0)*PTCP-308
     2XG(5))/(32.D0*AJ-16.D0)                                           PTCP-309
      S0(2,2,1)=(AJ-1.D0)*((AJ-1.D0)*(AJ*(AJ-2.D0)-XG(2)+(AJ-1.D0)*(XG(4PTCP-310
     1)+2.D0*XG(1)))+XG(5))/(AJ*(32.D0*AJ-16.D0))                       PTCP-311
      S0(2,3,1)=-((AJ-1.D0)*(AJ*(2.D0*AJ-1.D0)+(AJ-1.D0)*XG(1)-2.D0*XG(2PTCP-312
     1)+CJ*XG(4))-XG(5))/(AJ*(32.D0*AJ-16.D0))                          PTCP-313
      S0(2,5,1)=((AJ-1.D0)*(AJ*(2.D0*AJ**2+1.D0)+(AJ-1.D0)**2*XG(1)-CJ*XPTCP-314
     1G(2)+2.D0*(BJ+1.D0)*XG(4))-(AJ+2.D0)*XG(5))/(AJ*(32.D0*AJ-16.D0)) PTCP-315
      S0(2,6,1)=-(BJ-(AJ-1.D0)*XG(1)-XG(2)+(AJ+2.D0)*XG(4)-2.D0*XG(5)/(APTCP-316
     1J-1.D0))/(AJ*(32.D0*AJ-16.D0))                                    PTCP-317
      S0(2,6,2)=CJ*(3.D0+2.D0*XG(1)-6.D0*XG(4)+(12.D0*XG(4)+12.D0*XG(5)-PTCP-318
     13.D0*XG(2))*DJ)/((2.D0*AJ+3.D0)*(32.D0*AJ-16.D0))                 PTCP-319
      S0(2,6,3)=(BJ+(AJ+2.D0)*XG(1)-XG(2)-(AJ-1.D0)*XG(4)+2.D0*XG(5)/(AJPTCP-320
     1+2.D0))/((AJ+1.D0)*(32.D0*AJ+48.D0))                              PTCP-321
      S0(2,6,4)=.0625D0*(BJ-(AJ-1.D0)*XG(1)-XG(2)+(AJ+2.D0)*XG(4)-2.D0*XPTCP-322
     1G(5)/(AJ-1.D0))*DJ                                                PTCP-323
      S0(2,6,5)=-.0625D0*(BJ+(AJ+2.D0)*XG(1)-XG(2)-(AJ-1.D0)*XG(4)+2.D0*PTCP-324
     1XG(5)/(AJ+2.D0))*DJ                                               PTCP-325
      S0(2,2,6)=-((AJ-1.D0)*((AJ-3.D0)*(AJ*(AJ-2.D0)-XG(2)+(AJ-1.D0)*XG(PTCP-326
     14))+((AJ-6.D0)*AJ+6.D0)*XG(1)+(AJ-1.D0)*XG(3)+XG(8))+(AJ-3.D0)*XG(PTCP-327
     25)-XG(11))/(AJ*(32.D0*AJ-16.D0))                                  PTCP-328
      S0(2,1,9)=.0625D0*((AJ-1.D0)*(3.D0*AJ-3.D0*XG(1)-CJ*XG(4))+XG(5)) PTCP-329
      S0(2,6,9)=.0625D0*((AJ-1.D0)*XG(1)+(AJ+2.D0)*XG(4)-2.D0*XG(5)/(AJ-PTCP-330
     11.D0))*DJ                                                         PTCP-331
      S0(2,6,10)=.0625D0*((AJ+2.D0)*XG(1)+(AJ-1.D0)*XG(4)-2.D0*XG(5)/(AJPTCP-332
     1+2.D0))*DJ                                                        PTCP-333
      S0(2,12,9)=-S0(2,9,9)/CJ                                          PTCP-334
      S0(2,12,10)=S0(2,9,10)/CJ                                         PTCP-335
      S0(2,12,11)=XG(1)/(AJ*(32.D0*AJ-16.D0))                           PTCP-336
      S0(2,6,11)=-(AJ-3.D0)*S0(2,12,11)                                 PTCP-337
      S0(2,9,11)=-(AJ-1.D0)*S0(2,12,11)                                 PTCP-338
      S0(2,4,11)=(AJ-1.D0)*S0(2,9,11)                                   PTCP-339
      S0(2,2,11)=((AJ-6.D0)*AJ+6.D0)*S0(2,9,11)                         PTCP-340
      S0(2,3,11)=-(AJ-3.D0)*S0(2,9,11)                                  PTCP-341
      S0(2,5,11)=-(AJ-1.D0)*S0(2,3,11)                                  PTCP-342
      S0(2,1,11)=-AJ*(AJ-2.D0)*S0(2,3,11)                               PTCP-343
      S0(2,1,12)=-1.5D0*(BJ-2.D0)*S0(2,9,12)                            PTCP-344
      S0(2,3,12)=DJ*S0(2,1,12)                                          PTCP-345
      S0(2,5,12)=-(2.D0-3.D0*DJ)*S0(2,1,12)/3.D0                        PTCP-346
      S0(2,6,12)=(1.D0+3.D0*DJ)*S0(2,9,12)                              PTCP-347
      S0(2,12,12)=1.5D0*DJ*S0(2,9,12)                                   PTCP-348
      S0(2,12,13)=S0(2,9,13)/(AJ+2.D0)                                  PTCP-349
      S0(2,6,13)=(AJ+4.D0)*S0(2,12,13)                                  PTCP-350
      S1(2,3,1)=-(AJ-1.D0)*XG(1)/(AJ*(16.D0*AJ-8.D0))/H                 PTCP-351
      S1(2,5,1)=-(AJ-1.D0)*S1(2,3,1)                                    PTCP-352
      S1(2,2,1)=2.D0*S1(2,5,1)                                          PTCP-353
      S1(2,1,1)=-AJ*(AJ-2.D0)*S1(2,3,1)                                 PTCP-354
      S1(2,6,1)=-S1(2,3,1)/(AJ-1.D0)                                    PTCP-355
      S1(2,6,2)=1.5D0*DJ*S1(2,2,2)                                      PTCP-356
      S1(2,6,3)=S1(2,3,3)/(AJ+2.D0)                                     PTCP-357
      S1(2,2,4)=-((AJ-1.D0)*((AJ-2.D0)*(AJ+2.D0*XG(1))-XG(2)+(AJ-1.D0)*XPTCP-358
     1G(4))+XG(5))/(AJ*(16.D0*AJ-8.D0))/H                               PTCP-359
      S1(2,6,7)=-S1(2,1,7)*DJ/3.D0                                      PTCP-360
      S2(2,2,1)=-(AJ-1.D0)*XG(1)/(AJ*(8.D0*AJ-4.D0))/H**2               PTCP-361
      S0(3,1,1)=.125D0*((AJ-1.D0)*(AJ**2-XG(2)+(AJ+1.D0)*XG(4))-XG(5))  PTCP-362
      S0(3,2,1)=(AJ-1.D0)**2*(AJ*(AJ-1.D0)*XG(1)-XG(2)+XG(4)+XG(5))*DJ/(PTCP-363
     116.D0*AJ-8.D0)                                                    PTCP-364
      S0(3,3,1)=-((AJ-1.D0)*(2.D0*AJ-1.D0+((AJ-1.D0)*XG(1)-(2.D0*AJ+1.D0PTCP-365
     1)*XG(2)+AJ*(2.D0*AJ+3.D0)*XG(4))*DJ)-2.D0*AJ*XG(5)*DJ)/(16.D0*AJ-8PTCP-366
     2.D0)                                                              PTCP-367
      S0(3,5,1)=((2.D0*AJ-1.D0)*((AJ+1.D0)*(AJ-1.D0+XG(4))-XG(2))-2.D0*(PTCP-368
     1XG(4)+XG(5))+((AJ-1.D0)*((AJ-1.D0)*XG(1)-XG(4)-XG(5))+2.D0*AJ*XG(2PTCP-369
     2))*DJ)/(16.D0*AJ-8.D0)                                            PTCP-370
      S0(3,6,1)=-(2.D0*AJ-1.D0+2.D0*XG(4)-((AJ-1.D0)**2*XG(1)+2.D0*AJ*XGPTCP-371
     1(2)-(AJ-1.D0)*XG(4))*DJ-(3.D0*AJ-1.D0)*XG(5)*DJ/(AJ-1.D0))/(16.D0*PTCP-372
     2AJ-8.D0)                                                          PTCP-373
      S0(3,6,2)=CJ*(2.D0*XG(1)-4.D0*XG(4)-(2.D0*XG(1)+2.D0*XG(2)-5.D0*XGPTCP-374
     1(4)-10.D0*XG(5)-10.D0*XG(5)/((AJ-1.D0)*(AJ+2.D0)))*DJ)/((16.D0*AJ-PTCP-375
     28.D0)*(2.D0*AJ+3.D0))                                             PTCP-376
      S0(3,6,3)=((2.D0*AJ+3.D0)*(AJ+2.D0-XG(4))+((AJ+2.D0)**3*XG(1)-2.D0PTCP-377
     1*(AJ+1.D0)*(AJ+2.D0)*XG(2)+(3.D0*AJ+4.D0)*(XG(4)+XG(5)))*DJ)/((16.PTCP-378
     2D0*AJ+24.D0)*(AJ+2.D0))                                           PTCP-379
      S0(3,6,4)=.125D0*(BJ-(AJ-1.D0)*XG(1)-XG(2)+(AJ+2.D0)*XG(4)-2.D0*XGPTCP-380
     1(5)/(AJ-1.D0))*DJ                                                 PTCP-381
      S0(3,6,5)=-.125D0*(1.D0+((AJ+2.D0)*XG(1)-XG(2)-(AJ-1.D0)*XG(4)+2.DPTCP-382
     10*XG(5)/(AJ+2.D0))*DJ)                                            PTCP-383
      S0(3,2,6)=-((AJ-1.D0)*((AJ-3.D0)*(AJ*(AJ-2.D0)*XG(1)-2.D0*(XG(2)-XPTCP-384
     1G(4)-XG(5)))+2.D0*XG(3)-XG(7)-XG(8))+XG(10)-2.D0*XG(11))*DJ/(32.D0PTCP-385
     2*AJ-16.D0)                                                        PTCP-386
      S0(3,1,9)=-.125D0*((AJ-1.D0)*(AJ**2-XG(2)+(AJ+1.D0)*XG(4))-XG(5)) PTCP-387
      S0(3,2,9)=-.125D0*(AJ-1.D0)*(XG(1)-(XG(2)-XG(4)-XG(5))*DJ)        PTCP-388
      S0(3,6,9)=.125D0*(1.D0+((AJ-1.D0)*XG(1)-XG(2)+(AJ+2.D0)*XG(4)-2.D0PTCP-389
     1*XG(5)/(AJ-1.D0))*DJ)                                             PTCP-390
      S0(3,6,10)=-.125D0*(1.D0-((AJ+2.D0)*XG(1)+XG(2)+(AJ-1.D0)*XG(4)-2.PTCP-391
     1D0*XG(5)/(AJ+2.D0))*DJ)                                           PTCP-392
      S0(3,11,11)=-XG(1)*DJ/(32.D0*AJ-16.D0)                            PTCP-393
      S0(3,8,11)=-(AJ-1.D0)*S0(3,11,11)                                 PTCP-394
      S0(3,9,11)=S0(3,8,11)                                             PTCP-395
      S0(3,4,11)=-2.D0*S0(3,8,11)                                       PTCP-396
      S0(3,3,11)=-(AJ-3.D0)*S0(3,4,11)                                  PTCP-397
      S0(3,5,11)=-S0(3,3,11)                                            PTCP-398
      S0(3,2,11)=-.5D0*AJ*(AJ-2.D0)*S0(3,3,11)                          PTCP-399
      S0(3,6,11)=S0(3,5,11)                                             PTCP-400
      S0(3,12,11)=-2.D0*S0(3,11,11)                                     PTCP-401
      S0(3,11,12)=CJ*XG(1)*DJ/((16.D0*AJ-8.D0)*(2.D0*AJ+3.D0))          PTCP-402
      S0(3,12,12)=-2.D0*S0(3,11,12)                                     PTCP-403
      S0(3,6,12)=-(2.D0-BJ)*S0(3,12,12)                                 PTCP-404
      S0(3,5,12)=S0(3,6,12)                                             PTCP-405
      S0(3,3,12)=-S0(3,5,12)                                            PTCP-406
      S0(3,2,12)=-.5D0*BJ*S0(3,6,12)                                    PTCP-407
      S0(3,6,13)=S0(3,5,13)                                             PTCP-408
      S0(3,11,13)=S0(3,8,13)/(AJ+2.D0)                                  PTCP-409
      S0(3,12,13)=-2.D0*S0(3,11,13)                                     PTCP-410
      S1(3,3,1)=-(AJ-1.D0)*XG(1)*DJ/(8.D0*AJ-4.D0)/H                    PTCP-411
      S1(3,6,1)=-S1(3,3,1)                                              PTCP-412
      S1(3,2,1)=-AJ*(AJ-1.D0)*S1(3,3,1)                                 PTCP-413
      S1(3,5,1)=-S1(3,3,1)                                              PTCP-414
      S1(3,6,2)=-S1(3,3,2)                                              PTCP-415
      S1(3,6,3)=-S1(3,3,3)                                              PTCP-416
      S1(3,2,4)=-(AJ-1.D0)*(AJ*(AJ-2.D0)*XG(1)-XG(2)+XG(4)+XG(5))*DJ/(8.PTCP-417
     1D0*AJ-4.D0)/H                                                     PTCP-418
      S1(3,6,7)=-S1(3,3,7)                                              PTCP-419
      S2(3,2,1)=-(AJ-1.D0)*XG(1)/((AJ+1.D0)*(8.D0*AJ-4.D0))/H**2        PTCP-420
   12 DO 16 L=1,3                                                       PTCP-421
      S2(L,1,2)=-S2(L,1,1)-S2(L,1,3)                                    PTCP-422
      S2(L,2,2)=-S2(L,2,1)-S2(L,2,3)                                    PTCP-423
      DO 13 I=1,6                                                       PTCP-424
   13 S1(L,I,8)=-S1(L,I,7)                                              PTCP-425
      DO 15 K=1,6                                                       PTCP-426
      K1=K                                                              PTCP-427
      IF (K1.GT.3) K1=K1-3                                              PTCP-428
      DO 14 I=3,6                                                       PTCP-429
   14 S1(L,I,K+8)=-S1(L,I,K)                                            PTCP-430
      S1(L,1,K+8)=-S1(L,1,K)-H*S2(L,1,K1)                               PTCP-431
      S1(L,2,K+8)=-S1(L,2,K)-H*S2(L,2,K1)                               PTCP-432
   15 CONTINUE                                                          PTCP-433
   16 CONTINUE                                                          PTCP-434
      RETURN                                                            PTCP-435
      END                                                               PTCP-436
