C 03/04/98                                                      DWBA98  PTII-000
      SUBROUTINE PTII(KTF,CMU,CVF,VX,AM,VS,VD,VT,INM,NT,CA)             PTII-001
C CALCULATION OF THE FORM-FACTORS IN THE HELICITY FORMALISM FOR NON     PTII-002
C NATURAL PARITY MATRIX-ELEMENTS. FOR THE ARGUMENTS, SEE PTIP.          PTII-003
C LOO(1) ARITHMETIC AVERAGE   LOO(2) SECOND TIME FOR ARITHM. AVERAGE    PTII-004
C LOO(3) DENSITY DEPENDENCE OF MIDDLE POINT                             PTII-005
C LOO(4) PREVIOUS STEPS WERE NOT DONE AGAIN  LOO(5) SAME FORM FACTOR    PTII-006
C LOO(6) USED IN PTIV   LOO(7),LO(8) FOR SAME LENGTH AS IN PTII         PTII-007
C INPUT, OUTPUT, WORKING SPACE DESCRIBED IN PTIP.                       PTII-008
C R1 INTEGRATED VARIABLE, R2 FACTOR VARIABLE                  ORDER OF  PTII-009
C MULTIPOLES               J-3 J-2 J-1  J  J+1 J+2 J+3     OPERATIONS   PTII-010
C  VT(1,2)          (1)    1-11   12-22   23-33   34-44  | 1   3   6   9PTII-011
C  R2 VT(1,2)       (25) 289-294 295-300 301-306 307-312 | 2   4   7  10PTII-012
C  R2**2 VT(1,2)    (1)          327-328 329-330         |     5   8    PTII-013
C  R1 VT(1,2)       (25)     247-252 253-258 259-264     |  11  14  17  PTII-014
C  R1/R2 VT(1,2)    (1)      122-132 133-143 144-154     |  12  15  18  PTII-015
C  R2*R1 VT(1,2)    (1)      321-322 323-324 325-326     |  13  16  19  PTII-016
C  R1**2 VT(1,2)    (37) 313-314 315-316 317-318 319-320 |20  23  27  31PTII-017
C  R1**2 VT(1,2)    (1)          331-332 333-334         |    24  28    PTII-018
C  R1**2/R2 VT(1,2) (25) 265-270 271-276 277-282 283-288 |21  25  29  32PTII-019
C  R1**2/R2**2 VT   (1)  155-165 166-176 177-187 188-198 |22  26  30  33PTII-020
C  R2/R1 VT(1,2)    (1)       45-55   56-66   67-77      |  34  35  36  PTII-021
C  R2**2/R1**2 VT   (1)   78-88   89-99  100-110 111-121 |37  38  39  40PTII-022
C  -R2 VT(3,4)      (1)       247-252 253-258 259-264    |  41  42  43  PTII-023
C  R1 VT(3,4)       (1)  199-204 205-210 211-216 217-222 |44  46  48  50PTII-024
C  -2 R2 R1 VT(3,4) (25) 313-314 315-316 317-318 319-320 |45  47  49  51PTII-025
C  R2**2/R1 VT(3,4) (1)  223-228 229-234 235-240 241-246 |52  53  54  55PTII-026
C  R2**2 VT(5,6)    (1)  313-314 315-316 317-318 319-320 |56  57  58  59PTII-027
C***********************************************************************PTII-028
      IMPLICIT REAL*8 (A-H,O-Z)                                         PTII-029
      LOGICAL LO,LOO(8)                                                 PTII-030
      DIMENSION VT(INM,12),AM(INM,18,1),KTF(7,7,1),CMU(1),CVF(7,6,1),VX(PTII-031
     1INM,1),VS(INM,2),VD(INM,1),VA(2,7),BB(59),IBD(59),IBF(59),IBK(59),PTII-032
     2IBA(59),IB1(59),IB2(59),IBT(59),XX(2,334),X0(2,11,18),X1(2,6,19),XPTII-033
     32(2,2,4),X3(2,2,7),S0(2,11,18),S1(2,6,19),S2(2,2,4),ST(2,320),IBB(PTII-034
     459,7),XH(11),JBA(59),JBT(59)                                      PTII-035
      EQUIVALENCE (XX(1,1),X0(1,1,1)),(XX(1,199),X1(1,1,1)),(XX(1,313),XPTII-036
     12(1,1,1)),(XX(1,321),X3(1,1,1)),(ST(1,1),S0(1,1,1)),(ST(1,199),S1(PTII-037
     21,1,1)),(ST(1,313),S2(1,1,1)),(IBB(1,1),IBD),(IBB(1,2),IBF),(IBB(1PTII-038
     3,3),IBK),(IBB(1,4),JBA),(IBB(1,5),IB1),(IBB(1,6),IB2),(IBB(1,7),JBPTII-039
     4T)                                                                PTII-040
      COMMON /NOMBR/ H,CCO(5),JMAX,KV,KR,KS,NBCONF,NBPROT,J,KY,ILL(3,4),PTII-041
     1LO(40)                                                            PTII-042
      COMMON /GABJ/ AA,AB,AJ,BJ,CJ,DJ,XG(11),JX                         PTII-043
      DATA BB /40*1.,3*-1.,1.,-2.,1.,-2.,1.,-2.,1.,-2.,8*1./            PTII-044
      DATA XH /2*1.,3*-1.,5*1.,-1./                                     PTII-045
      DATA JBA /40*1,15*2,4*3/                                          PTII-046
      DATA JBT /1,3,1,3,2*1,3,2*1,2*3,2*1,3,2*1,3,2*1,5,3,1,5,1,3,1,5,1,PTII-047
     13,1,5,3,12*1,3,1,3,1,3,1,3,8*1/                                   PTII-048
      DATA IBD /1,289,12,295,327,23,301,329,34,307,247,122,321,253,133,3PTII-049
     123,259,144,325,313,265,155,315,331,271,166,317,333,277,177,319,283PTII-050
     2,188,45,56,67,78,89,100,111,247,253,259,199,313,205,315,211,317,21PTII-051
     37,319,223,229,235,241,313,315,317,319/                            PTII-052
      DATA IBF /11,294,22,300,328,33,306,330,44,312,252,132,322,258,143,PTII-053
     1324,264,154,326,314,270,165,316,332,276,176,318,334,282,187,320,28PTII-054
     28,198,55,66,77,88,99,110,121,252,258,264,204,314,210,316,216,318,2PTII-055
     322,320,228,234,240,246,314,316,318,320/                           PTII-056
      DATA IBK /2*1,3*3,3*5,2*7,3*2,3*4,3*6,3*1,4*3,4*5,3*7,2,4,6,1,3,5,PTII-057
     17,2,4,6,2*1,2*3,2*5,2*7,1,3,5,7,1,3,5,7/                          PTII-058
      DATA IBA,IK,IS1 /40*1,15*3,4*5,2*0/                               PTII-059
      DATA IB1 /10*0,9*1,14*2,3*-1,4*-2,3*0,8*1,4*-1,4*0/               PTII-060
      DATA IB2 /0,1,0,1,2,0,1,2,0,1,0,-1,1,0,-1,1,0,-1,1,0,-1,-2,0,0,-1,PTII-061
     1-2,0,0,-1,-2,0,-1,-2,3*1,4*2,3*1,0,1,0,1,0,1,0,1,8*2/             PTII-062
      DATA IBT /1,25,1,25,2*1,25,2*1,2*25,2*1,25,2*1,25,2*1,37,25,1,37,1PTII-063
     1,25,1,37,1,25,1,37,25,12*1,25,1,25,1,25,1,25,8*1/                 PTII-064
      CB=CA/CJ                                                          PTII-065
      IF (LO(7).OR.(.NOT.LO(22))) GO TO 3                               PTII-066
C ZERO ARRAY FOR THE EXCHANGE CASE.                                     PTII-067
      DO 2 L=1,40                                                       PTII-068
      DO 1 I=1,INM                                                      PTII-069
    1 VD(I,L)=0.D0                                                      PTII-070
    2 CONTINUE                                                          PTII-071
    3 IF (KS.EQ.0) RETURN                                               PTII-072
      CALL PTCI(KTF(1,NT,1),KS,H,S0,S1,S2)                              PTII-073
C LOOP OVER RADIAL DEPENDENCES                                          PTII-074
      DO 41 KX=1,KY                                                     PTII-075
      KZ=KX-1                                                           PTII-076
C LOOP OVER RANGES                                                      PTII-077
      DO 40 K=1,KS                                                      PTII-078
      DO 4 I=1,14                                                       PTII-079
    4 VA(I,1)=0.D0                                                      PTII-080
      IX=0                                                              PTII-081
C LOOP OVER THE INTERACTIONS FOR SUM OF THEIR STRENGTHS                 PTII-082
      DO 5 JJ=1,7                                                       PTII-083
      IF (KTF(JJ,NT,K).NE.KX) GO TO 5                                   PTII-084
      IX=JJ                                                             PTII-085
      VA(1,JJ)=VA(1,JJ)+CB*CVF(JJ,NT,K)                                 PTII-086
      VA(2,JJ)=VA(2,JJ)+CB*CVF(JJ,NT+3,K)                               PTII-087
    5 CONTINUE                                                          PTII-088
      IF (IX.EQ.0) GO TO 40                                             PTII-089
      KW=KTF(IX,NT+3,K)-1                                               PTII-090
      DO 9 L=1,2                                                        PTII-091
      DO 6 I=1,334                                                      PTII-092
    6 XX(L,I)=0.D0                                                      PTII-093
      VA(L,1)=.25D0*(VA(L,2)-VA(L,1))*CJ                                PTII-094
      VA(L,2)=VA(L,1)*DJ*XG(1)                                          PTII-095
      VA(L,3)=VA(L,3)-.5D0*VA(L,5)                                      PTII-096
      X0(L,1,2)=VA(L,1)*(AJ+XG(1))/CJ                                   PTII-097
      X0(L,1,3)=VA(L,1)*(AJ+1.D0-XG(1))/CJ                              PTII-098
      X0(L,2,2)=(AJ+1.D0)*X0(L,1,2)*DJ                                  PTII-099
      X0(L,2,3)=-X0(L,1,3)/(AJ+1.D0)                                    PTII-100
      IF (IX.LE.2) GO TO 9                                              PTII-101
C SPIN-ORBIT AND TENSOR CONSTANTS                                       PTII-102
      X3(L,1,2)=-VA(L,4)*CJ*(14.D0*BJ-10.D0+XG(1))/((2.D0*AJ-1.D0)*(2.D0PTII-103
     1*AJ+3.D0))                                                        PTII-104
      X3(L,2,2)=VA(L,4)*CJ*(XG(1)*(10.D0-9.D0*DJ)-1.D0)/((2.D0*AJ-1.D0)*PTII-105
     1(2.D0*AJ+3.D0))                                                   PTII-106
      X3(L,1,3)=-VA(L,4)*(AJ+1.D0-XG(1))*(AJ+2.D0)/(2.D0*AJ+3.D0)       PTII-107
      X3(L,2,3)=-X3(L,1,3)/(AJ+1.D0)                                    PTII-108
      X3(L,1,7)=VA(L,4)*(2.D0*(AJ+1.D0)+XG(1))                          PTII-109
      X3(L,2,7)=-X3(L,1,7)/(AJ+1.D0)                                    PTII-110
      X3(L,1,5)=2.D0*VA(L,4)*(AJ+1.D0-XG(1))                            PTII-111
      X3(L,2,5)=.5D0*X3(L,1,5)/(AJ+1.D0)                                PTII-112
      IF (JX.EQ.0) GO TO 7                                              PTII-113
      X3(L,1,1)=-VA(L,4)*(AJ+XG(1))*(AJ-1.D0)/(2.D0*AJ-1.D0)            PTII-114
      X3(L,2,1)=X3(L,1,1)*DJ*(AJ+1.D0)                                  PTII-115
      X3(L,1,4)=2.D0*VA(L,4)*(AJ+XG(1))                                 PTII-116
      X3(L,2,4)=-.5D0*X3(L,1,4)*DJ*(AJ+1.D0)                            PTII-117
      X3(L,1,6)=VA(L,4)*(2.D0*AJ-XG(1))                                 PTII-118
      X3(L,2,6)=X3(L,1,6)*DJ*(AJ+1.D0)                                  PTII-119
      X0(L,1,2)=X0(L,1,2)+.125D0*VA(L,3)*(XG(2)-2.D0*BJ-(AJ+2.D0)*XG(1))PTII-120
      X0(L,2,2)=X0(L,2,2)-.125D0*VA(L,3)*(AJ+2.D0+(2.D0*XG(1)-XG(2))*DJ*PTII-121
     1(AJ+1.D0))                                                        PTII-122
      X0(L,3,2)=.125D0*VA(L,3)*(1.D0+XG(1)*DJ*(AJ+1.D0))                PTII-123
      X0(L,1,3)=X0(L,1,3)+.125D0*VA(L,3)*(2.D0*BJ-XG(2)-(AJ-1.D0)*XG(1))PTII-124
      X0(L,2,3)=X0(L,2,3)-.125D0*VA(L,3)*(AJ-1.D0+(2.D0*XG(1)-XG(2))/(AJPTII-125
     1+1.D0))                                                           PTII-126
      X0(L,3,3)=-.125D0*VA(L,3)*(1.D0-XG(1)/(AJ+1.D0))                  PTII-127
      X0(L,2,6)=.125D0*VA(L,3)*CJ*(1.D0+(XG(1)-XG(2))*DJ)               PTII-128
      X0(L,1,13)=.125D0*VA(L,3)*CJ*XG(1)                                PTII-129
      X0(L,2,13)=.125D0*VA(L,3)*CJ*XG(1)*DJ                             PTII-130
      X0(L,3,13)=-.125D0*VA(L,3)*CJ*XG(1)*DJ                            PTII-131
    7 IF (IX.LE.4) GO TO 9                                              PTII-132
C CHANGE FROM S=0 OR S=1 TO CTE AND S1.S2                               PTII-133
      IF (LO(25)) VA(L,7)=VA(L,7)-VA(L,5)                               PTII-134
      A=.5D0*VA(L,5)                                                    PTII-135
      VA(L,5)=A+.25D0*VA(L,6)+.75D0*VA(L,7)                             PTII-136
      VA(L,7)=.25D0*(VA(L,7)-VA(L,6))                                   PTII-137
      VA(L,6)=A                                                         PTII-138
      DO 8 I=1,320                                                      PTII-139
    8 XX(L,I)=XX(L,I)+VA(L,6)*ST(1,I)+VA(L,7)*ST(2,I)                   PTII-140
      IF ((VA(L,5).EQ.0.).OR.(JX.EQ.0)) GO TO 9                         PTII-141
      X0(L,1,2)=X0(L,1,2)+.125D0*CJ*VA(L,5)*(BJ+XG(1)-XG(2))            PTII-142
      X0(L,2,2)=X0(L,2,2)+.125D0*CJ*VA(L,5)*(BJ+XG(1)-XG(2))*DJ         PTII-143
      X0(L,3,2)=X0(L,3,2)-.125D0*CJ*VA(L,5)*(BJ+XG(1)-XG(2))*DJ         PTII-144
      X0(L,1,3)=X0(L,1,3)+.125D0*CJ*VA(L,5)*(BJ+XG(1)-XG(2))            PTII-145
      X0(L,2,3)=X0(L,2,3)+.125D0*CJ*VA(L,5)*(BJ+XG(1)-XG(2))*DJ         PTII-146
      X0(L,3,3)=X0(L,3,3)-.125D0*CJ*VA(L,5)*(BJ+XG(1)-XG(2))*DJ         PTII-147
      X0(L,1,6)=X0(L,1,6)-.125D0*CJ*VA(L,5)*(BJ+XG(1)-XG(2))            PTII-148
      X0(L,2,6)=X0(L,2,6)-.125D0*CJ*VA(L,5)*(BJ+XG(1)-XG(2))*DJ         PTII-149
      X0(L,3,6)=X0(L,3,6)+.125D0*CJ*VA(L,5)*(BJ+XG(1)-XG(2))*DJ         PTII-150
      X0(L,1,13)=X0(L,1,13)-.125D0*CJ*VA(L,5)*(BJ+XG(1)-XG(2))          PTII-151
      X0(L,2,13)=X0(L,2,13)-.125D0*CJ*VA(L,5)*(BJ+XG(1)-XG(2))*DJ       PTII-152
      X0(L,3,13)=X0(L,3,13)+.125D0*CJ*VA(L,5)*(BJ+XG(1)-XG(2))*DJ       PTII-153
    9 CONTINUE                                                          PTII-154
      LOO(1)=KTF(IX,7,K).GT.0                                           PTII-155
      LOO(2)=.FALSE.                                                    PTII-156
      LOO(3)=KTF(IX,7,K).LT.0                                           PTII-157
      IF (.NOT.LO(7)) GO TO 10                                          PTII-158
      CALL PTIV(K,AM,CMU,H,LOO,IBB,BB,59,XX,VD,VS,VX,VT,INM,KW,XH,KZ)   PTII-159
      GO TO 40                                                          PTII-160
   10 LOO(4)=.FALSE.                                                    PTII-161
      LOO(6)=(ABS(VA(1,1))+ABS(VA(2,1))+ABS(VA(1,2))+ABS(VA(2,2)).EQ.0.)PTII-162
      LOO(7)=.FALSE.                                                    PTII-163
      LOO(8)=.FALSE.                                                    PTII-164
      IH=1                                                              PTII-165
      IA=0                                                              PTII-166
      DO 39 JJ=1,59                                                     PTII-167
      J1=IBD(JJ)                                                        PTII-168
      J2=IBF(JJ)                                                        PTII-169
      LOO(5)=.FALSE.                                                    PTII-170
      DO 38 JB=J1,J2                                                    PTII-171
      IF ((XX(1,JB).EQ.0.).AND.(XX(2,JB).EQ.0.)) GO TO 38               PTII-172
      IF (LOO(5)) GO TO 34                                              PTII-173
      LOO(4)=IA.EQ.IBA(JJ)                                              PTII-174
      IF (LOO(4)) GO TO 15                                              PTII-175
      IA=IBA(JJ)                                                        PTII-176
      IB=IA                                                             PTII-177
      IF (KZ.EQ.0.OR.LOO(2).OR.LOO(3)) GO TO 15                         PTII-178
C MULTIPLICATION BY THE RADIAL DEPENDENCES                              PTII-179
      IB=7                                                              PTII-180
      IKX=1                                                             PTII-181
      IX=IA                                                             PTII-182
      IY=IB                                                             PTII-183
   11 DO 12 I=1,INM                                                     PTII-184
      VT(I,IY)=VT(I,IX)*VX(I,KZ)                                        PTII-185
   12 VT(I,IY+1)=VT(I,IX+1)*VX(I,KZ)                                    PTII-186
      IF (KW.EQ.KZ) GO TO 14                                            PTII-187
      DO 13 I=1,INM                                                     PTII-188
      VT(I,IY)=VT(I,IY)-VT(I,IX+1)*VX(I,KW)                             PTII-189
   13 VT(I,IY+1)=VT(I,IY+1)+VT(I,IX)*VX(I,KW)                           PTII-190
   14 GO TO ( 15 , 24 , 33 ) , IKX                                      PTII-191
   15 LOO(4)=LOO(4).AND.(IS1.EQ.IB1(JJ))                                PTII-192
      IF (LOO(4)) GO TO 21                                              PTII-193
      IS1=IB1(JJ)                                                       PTII-194
      IX=IB                                                             PTII-195
      IY=9                                                              PTII-196
      IC=IX                                                             PTII-197
      IF (IS1.EQ.0) GO TO 21                                            PTII-198
      IS=IS1                                                            PTII-199
      IC=9                                                              PTII-200
      IKX=1                                                             PTII-201
C MULTIPLICATION BY A POWER OF R                                        PTII-202
   16 IF (IS.LT.0) GO TO 18                                             PTII-203
      DO 17 I=1,INM                                                     PTII-204
      VT(I,IY)=VT(I,IX)*VS(I,IS)                                        PTII-205
   17 VT(I,IY+1)=VT(I,IX+1)*VS(I,IS)                                    PTII-206
      GO TO 20                                                          PTII-207
   18 IS=-IS                                                            PTII-208
      DO 19 I=1,INM                                                     PTII-209
      VT(I,IY)=VT(I,IX)/VS(I,IS)                                        PTII-210
   19 VT(I,IY+1)=VT(I,IX+1)/VS(I,IS)                                    PTII-211
   20 IF (IKX.GE.2) GO TO 34                                            PTII-212
   21 LOO(4)=LOO(4).AND.(IK.EQ.IBK(JJ))                                 PTII-213
      IF (LOO(4)) GO TO 33                                              PTII-214
      ID=11                                                             PTII-215
      IK=IBK(JJ)                                                        PTII-216
      IKX=2                                                             PTII-217
      IF (LOO(3)) GO TO 25                                              PTII-218
      VT(INM,11)=0.D0                                                   PTII-219
      VT(INM,12)=0.D0                                                   PTII-220
      I=INM                                                             PTII-221
      DO 22 L=2,INM                                                     PTII-222
      VT(I-1,11)=VT(I,11)+AM(I,IK,K)*VT(I,IC)                           PTII-223
      VT(I-1,12)=VT(I,12)+AM(I,IK,K)*VT(I,IC+1)                         PTII-224
   22 I=I-1                                                             PTII-225
      Z1=0.D0                                                           PTII-226
      Y1=0.D0                                                           PTII-227
      DO 23 I=1,INM                                                     PTII-228
      Z1=Z1+AM(I,IK+7,K)*VT(I,IC)                                       PTII-229
      Y1=Y1+AM(I,IK+7,K)*VT(I,IC+1)                                     PTII-230
      VT(I,11)=VT(I,11)*AM(I,IK+7,K)+Z1*AM(I,IK,K)                      PTII-231
   23 VT(I,12)=VT(I,12)*AM(I,IK+7,K)+Y1*AM(I,IK,K)                      PTII-232
      IH=IC                                                             PTII-233
      IF ((KZ.EQ.0).OR.(LOO(1).AND.(.NOT.LOO(2)))) GO TO 33             PTII-234
      IX=11                                                             PTII-235
      IY=13                                                             PTII-236
      GO TO 11                                                          PTII-237
   24 ID=13                                                             PTII-238
      IF (LOO(6)) GO TO 33                                              PTII-239
      LOO(6)=.TRUE.                                                     PTII-240
      IKX=3                                                             PTII-241
      IX=IB                                                             PTII-242
      IY=17                                                             PTII-243
      IH=17                                                             PTII-244
      GO TO 11                                                          PTII-245
   25 DO 31 I=1,INM                                                     PTII-246
      VT(I,11)=0.D0                                                     PTII-247
      VT(I,12)=0.D0                                                     PTII-248
      DO 30 L=1,INM                                                     PTII-249
      IF (I.GT.L) GO TO 26                                              PTII-250
      XX1=VT(L,IC)*AM(L,IK,K)*AM(I,IK+7,K)                              PTII-251
      YY1=VT(L,IC+1)*AM(L,IK,K)*AM(I,IK+7,K)                            PTII-252
      GO TO 27                                                          PTII-253
   26 XX1=VT(L,IC)*AM(I,IK,K)*AM(L,IK+7,K)                              PTII-254
      YY1=VT(L,IC+1)*AM(I,IK,K)*AM(L,IK+7,K)                            PTII-255
   27 IF (KZ.EQ.KW) GO TO 28                                            PTII-256
      XX2=XX1*VX(I+L,KZ)-YY1*VX(I+L,KW)                                 PTII-257
      YY2=YY1*VX(I+L,KZ)+XX1*VX(I+L,KW)                                 PTII-258
      GO TO 29                                                          PTII-259
   28 XX2=XX1*VX(I+L,KZ)                                                PTII-260
      YY2=YY1*VX(I+L,KZ)                                                PTII-261
   29 VT(I,11)=VT(I,11)+XX2                                             PTII-262
   30 VT(I,12)=VT(I,12)+YY2                                             PTII-263
   31 CONTINUE                                                          PTII-264
      IF ((JB.NE.12).AND.(JB.NE.13).AND.(JB.NE.23).AND.(JB.NE.24)) GO TOPTII-265
     1 33                                                               PTII-266
      IH=17                                                             PTII-267
      DO 32 I=1,INM                                                     PTII-268
      VT(I,IH)=VT(I,IC)*VX(2*I,KZ)                                      PTII-269
      VT(I,IH+1)=VT(I,IC+1)*VX(2*I,KZ)                                  PTII-270
      IF (KZ.EQ.KW) GO TO 32                                            PTII-271
      VT(I,IH)=VT(I,IH)-VT(I,IC+1)*VX(2*I,KW)                           PTII-272
      VT(I,IH+1)=VT(I,IH+1)+VT(I,IC)*VX(2*I,KW)                         PTII-273
   32 CONTINUE                                                          PTII-274
   33 IE=ID                                                             PTII-275
      IS=IB2(JJ)                                                        PTII-276
      IF (IS.EQ.0) GO TO 34                                             PTII-277
      IY=15                                                             PTII-278
      IX=IE                                                             PTII-279
      IE=IY                                                             PTII-280
      GO TO 16                                                          PTII-281
   34 IG=IBT(JJ)+2*(JB-J1)                                              PTII-282
      LOO(5)=.TRUE.                                                     PTII-283
      IF ((JB.NE.12).AND.(JB.NE.13).AND.(JB.NE.23).AND.(JB.NE.24)) GO TOPTII-284
     1 36                                                               PTII-285
      I=JB-11                                                           PTII-286
      IF (I.GT.11) I=I-11                                               PTII-287
      IF (LOO(I+6)) GO TO 36                                            PTII-288
      LOO(I+6)=.TRUE.                                                   PTII-289
      COR=H*H*CMU(K)/12.D0                                              PTII-290
      Z1=COR*VA(1,I)                                                    PTII-291
      Y1=COR*VA(2,I)                                                    PTII-292
      IF ((Z1.EQ.0.).AND.(Y1.EQ.0.)) GO TO 36                           PTII-293
      DO 35 I=1,INM                                                     PTII-294
      VD(I,IG)=VD(I,IG)-(Z1*VT(I,IH)-Y1*VT(I,IH+1))/VS(I,2)             PTII-295
   35 VD(I,IG+1)=VD(I,IG+1)-(Z1*VT(I,IH+1)+Y1*VT(I,IH))/VS(I,2)         PTII-296
   36 Z1=BB(JJ)*XX(1,JB)                                                PTII-297
      Y1=BB(JJ)*XX(2,JB)                                                PTII-298
      DO 37 I=1,INM                                                     PTII-299
      VD(I,IG)=VD(I,IG)+Z1*VT(I,IE)-Y1*VT(I,IE+1)                       PTII-300
   37 VD(I,IG+1)=VD(I,IG+1)+Z1*VT(I,IE+1)+Y1*VT(I,IE)                   PTII-301
   38 CONTINUE                                                          PTII-302
   39 CONTINUE                                                          PTII-303
      IF (.NOT.LOO(1)) GO TO 40                                         PTII-304
      LOO(2)=.NOT.LOO(2)                                                PTII-305
      IF (LOO(2)) GO TO 10                                              PTII-306
   40 CONTINUE                                                          PTII-307
   41 CONTINUE                                                          PTII-308
      RETURN                                                            PTII-309
      END                                                               PTII-310
