C 29/03/98                                                      DWBA98  PTC0-000
      SUBROUTINE PTC0(R0,S0,SL)                                         PTC0-001
C CALCULATION OF THE COEFFICIENTS FOR A ZERO RANGE INTERACTION.         PTC0-002
C DATA PASSED OVER BY THE COMMON /NOMBR/:                               PTC0-003
C  LO        LOGICAL CONTROLS: LO(31)=.TRUE. NATURAL PARITY.            PTC0-004
C DATA PASSED OVER BY COMMON /GABJ/:                                    PTC0-005
C  JX           SPIN TRANSFER J.                                        PTC0-006
C  AJ,BJ,CJ,DJ  SPIN TRANSFER J, J*(J+1), 2*J+1, 1./(J*(J+1))           PTC0-007
C OUTPUT: R0,S0,SL                                                      PTC0-008
C***********************************************************************PTC0-009
      IMPLICIT REAL*8 (A-H,O-Z)                                         PTC0-010
      LOGICAL LO                                                        PTC0-011
      DIMENSION R0(3,4),S0(4,9),SL(2,10)                                PTC0-012
      COMMON /NOMBR/ H,CCO(5),JMAX,KV,KR,KS,NBCONF,NBPROT,J,KY,ILL(3,4),PTC0-013
     1LO(40)                                                            PTC0-014
      COMMON /GABJ/ AA,AB,AJ,BJ,CJ,DJ,XG(11),JX                         PTC0-015
      DO 1 I=1,12                                                       PTC0-016
    1 R0(I,1)=0.D0                                                      PTC0-017
      DO 2 I=1,36                                                       PTC0-018
    2 S0(I,1)=0.D0                                                      PTC0-019
      DO 3 I=1,20                                                       PTC0-020
    3 SL(I,1)=0.D0                                                      PTC0-021
C CALCULATION OF THE CONSTANTS FOR THE CENTRAL POTENTIAL                PTC0-022
      IF (LO(31)) GO TO 4                                               PTC0-023
      R0(1,1)=-.25D0                                                    PTC0-024
      R0(2,1)=.25D0                                                     PTC0-025
      IF (JX.EQ.0) GO TO 5                                              PTC0-026
      R0(1,2)=-.25D0*XG(1)*DJ                                           PTC0-027
      GO TO 5                                                           PTC0-028
    4 R0(1,1)=.25D0                                                     PTC0-029
      R0(2,1)=.75D0                                                     PTC0-030
      IF (JX.EQ.0) GO TO 5                                              PTC0-031
      R0(1,2)=.25D0*XG(1)*DJ                                            PTC0-032
    5 R0(2,2)=-R0(1,2)                                                  PTC0-033
C CALCULATION OF CONSTANTS FOR THE SKYRME FORCE                         PTC0-034
      IF (LO(31)) GO TO 7                                               PTC0-035
C NON-NATURAL PARITY                                                    PTC0-036
      R0(1,3)=.25D0*(BJ+2.D0-2.D0*XG(1))                                PTC0-037
      S0(1,1)=-.25D0+.25D0*XG(1)-.0625D0*(XG(2)-XG(6))                  PTC0-038
      S0(1,7)=.0625D0                                                   PTC0-039
      R0(2,3)=-.25D0*(BJ+2.D0-2.D0*XG(1))                               PTC0-040
      S0(2,1)=-.5D0*BJ-.25D0-.25D0*XG(1)+.4375D0*XG(2)+.0625D0*XG(6)    PTC0-041
      S0(2,7)=.0625D0                                                   PTC0-042
      R0(3,1)=16.D0                                                     PTC0-043
      R0(3,3)=8.D0*BJ-32.D0+32.D0*XG(1)                                 PTC0-044
      S0(3,1)=4.D0*BJ+20.D0-10.D0*XG(1)-2.D0*XG(2)+6.D0*XG(4)-2.D0*XG(6)PTC0-045
      S0(3,7)=-2.D0                                                     PTC0-046
      SL(1,6)=-12.D0*XG(4)                                              PTC0-047
      SL(1,10)=12.D0                                                    PTC0-048
      IF (JX.NE.0) GO TO 6                                              PTC0-049
      S0(1,5)=.0625D0*XG(4)                                             PTC0-050
      S0(2,5)=.0625D0*XG(4)                                             PTC0-051
      S0(3,5)=-6.D0+7.D0*XG(4)                                          PTC0-052
      GO TO 9                                                           PTC0-053
    6 R0(1,4)=-.5D0+.25D0*XG(1)                                         PTC0-054
      S0(1,2)=.0625D0*(4.D0-(2.D0*(BJ-1.D0)*XG(1)+4.D0*XG(2)-XG(7)-XG(8)PTC0-055
     1)*DJ)                                                             PTC0-056
      S0(1,3)=-.0625D0*(1.D0+(4.D0*XG(1)-2.D0*XG(2))*DJ)                PTC0-057
      S0(1,4)=.125D0*XG(3)*DJ                                           PTC0-058
      S0(1,5)=.125D0*(XG(4)-(XG(4)+XG(5))*DJ)                           PTC0-059
      S0(1,8)=.0625D0*XG(1)*DJ                                          PTC0-060
      S0(1,9)=.0625D0*XG(1)*DJ                                          PTC0-061
      R0(2,4)=.5D0-.25D0*XG(1)                                          PTC0-062
      S0(2,2)=-.25D0-.0625D0*((2.D0*BJ+6.D0)*XG(1)-4.D0*XG(2)-XG(7)-XG(8PTC0-063
     1))*DJ                                                             PTC0-064
      S0(2,3)=.4375D0+.125D0*(2.D0*XG(1)-3.D0*XG(2))*DJ                 PTC0-065
      S0(2,4)=.125D0*XG(3)*DJ                                           PTC0-066
      S0(2,5)=.125D0*(XG(4)-(XG(4)+XG(5))*DJ)                           PTC0-067
      S0(2,8)=.0625D0*XG(1)*DJ                                          PTC0-068
      S0(2,9)=.0625D0*XG(1)*DJ                                          PTC0-069
      R0(3,2)=-8.D0*XG(1)*DJ                                            PTC0-070
      R0(3,4)=8.D0-16.D0*XG(1)                                          PTC0-071
      S0(3,2)=-10.D0+4.D0*XG(1)-2.D0*(9.D0*XG(1)-5.D0*XG(2)+3.D0*XG(3)+XPTC0-072
     1G(7)-2.D0*XG(8))*DJ                                               PTC0-073
      S0(3,3)=-2.D0+10.D0*XG(1)*DJ                                      PTC0-074
      S0(3,4)=(6.D0*XG(1)-4.D0*XG(3))*DJ                                PTC0-075
      S0(3,5)=-6.D0+8.D0*XG(4)-2.D0*(XG(4)+XG(5))*DJ                    PTC0-076
      S0(3,8)=-2.D0*XG(1)*DJ                                            PTC0-077
      S0(3,9)=4.D0*XG(1)*DJ                                             PTC0-078
      SL(1,7)=12.D0*XG(3)*DJ                                            PTC0-079
      SL(1,9)=-12.D0*XG(1)*DJ                                           PTC0-080
      SL(1,1)=-24.D0*XG(1)                                              PTC0-081
      SL(1,2)=24.D0                                                     PTC0-082
      IF (JX.EQ.1) GO TO 9                                              PTC0-083
      S0(1,6)=.125D0*(-XG(4)+2.D0*XG(5)/(BJ-2.D0))*DJ                   PTC0-084
      S0(2,6)=.125D0*(-XG(4)+2.D0*XG(5)/(BJ-2.D0))*DJ                   PTC0-085
      S0(3,6)=-(2.D0*XG(4)-4.D0*XG(5)/(BJ-2.D0))*DJ                     PTC0-086
      GO TO 9                                                           PTC0-087
C NATURAL PARITY                                                        PTC0-088
    7 S0(1,1)=-.25D0+.0625D0*XG(2)+.25D0*XG(4)-.0625D0*XG(6)            PTC0-089
      S0(1,7)=-.0625D0                                                  PTC0-090
      S0(2,1)=-.5D0*BJ-.25D0+.3125D0*XG(2)-.25D0*XG(4)+.1875D0*XG(6)    PTC0-091
      S0(2,7)=.1875D0                                                   PTC0-092
      S0(3,1)=4.D0*BJ+20.D0+6.D0*XG(1)-4.D0*XG(2)-10.D0*XG(4)           PTC0-093
      IF (JX.NE.0) GO TO 8                                              PTC0-094
      S0(1,5)=.25D0-.0625D0*XG(4)                                       PTC0-095
      S0(2,5)=-.25D0-.0625D0*XG(4)                                      PTC0-096
      S0(3,5)=-10.D0+5.D0*XG(4)                                         PTC0-097
      GO TO 9                                                           PTC0-098
    8 R0(1,3)=-.25D0*BJ                                                 PTC0-099
      R0(1,4)=-.25D0*XG(1)                                              PTC0-100
      S0(1,2)=.0625D0*(2.D0*(BJ-1.D0)*XG(1)+4.D0*XG(3)-XG(7)-XG(8))*DJ  PTC0-101
      S0(1,3)=.0625D0-.125D0*XG(2)*DJ                                   PTC0-102
      S0(1,4)=.125D0*(2.D0*XG(1)-XG(3))*DJ                              PTC0-103
      S0(1,5)=.25D0-.125D0*(XG(4)-(XG(4)+XG(5))*DJ)                     PTC0-104
      S0(1,8)=-.0625D0*XG(1)*DJ                                         PTC0-105
      S0(1,9)=-.0625D0*XG(1)*DJ                                         PTC0-106
      R0(2,3)=-.75D0*BJ                                                 PTC0-107
      R0(2,4)=.25D0*XG(1)                                               PTC0-108
      S0(2,2)=.0625D0*((2.D0*BJ+6.D0)*XG(1)-4.D0*XG(3)-XG(7)-XG(8))*DJ  PTC0-109
      S0(2,3)=.3125D0-.125D0*XG(2)*DJ                                   PTC0-110
      S0(2,4)=-.125D0*(2.D0*XG(1)-3.D0*XG(3))*DJ                        PTC0-111
      S0(2,5)=-.25D0-.125D0*(XG(4)-(XG(4)+XG(5))*DJ)                    PTC0-112
      S0(2,8)=-.0625D0*XG(1)*DJ                                         PTC0-113
      S0(2,9)=-.0625D0*XG(1)*DJ                                         PTC0-114
      R0(3,2)=8.D0*XG(1)*DJ                                             PTC0-115
      R0(3,4)=-8.D0*XG(1)                                               PTC0-116
      S0(3,2)=-6.D0+8.D0*XG(1)+2.D0*(9.D0*XG(1)+3.D0*XG(2)-5.D0*XG(3)-2.PTC0-117
     1D0*XG(7)+XG(8))*DJ                                                PTC0-118
      S0(3,3)=-4.D0-(6.D0*XG(1)-4.D0*XG(2))*DJ                          PTC0-119
      S0(3,4)=-10.D0*XG(1)*DJ                                           PTC0-120
      S0(3,5)=-10.D0+4.D0*XG(4)+2.D0*(XG(4)+XG(5))*DJ                   PTC0-121
      S0(3,8)=-4.D0*XG(1)*DJ                                            PTC0-122
      S0(3,9)=2.D0*XG(1)*DJ                                             PTC0-123
      SL(1,6)=-12.D0*XG(1)                                              PTC0-124
      SL(1,7)=12.D0-12.D0*XG(2)*DJ                                      PTC0-125
      SL(1,8)=12.D0*XG(1)*DJ                                            PTC0-126
      IF (JX.EQ.1) GO TO 9                                              PTC0-127
      S0(1,6)=.125D0*(XG(4)-2.D0*XG(5)/(BJ-2.D0))*DJ                    PTC0-128
      S0(2,6)=.125D0*(XG(4)-2.D0*XG(5)/(BJ-2.D0))*DJ                    PTC0-129
      S0(3,6)=(2.D0*XG(4)-4.D0*XG(5)/(BJ-2.D0))*DJ                      PTC0-130
C CONSTANTS FOR THE SPIN-ORBIT                                          PTC0-131
    9 IF (LO(31)) GO TO 10                                              PTC0-132
C NON-NATURAL PARITY                                                    PTC0-133
      IF (JX.EQ.0) RETURN                                               PTC0-134
      S0(4,1)=-.5D0*BJ-.25D0*(XG(1)-XG(2))                              PTC0-135
      S0(4,2)=.25D0*(XG(1)-XG(2))*DJ                                    PTC0-136
      S0(4,3)=.25D0                                                     PTC0-137
      SL(2,1)=.25D0*XG(1)                                               PTC0-138
      SL(2,2)=-.25D0+.25D0*XG(2)*DJ                                     PTC0-139
      SL(2,3)=-.25D0*XG(1)*DJ                                           PTC0-140
      RETURN                                                            PTC0-141
C NATURAL PARITY                                                        PTC0-142
   10 S0(4,1)=-.5D0*BJ-.5D0-.25D0*(XG(1)-XG(2))                         PTC0-143
      S0(4,5)=.25D0                                                     PTC0-144
      SL(2,1)=.25D0*XG(4)                                               PTC0-145
      SL(2,5)=-.25D0                                                    PTC0-146
      IF (JX.EQ.0) RETURN                                               PTC0-147
      S0(4,2)=.25D0-.25D0*(XG(1)-XG(3))*DJ                              PTC0-148
      S0(4,3)=.25D0                                                     PTC0-149
      SL(2,6)=.5D0*XG(1)                                                PTC0-150
      SL(2,7)=-.5D0                                                     PTC0-151
      SL(2,2)=-.25D0*XG(3)*DJ                                           PTC0-152
      SL(2,4)=.25D0*XG(1)*DJ                                            PTC0-153
      RETURN                                                            PTC0-154
      END                                                               PTC0-155
