C 29/03/98                                                      DWBA98  DERI-000
      SUBROUTINE DERI(Y,X,N)                                            DERI-001
C NUMERICAL DERIVATION OF THE FUNCTION Y KNOWN AT N POINTS              DERI-002
C THIS SUBROUTINE REQUIRES AT LEAST 7 POINTS                            DERI-003
C AND RETURNS THE VALUE OF H*(D(Y)/DR) IN X                             DERI-004
C THE POINT -1 IS ASSUMED TO BE 0                                       DERI-005
C***********************************************************************DERI-006
      IMPLICIT REAL*8 (A-H,O-Z)                                         DERI-007
      DIMENSION X(7),Y(7)                                               DERI-008
      N3=N-3                                                            DERI-009
      IF (N3.GE.4) GO TO 1                                              DERI-010
      WRITE (6,1000) N                                                  DERI-011
      STOP                                                              DERI-012
    1 X(1)=(-77.D0*Y(1)+150.D0*Y(2)-100.D0*Y(3)+50.D0*Y(4)-15.D0*Y(5)+2.DERI-013
     1D0*Y(6))/60.D0                                                    DERI-014
      X(2)=(-24.D0*Y(1)-35.D0*Y(2)+80.D0*Y(3)-30.D0*Y(4)+8.D0*Y(5)-Y(6))DERI-015
     1/60.D0                                                            DERI-016
      X(3)=.75D0*(Y(4)-Y(2))-.15D0*(Y(5)-Y(1))+Y(6)/60.D0               DERI-017
      DO 2 I=4,N3                                                       DERI-018
    2 X(I)=.75D0*(Y(I+1)-Y(I-1))-.15D0*(Y(I+2)-Y(I-2))+(Y(I+3)-Y(I-3))/6DERI-019
     10.D0                                                              DERI-020
      X(N-2)=(Y(N-6)-8.D0*Y(N-5)+30.D0*Y(N-4)-80.D0*Y(N3)+35.D0*Y(N-2)+2DERI-021
     14.D0*Y(N-1)-2.D0*Y(N))/60.D0                                      DERI-022
      X(N-1)=(-2.D0*Y(N-6)+15.D0*Y(N-5)-50.D0*Y(N-4)+100.D0*Y(N3)-150.D0DERI-023
     1*Y(N-2)+77.D0*Y(N-1)+10.D0*Y(N))/60.D0                            DERI-024
      X(N)=(10.D0*Y(N-6)-72.D0*Y(N-5)+225.D0*Y(N-4)-400.D0*Y(N3)+450.D0*DERI-025
     1Y(N-2)-360.D0*Y(N-1)+147.D0*Y(N))/60.D0                           DERI-026
      RETURN                                                            DERI-027
 1000 FORMAT (5X,I5,43H INSUFFICIENT POINTS FOR DERIVATIVE IN DERI//10X,DERI-028
     115H ...  STOP  ...)                                               DERI-029
      END                                                               DERI-030
