C 29/03/98                                                      DWBA98  DER2-000
      SUBROUTINE DER2(Y,X,N)                                            DER2-001
C NUMERICAL DOUBLE DERIVATIVE OF A FUNCTION Y KNOWN AT N POINTS         DER2-002
C THIS SUBROUTINE REQUIRES AT LEAST 7 POINTS                            DER2-003
C AND RETURNS THE VALUE OF H**2*(D**2(Y)/DR**2) IN X                    DER2-004
C THE POINT -1 IS ASSUMED TO BE 0                                       DER2-005
C***********************************************************************DER2-006
      IMPLICIT REAL*8 (A-H,O-Z)                                         DER2-007
      DIMENSION X(7),Y(7)                                               DER2-008
      N3=N-3                                                            DER2-009
      IF (N3.GE.4) GO TO 1                                              DER2-010
      WRITE (6,1000) N                                                  DER2-011
      STOP                                                              DER2-012
    1 X(1)=(-147.D0*Y(1)-255.D0*Y(2)+470.D0*Y(3)-285.D0*Y(4)+93.D0*Y(5)-DER2-013
     113.D0*Y(6))/180.D0                                                DER2-014
      X(2)=(228.D0*Y(1)-420.D0*Y(2)+200.D0*Y(3)+15.D0*Y(4)-12.D0*Y(5)+2.DER2-015
     1D0*Y(6))/180.D0                                                   DER2-016
      X(3)=1.5D0*(Y(4)+Y(2))-.15D0*(Y(5)+Y(1))+(Y(6)-245.D0*Y(3))/90.D0 DER2-017
      DO 2 I=4,N3                                                       DER2-018
    2 X(I)=1.5D0*(Y(I+1)+Y(I-1))-.15D0*(Y(I+2)+Y(I-2))+(Y(I+3)+Y(I-3)-24DER2-019
     15.D0*Y(I))/90.D0                                                  DER2-020
      X(N-2)=(2.D0*Y(N-6)-12.D0*Y(N-5)+15.D0*Y(N-4)+200.D0*Y(N3)-420.D0*DER2-021
     1Y(N-2)+228.D0*Y(N-1)-13.D0*Y(N))/180.D0                           DER2-022
      X(N-1)=(-13.D0*Y(N-6)+93.D0*Y(N-5)-285.D0*Y(N-4)+470.D0*Y(N3)-255.DER2-023
     1D0*Y(N-2)-147.D0*Y(N-1)+137.D0*Y(N))/180.D0                       DER2-024
      X(N)=(137.D0*Y(N-6)-972.D0*Y(N-5)+2970.D0*Y(N-4)-5080.D0*Y(N3)+526DER2-025
     15.D0*Y(N-2)-3132.D0*Y(N-1)+812.D0*Y(N))/180.D0                    DER2-026
      RETURN                                                            DER2-027
 1000 FORMAT (5X,I5,43H INSUFFICIENT POINTS FOR DERIVATIVE IN DER2//10X,DER2-028
     115H ...  STOP  ...)                                               DER2-029
      END                                                               DER2-030
