C 24/03/97                                                      DWBA98  DCGS-000
      FUNCTION DCGS(L,J1,J2,FAC,NFA)                                    DCGS-001
C                                                                       DCGS-002
C  THE FIRST THREE ARGUMENTS ARE DOUBLE VALUES AS INTEGERS.             DCGS-003
C                                                                       DCGS-004
C   CGS(L,J1,J2) =                                                      DCGS-005
C                 /________________   ( J2   L   J1  )                  DCGS-006
C (-)**(J1+1/2)  / (2*J1+1)*(2*J2+1)  (              )                  DCGS-007
C               V                     (-1/2  0   1/2 )                  DCGS-008
C  WHEN J1 AND J2 ARE HALF INTEGRAL,                                    DCGS-009
C                                                                       DCGS-010
C                ( J2  L  J1 )                                          DCGS-011
C   (-)**(J1-1)  (           )                                          DCGS-012
C                (  0  0  0  )                                          DCGS-013
C  WHEN J1 AND J2 ARE INTEGRAL.                                         DCGS-014
C                                                                       DCGS-015
C FAC IS THE TABLE OF LOGARITHMS OF FACTORIALS FROM 0 TO NFA-1.         DCGS-016
C                                                                       DCGS-017
C***********************************************************************DCGS-018
      IMPLICIT REAL*8 (A-H,O-Z)                                         DCGS-019
      DIMENSION FAC(1)                                                  DCGS-020
      IF (L.LT.0.OR.J1.LT.0.OR.J2.LT.0) GO TO 1                         DCGS-021
      LL=L+J1+J2+2                                                      DCGS-022
      LT=LL/2                                                           DCGS-023
      IF (2*LT.NE.LL) GO TO 1                                           DCGS-024
      IF (LT.GE.NFA) GO TO 1                                            DCGS-025
      L1=LT-J1                                                          DCGS-026
      L2=LT-J2                                                          DCGS-027
      L3=LT-L                                                           DCGS-028
      IF (L1.LE.0.OR.L2.LE.0.OR.L3.LE.0) GO TO 1                        DCGS-029
      L4=LT+1                                                           DCGS-030
      N1=(L1+1)/2                                                       DCGS-031
      N2=(L2+1)/2                                                       DCGS-032
      N3=(L3+1)/2                                                       DCGS-033
      N4=(L4+1)/2                                                       DCGS-034
      DCGS=DEXP(FAC(N4)-FAC(N1)-FAC(N2)-FAC(N3)-.5D0*(FAC(L4)-FAC(L1)-FADCGS-035
     1C(L2)-FAC(L3)))                                                   DCGS-036
      IF (2*(N1/2).NE.N1) DCGS=-DCGS                                    DCGS-037
      IF (N4-N1-N2-N3+1) 3 , 2 , 1                                      DCGS-038
    1 DCGS=0.D0                                                         DCGS-039
    2 DCGS=2.D0*DCGS                                                    DCGS-040
    3 RETURN                                                            DCGS-041
      END                                                               DCGS-042
