C 30/11/98                                               DWBA98/DWBB98  EMRO-000
      SUBROUTINE EMRO(N,N1,N2,X2,X3,RES,NX)                             EMRO-001
C  CALCULATES THE NX                                                    EMRO-002
C            N          N+1                     N+NX-1                  EMRO-003
C           R (THETA), R (THETA) ............. R (THETA)                EMRO-004
C            N1,N2      N1,N2                   N1,N2                   EMRO-005
C IN THE ARRAY RES                                                      EMRO-006
C IT USES THE RECURRENCE RELATION OBTAINED FROM                         EMRO-007
C                      J                   J'                           EMRO-008
C        COS(THETA) * R (THETA)  = SUM  R (THETA)                       EMRO-009
C                      F1,F2       ON J'   F1,F2                        EMRO-010
C THETA IS GIVEN BY X2=COS(0.5*THETA),X3=SIN(0.5*THETA)                 EMRO-011
C***********************************************************************EMRO-012
      IMPLICIT REAL*8 (A-H,O-Z)                                         EMRO-013
      DIMENSION RES(1)                                                  EMRO-014
      NR=1                                                              EMRO-015
      AJ=DFLOAT(N)*.5D0                                                 EMRO-016
      X1=X2*X2-X3*X3                                                    EMRO-017
      M1=IABS(N1+N2)/2                                                  EMRO-018
      M2=IABS(N1-N2)/2                                                  EMRO-019
      XJ=M1+M2                                                          EMRO-020
    1 IF (XJ.GT.2.D0*AJ+.1D0) GO TO 7                                   EMRO-021
      S1=0.D0                                                           EMRO-022
      S2=0.D0                                                           EMRO-023
      S3=1.D0                                                           EMRO-024
      IF (XJ.EQ.0.D0) GO TO 11                                          EMRO-025
C THE MAGNETIC QUANTUM NUMBERS ARE NOT BOTH ZEROS                       EMRO-026
      IF (M1.EQ.M2) GO TO 8                                             EMRO-027
C NO MAGNETIC QUANTUM NUMBER IS ZERO                                    EMRO-028
      IF (M2.EQ.0) GO TO 3                                              EMRO-029
      DO 2 I=1,M2                                                       EMRO-030
    2 S3=S3*X3*DSQRT(DFLOAT(M1+I)/DFLOAT(I))                            EMRO-031
    3 IF (M1.EQ.0) GO TO 5                                              EMRO-032
      DO 4 M=1,M1                                                       EMRO-033
    4 S3=S3*X2                                                          EMRO-034
    5 IF ((N1.GT.N2).AND.(2*(M2/2).NE.M2)) S3=-S3                       EMRO-035
      KX=1                                                              EMRO-036
      SJ=0.5D0*XJ                                                       EMRO-037
      X4=0.D0                                                           EMRO-038
      Z1=M1                                                             EMRO-039
      Z2=M2                                                             EMRO-040
      SL=0.5D0*(Z1-Z2)/(SJ+1.D0)                                        EMRO-041
    6 IF (AJ.LE.SJ+.1D0) GO TO 13                                       EMRO-042
C RECURRENCE                                                            EMRO-043
      SJ=SJ+1.D0                                                        EMRO-044
      S2=S3                                                             EMRO-045
      Z1=Z1+1.D0                                                        EMRO-046
      Z2=Z2+1.D0                                                        EMRO-047
      XJ=XJ+1.D0                                                        EMRO-048
      X4=X4+1.D0                                                        EMRO-049
      Y2=DSQRT(Z1*Z2*XJ*X4)                                             EMRO-050
      S3=(2.D0*SJ-1.D0)*SJ*((X1-SL)*S2-S1)/Y2                           EMRO-051
      S1=Y2*S2/((2.D0*SJ+1.D0)*SJ)                                      EMRO-052
      SL=SL*(SJ-1.D0)/(SJ+1.D0)                                         EMRO-053
      GO TO 6                                                           EMRO-054
    7 RES(NR)=0.D0                                                      EMRO-055
      NR=NR+1                                                           EMRO-056
      IF (NR.GT.NX) GO TO 14                                            EMRO-057
      AJ=AJ+1.D0                                                        EMRO-058
      GO TO 1                                                           EMRO-059
C A MAGNETIC QUANTUM NUMBER IS ZERO                                     EMRO-060
    8 DO 9 I=1,M1                                                       EMRO-061
    9 S3=S3*X3*X2*DSQRT(DFLOAT(M1+I)/DFLOAT(I))                         EMRO-062
      KX=2                                                              EMRO-063
      IF (N1.GT.N2.AND.(2*(M2/2).NE.M2)) S3=-S3                         EMRO-064
      X4=0                                                              EMRO-065
      SJ=M1                                                             EMRO-066
   10 IF (AJ.LE.SJ+.1D0) GO TO 13                                       EMRO-067
C RECURRENCE                                                            EMRO-068
      SJ=SJ+1.D0                                                        EMRO-069
      S2=S3                                                             EMRO-070
      XJ=XJ+1.D0                                                        EMRO-071
      X4=X4+1.D0                                                        EMRO-072
      Y2=DSQRT(XJ*X4)                                                   EMRO-073
      S3=((2.D0*SJ-1.D0)*X1*S2-S1)/Y2                                   EMRO-074
      S1=Y2*S2                                                          EMRO-075
      GO TO 10                                                          EMRO-076
C THE MAGNETIC QUANTUM NUMBERS ARE BOTH ZEROS                           EMRO-077
   11 KX=3                                                              EMRO-078
      SJ=0.D0                                                           EMRO-079
   12 IF (AJ.LE.SJ+.1D0) GO TO 13                                       EMRO-080
C RECURRENCE                                                            EMRO-081
      SJ=SJ+1.D0                                                        EMRO-082
      S2=S3                                                             EMRO-083
      S3=((2.D0*SJ-1.D0)*X1*S2-S1)/SJ                                   EMRO-084
      S1=S2*SJ                                                          EMRO-085
      GO TO 12                                                          EMRO-086
C STORAGE                                                               EMRO-087
   13 RES(NR)=S3                                                        EMRO-088
      NR=NR+1                                                           EMRO-089
      IF (NR.GT.NX) GO TO 14                                            EMRO-090
      AJ=AJ+1.D0                                                        EMRO-091
      GO TO ( 6 , 10 , 12 ),KX                                          EMRO-092
   14 RETURN                                                            EMRO-093
      END                                                               EMRO-094
