C 30/11/98                                                      DWBA98  GRAL-000
      SUBROUTINE GRAL(TGR,GRR,NTGS,NNK,IG)                              GRAL-001
C DRAW THE GRAPHS OF THE CROSS SECTION AND THE POLARISATION.            GRAL-002
C INPUTS:  TGR(NTGS)     ANGLES.                                        GRAL-003
C          GRR(NTGS,I)   CROSS SECTIONS FOR I=1.                        GRAL-004
C                        ANALYSING POWER FOR I=2.                       GRAL-005
C                        IF IG=1, OBSERVABLE Q FOR I=5.                 GRAL-006
C                        IF IG=2, POLARISATION FOR I=3.                 GRAL-007
C                        IF IG=2, SPIN-FLIP FOR I=4.                    GRAL-008
C                        IF IG=2, OBSERVABLE Q FOR I=5.                 GRAL-009
C          NTGS          NUMBER OF ANGLES.                              GRAL-010
C          NNK(2)        NNK(1) NUMBER OF LOGARITHM CYCLES FOR THE CROSSGRAL-011
C                        SECTION .IF NNK(1)=0, NO GRAPH.                GRAL-012
C                        NNK(2) BINARY INDEX FOR THE GRAPHS OF THE      GRAL-013
C                        POLARISATION FROM 1 TO 7 OR 15.NO GRAPHS FOR   GRAL-014
C                        THE OTHER VALUES.                              GRAL-015
C          IG            1 FOR ELASTIC SCATTERING, 2 FOR TRANSITION.    GRAL-016
C***********************************************************************GRAL-017
      IMPLICIT REAL*8 (A-H,O-Z)                                         GRAL-018
      DIMENSION GRA(6),VGRA(113),TGR(1),GRR(NTGS,1),NNK(2),KX(4)        GRAL-019
      DATA GRA /1H+,1H*,1H.,1H,,1H ,1H1/                                GRAL-020
      IF (NNK(1).EQ.0) GO TO 12                                         GRAL-021
      NA2=100/NNK(1)                                                    GRAL-022
      IF (NA2.LE.0) GO TO 12                                            GRAL-023
C GRAPH OF THE DIFFERENTIAL CROSS SECTION.                              GRAL-024
      AA2=NA2                                                           GRAL-025
      WRITE (6,1000)                                                    GRAL-026
      AA3=(NNK(1)+1)/2                                                  GRAL-027
      AA3=AA2*AA3                                                       GRAL-028
      AA1=AA2/DLOG(10.D0)                                               GRAL-029
      NA1=102-NNK(1)*NA2                                                GRAL-030
      A5=102.5D0                                                        GRAL-031
C TOP AXIS                                                              GRAL-032
      DO 1 I=1,113                                                      GRAL-033
    1 VGRA(I)=GRA(5)                                                    GRAL-034
      DO 2 I=NA1,112,NA2                                                GRAL-035
    2 VGRA(I)=GRA(6)                                                    GRAL-036
      WRITE (6,1001) VGRA                                               GRAL-037
      DO 3 I=1,113                                                      GRAL-038
    3 VGRA(I)=GRA(3)                                                    GRAL-039
      DO 4 I=2,112,50                                                   GRAL-040
    4 VGRA(I)=GRA(2)                                                    GRAL-041
      WRITE (6,1001) VGRA                                               GRAL-042
C GRAPH                                                                 GRAL-043
      DO 9 I=1,NTGS                                                     GRAL-044
      DO 5 J=2,112                                                      GRAL-045
    5 VGRA(J)=GRA(5)                                                    GRAL-046
      A4=AA1*DLOG(GRR(I,1))+A5                                          GRAL-047
      NG=0                                                              GRAL-048
    6 IF (A4.GT.2.) GO TO 7                                             GRAL-049
      NG=NG+1                                                           GRAL-050
      IF (NG.GT.12) GO TO 21                                            GRAL-051
      A4=A4+AA3                                                         GRAL-052
      A5=A5+AA3                                                         GRAL-053
      WRITE (6,1002)                                                    GRAL-054
      GO TO 6                                                           GRAL-055
    7 IF (A4.LT.113.D0) GO TO 8                                         GRAL-056
      NG=NG+1                                                           GRAL-057
      IF (NG.GT.12) GO TO 21                                            GRAL-058
      A4=A4-AA3                                                         GRAL-059
      A5=A5-AA3                                                         GRAL-060
      WRITE (6,1003)                                                    GRAL-061
      GO TO 7                                                           GRAL-062
    8 L=A4                                                              GRAL-063
      VGRA(L)=GRA(1)                                                    GRAL-064
    9 WRITE (6,1004) TGR(I),VGRA                                        GRAL-065
C END OF THE GRAPH                                                      GRAL-066
      DO 10 I=1,113                                                     GRAL-067
   10 VGRA(I)=GRA(3)                                                    GRAL-068
      DO 11 I=2,112,50                                                  GRAL-069
   11 VGRA(I)=GRA(2)                                                    GRAL-070
      WRITE (6,1001) VGRA                                               GRAL-071
   12 NK=NNK(2)                                                         GRAL-072
      IF ((NK.LE.0).OR.(NK.GT.15)) RETURN                               GRAL-073
C GRAPH OF THE POLARISATIONS                                            GRAL-074
      KX(1)=MOD(NK,2)                                                   GRAL-075
      NK=NK/2                                                           GRAL-076
      KX(2)=MOD(NK,2)                                                   GRAL-077
      NK=NK/2                                                           GRAL-078
      KX(3)=MOD(NK,2)                                                   GRAL-079
      NK=NK/2                                                           GRAL-080
      KX(4)=MOD(NK,2)                                                   GRAL-081
C TOP AXIS                                                              GRAL-082
      WRITE (6,1000)                                                    GRAL-083
      IF (IG.EQ.1) WRITE (6,1005)                                       GRAL-084
      IF (IG.EQ.2) WRITE (6,1006)                                       GRAL-085
      WRITE (6,1007)                                                    GRAL-086
      NK=2*IG                                                           GRAL-087
      DO 13 I=1,113                                                     GRAL-088
   13 VGRA(I)=GRA(5)                                                    GRAL-089
      DO 14 I=1,103                                                     GRAL-090
   14 VGRA(I)=GRA(3)                                                    GRAL-091
      DO 15 I=2,102,10                                                  GRAL-092
   15 VGRA(I)=GRA(2)                                                    GRAL-093
      WRITE (6,1001) VGRA                                               GRAL-094
C GRAPH                                                                 GRAL-095
      DO 18 I=1,NTGS                                                    GRAL-096
      DO 16 M=2,102                                                     GRAL-097
   16 VGRA(M)=GRA(5)                                                    GRAL-098
      VGRA(52)=GRA(6)                                                   GRAL-099
      DO 17 K=1,NK                                                      GRAL-100
      IF (KX(K).EQ.0) GO TO 17                                          GRAL-101
      M=50.D0*GRR(I,K+1)+52.5D0                                         GRAL-102
      VGRA(M)=GRA(K)                                                    GRAL-103
   17 CONTINUE                                                          GRAL-104
   18 WRITE (6,1004) TGR(I),VGRA                                        GRAL-105
C END OF GRAPH                                                          GRAL-106
      DO 19 I=1,103                                                     GRAL-107
   19 VGRA(I)=GRA(3)                                                    GRAL-108
      DO 20 I=2,102,10                                                  GRAL-109
   20 VGRA(I)=GRA(2)                                                    GRAL-110
      WRITE (6,1001) VGRA                                               GRAL-111
      RETURN                                                            GRAL-112
   21 WRITE (6,1008)                                                    GRAL-113
      RETURN                                                            GRAL-114
 1000 FORMAT (1H1)                                                      GRAL-115
 1001 FORMAT (7X,113A1)                                                 GRAL-116
 1002 FORMAT (40(3H -*))                                                GRAL-117
 1003 FORMAT (40(3H *-))                                                GRAL-118
 1004 FORMAT (F7.2,113A1)                                               GRAL-119
 1005 FORMAT (42X,31H+ POLARISATION   * OBSERVABLE Q//)                 GRAL-120
 1006 FORMAT (25X,65H+ ASYMMETRY      * POLARISATION   . SPIN-FLIP      GRAL-121
     1, OBSERVABLE Q//)                                                 GRAL-122
 1007 FORMAT (//7X,2H-1,8X,3H-.8,7X,3H-.6,7X,3H-.4,7X,3H-.2,8X,1H0,9X,2HGRAL-123
     1.2,8X,2H.4,8X,2H.6,8X,2H.8,9X,1H1)                                GRAL-124
 1008 FORMAT (34H *** MORE THAN 12 TRANSLATIONS ***/24H *** GRAPH CANCELGRAL-125
     1LED ***)                                                          GRAL-126
      END                                                               GRAL-127
