C 04/11/99                                                      DWBB98  SCHE-000
      SUBROUTINE SCHE(F,JM,IJ1,IJ2,MT2,MF,XG,XZ,G,TX,AM,MC)             SCHE-001
C SCATTERING COEFFICIENTS IN THE HELICITY REPRESENTATION                SCHE-002
C INPUT VARIABLES: F:      S-MATRIX                                     SCHE-003
C                  JM:     MAXIMUM NUMBER OF CHANNEL SPINS, DIM. FOR F  SCHE-004
C                  IJ1,IJ2:MULTIPLICITY OF INITIAL AND FINAL TARGET     SCHE-005
C                  MF:     HELICITY NUMBERS. SEE DEPH                   SCHE-006
C                  MT2:    DIMENSION FOR AM                             SCHE-007
C                  XG:     COULOMB PHASE-SHIFTS                         SCHE-008
C                  XZ:     CONVERSION FACTOR TO MILLIBARNS              SCHE-009
C OUTPUT VARIABLES:G:      HELICITY SCATTERING COEFFICIENTS             SCHE-010
C                  TX:     TOTAL REACTION CROSS SECTION IN MB           SCHE-011
C WORKING FIELD:   AM(2,MT2,KAB) FOR PRODUCTS OF C.G. COEFFICIENTS      SCHE-012
C                  MC:     NUCLEAR STATE NUMBERS AND ANGULAR MOMENTA    SCHE-013
C***********************************************************************SCHE-014
      IMPLICIT REAL*8 (A-H,O-Z)                                         SCHE-015
      DIMENSION F(2,JM,IJ2,IJ1,2),MF(9,1),XG(2,1),G(2,JM,1),MC(4,2,1),AMSCHE-016
     1(2,MT2,1)                                                         SCHE-017
      DATA PI /3.1415926535897932D0/                                    SCHE-018
      COMMON /QUAN/ IPJ(2),IPI(2),IP3,LML,LMJ,IP4,KY,KC1,KCC,JT,NJY     SCHE-019
      IAJ=-MOD(IPJ(1)+1,2)-1                                            SCHE-020
      DO 4 JPI=1,2                                                      SCHE-021
      NC=0                                                              SCHE-022
      DO 3 I=1,2                                                        SCHE-023
      NJ=IPJ(I)                                                         SCHE-024
      NJ1=IAJ-NJ+1                                                      SCHE-025
      DO 2 J=1,NJ                                                       SCHE-026
      L1=NJ1-1                                                          SCHE-027
      DO 1 K=1,2                                                        SCHE-028
      IF (MOD(L1/2+IPI(I)+IPI(1)+JPI,2).NE.0) GO TO 1                   SCHE-029
      NC=NC+1                                                           SCHE-030
      MC(1,JPI,NC)=I                                                    SCHE-031
      MC(2,JPI,NC)=L1                                                   SCHE-032
      MC(3,JPI,NC)=NJ1                                                  SCHE-033
    1 L1=L1+2                                                           SCHE-034
    2 NJ1=NJ1+2                                                         SCHE-035
    3 CONTINUE                                                          SCHE-036
    4 CONTINUE                                                          SCHE-037
      IJ1=IPJ(1)                                                        SCHE-038
      IJ2=IPJ(2)                                                        SCHE-039
      TX=0.D0                                                           SCHE-040
      DO 13 IJ=1,JM                                                     SCHE-041
      IAJ=IAJ+2                                                         SCHE-042
      AAJ=IAJ+1                                                         SCHE-043
      DO 12 JI=1,2                                                      SCHE-044
C  GEOMETRIC COEFFICIENT FOR THE TRANSFORMATION TO HELICITY COEFFICIENTSSCHE-045
      NC1=0                                                             SCHE-046
      DO 8 IC=1,NC                                                      SCHE-047
      IV=MC(1,JI,IC)                                                    SCHE-048
      MI=IPJ(IV)                                                        SCHE-049
      MC(2,JI,IC)=MC(2,JI,IC)+2                                         SCHE-050
      MC(3,JI,IC)=MC(3,JI,IC)+2                                         SCHE-051
      MC(4,1,IC)=MC(3,JI,IC)-IABS(IAJ+1-MI)                             SCHE-052
      IF (MC(2,JI,IC).GE.2*LML) MC(4,1,IC)=-1                           SCHE-053
      IF (MC(4,1,IC).LT.0) GO TO 8                                      SCHE-054
      IF (IV.EQ.1) NC1=NC1+1                                            SCHE-055
      DO 7 I1=1,2                                                       SCHE-056
      A2=0.D0                                                           SCHE-057
      XB=0.5D0*(MI**2+(IAJ-MC(3,JI,IC))*(IAJ+MC(3,JI,IC)+2)-1)          SCHE-058
      C3=0.D0                                                           SCHE-059
C COUPLING FOR TARGET HELICITY                                          SCHE-060
      DO 5 I2=1,MI                                                      SCHE-061
      AM(I1,I2,IC)=0.D0                                                 SCHE-062
      IF (IABS(2*I2-MI-2*I1+2).GT.IAJ) GO TO 5                          SCHE-063
      N3=(IAJ+2*I1-2*I2+MI)*(IAJ-2*I1+2*I2-MI+2)*(I2-1)                 SCHE-064
      IF (N3.EQ.0) AM(I1,I2,IC)=2*MOD(I2,2)-1                           SCHE-065
      IF (N3.LE.0) GO TO 5                                              SCHE-066
      C2=C3                                                             SCHE-067
      IB=2*I2-MI-3                                                      SCHE-068
      C3=DSQRT((MI-I2+1)*(I2-1)*(AAJ**2-(2*I1-2*I2+MI-2+1)**2))         SCHE-069
      AM(I1,I2,IC)=((XB-IB*(IB-2*I1+3))*AM(I1,I2-1,IC)-C2*AM(I1,I2-2,IC)SCHE-070
     1)/C3                                                              SCHE-071
    5 A2=A2+2.D0*AM(I1,I2,IC)**2                                        SCHE-072
      IF (A2.NE.0.D0) A2=(MOD(1+MC(3,JI,IC)-IAJ+MI,4)-1)*DSQRT(AAJ/A2)  SCHE-073
      IF (I1.EQ.2) A2=A2*(MC(3,JI,IC)-MC(2,JI,IC))                      SCHE-074
      DO 6 I2=1,MI                                                      SCHE-075
    6 AM(I1,I2,IC)=AM(I1,I2,IC)*A2                                      SCHE-076
    7 CONTINUE                                                          SCHE-077
    8 CONTINUE                                                          SCHE-078
      IF (NC1.EQ.0) GO TO 12                                            SCHE-079
C TRANSFORMATION                                                        SCHE-080
      DO 11 ICX=1,IJ1                                                   SCHE-081
      IF (MC(4,1,ICX).LT.0) GO TO 11                                    SCHE-082
      LCI=MC(2,JI,ICX)/2+1                                              SCHE-083
      NC2=0                                                             SCHE-084
      DO 10 IC=1,IJ2                                                    SCHE-085
      ICP=IC+IJ1                                                        SCHE-086
      IF (MC(4,1,ICP).LT.0) GO TO 10                                    SCHE-087
      LCP=MC(2,JI,ICP)/2+1                                              SCHE-088
      NC2=NC2+1                                                         SCHE-089
      C1=XG(1,LCI)+XG(2,LCP)                                            SCHE-090
C MULTIPLICATION BY THE COULOMB PHASE                                   SCHE-091
      A1=DCOS(C1)                                                       SCHE-092
      A2=DSIN(C1)                                                       SCHE-093
      C2=F(1,IJ,IC,ICX,JI)*A1-F(2,IJ,IC,ICX,JI)*A2                      SCHE-094
      C3=F(1,IJ,IC,ICX,JI)*A2+F(2,IJ,IC,ICX,JI)*A1                      SCHE-095
      TX=TX+4.D0*PI*(C2**2+C3**2)*AAJ*XZ                                SCHE-096
C  HELICITY SCATTERING COEFFICIENTS                                     SCHE-097
      DO 9 ID=1,KY                                                      SCHE-098
      MF1=MF(1,ID)                                                      SCHE-099
      MF2=MF(2,ID)                                                      SCHE-100
      MF3=MF(3,ID)                                                      SCHE-101
      MF4=MF(4,ID)                                                      SCHE-102
      C1=AM(MF1,MF2,ICP)*AM(MF3,MF4,ICX)                                SCHE-103
      G(1,IJ,ID)=G(1,IJ,ID)+C2*C1                                       SCHE-104
    9 G(2,IJ,ID)=G(2,IJ,ID)+C3*C1                                       SCHE-105
   10 CONTINUE                                                          SCHE-106
   11 CONTINUE                                                          SCHE-107
   12 CONTINUE                                                          SCHE-108
   13 CONTINUE                                                          SCHE-109
      RETURN                                                            SCHE-110
      END                                                               SCHE-111
