C 07/12/98                                                      DWBB98  RESU-000
      SUBROUTINE RESU(SR,TX,JM,MF,COE,EX,NJC,AM,THE,MTETA,NZZ,LO)       RESU-001
C COMPUTES CROSS-SECTIONS AND POLARISATIONS                             RESU-002
C INPUT VARIABLES: SR:      HELICITY SCATTERING COEFFICIENTS            RESU-003
C                  TX:      INELASTIC CROSS-SECTIONS IN MILLIBARNS      RESU-004
C                  JM:      MAXIMUM NUMBER OF CHANNEL SPINS             RESU-005
C                  MF:      TABLES OF HELICITY, DESCRIPTION OF OBSERVA- RESU-006
C                           BLES ... ETC     SEE DEPH AND OBSE          RESU-007
C                  COE:     INDICATIONS FOR OBSERVABLES     SEE OBSE    RESU-008
C                  NJC:     FIRST DIMENSION OF WORKING ARRAY EX         RESU-009
C                  NZZ:     TOTAL LENGTH OF WORKING FIELD,RETURNS SPACE RESU-010
C                           USED.                                       RESU-011
C                  LO(1):   IS .TRUE. FOR RELATIVISTIC KINEMATICS       RESU-012
C                  LO(2):   IS .TRUE. FOR ANGLE IN THE LABORATORY SYSTEMRESU-013
C                  LO(3):   IS .TRUE. PLOT OF CROSS SECTION             RESU-014
C                  LO(4):   IS .TRUE. PLOT OF POLARISATIONS             RESU-015
C                  LO(5):   IS .TRUE. FOR OBSERVABLES IN LAB. SYSTEM    RESU-016
C WORKING SPACE:   AM:      FOR GENERAL PURPOSES                        RESU-017
C                  EX:      FOR OBSERVABLES                             RESU-018
C                  THE:     FOR PLOTS                                   RESU-019
C INFORMATIONS ARE ALSO IN LABELLED COMMON /TITR/ TITLE: HEAD OF OUTPUT RESU-020
C        THETA1,THETA2,DTHETA,DTHE FOR CALCULATION AT EQUIDISTANT ANGLESRESU-021
C        CMB: NUCLEAR MASS DIVIDED BY H BAR                             RESU-022
C        XZ:  CONVERSION FACTOR TO MILLIBARNS                           RESU-023
C        WV(I,J): WAVE NUMBER AND COULOMB PARAMETER                     RESU-024
C THE COMMON /RESC/ IS USED TO TRANSFER INFORMATIONS TO SCAT            RESU-025
C    SEE DESCRIPTION IN SCAT                                            RESU-026
C***********************************************************************RESU-027
      IMPLICIT REAL*8 (A-H,O-Z)                                         RESU-028
      LOGICAL LO(5)                                                     RESU-029
      DIMENSION SR(2,JM,1),MF(9,1),COE(1),AM(1),EX(NJC,3),THE(MTETA,3),NRESU-030
     1GM(2)                                                             RESU-031
      COMMON /TITR/ TITLE(18),THETA1,THETA2,DTHETA,DTHE,CMB,XZ,WV(6,2)  RESU-032
      COMMON /QUAN/ IJ1,IJ2,IP1,IP2,IP3,LML,LMJ,IP4,KY,KC1,KCC,JT,NJY   RESU-033
      COMMON /RESC/ XA,XB,MTT                                           RESU-034
      DATA NGM,NESP /1H+,1H-,0/                                         RESU-035
      AI=.5D0*(IJ1-1)                                                   RESU-036
      AJ=.5D0*(IJ2-1)                                                   RESU-037
      JX=MOD(IJ1,2)                                                     RESU-038
      WRITE (6,1000) TITLE                                              RESU-039
      IF (IP3.NE.1) WRITE (6,1001) TX                                   RESU-040
      WRITE (6,1002) AI,NGM(IP1+1),AJ,NGM(IP2+1)                        RESU-041
      MTT=4*IJ1*IJ2                                                     RESU-042
      M2=1+2*MTT                                                        RESU-043
      M3=M2+2*KY                                                        RESU-044
      M4=M3+JM                                                          RESU-045
      IF (LO(5)) M4=MAX0(M4,6*MTT)                                      RESU-046
      NESP=MAX0(NESP,M4)                                                RESU-047
      IF (M4.GT.NZZ) GO TO 17                                           RESU-048
      IF (.NOT.LO(2)) GO TO 2                                           RESU-049
      IF (LO(1)) GO TO 1                                                RESU-050
      XA=1.D0                                                           RESU-051
      XB=WV(3,1)*WV(1,2)/(WV(3,2)*WV(2,1))                              RESU-052
      GO TO 2                                                           RESU-053
    1 XA=DSQRT(1.D0+(WV(3,1)/(CMB*WV(2,1)))**2)                         RESU-054
      XB=DSQRT(WV(1,2)**2+(WV(3,2)/CMB)**2)*WV(3,1)/(WV(3,2)*WV(2,1))   RESU-055
    2 I4=2+KCC-KC1                                                      RESU-056
      I3=I4                                                             RESU-057
      I5=2                                                              RESU-058
      IF (I4.GT.2.AND.MF(1,KC1+1).EQ.1) I5=3                            RESU-059
      I7=I4-I5                                                          RESU-060
      NGX=MIN0(KCC,KC1+5)                                               RESU-061
      WRITE (6,1003) ((MF(L,K),L=5,9),K=KC1,NGX)                        RESU-062
      IF (NGX.EQ.KCC) GO TO 4                                           RESU-063
    3 NJX=NGX+1                                                         RESU-064
      NGX=MIN0(KCC,NJX+4)                                               RESU-065
      WRITE (6,1004) ((MF(L,K),L=5,9),K=NJX,NGX)                        RESU-066
      IF (NGX.LT.KCC) GO TO 3                                           RESU-067
    4 DO 15 II=1,MTETA                                                  RESU-068
      THETB=THETA1+(II-1)*DTHETA                                        RESU-069
      THE(II,1)=THETB                                                   RESU-070
      THETA=THETB                                                       RESU-071
      KC=1                                                              RESU-072
    5 CALL SCAT(SR,MF,JM,THETA,CMB,COE,COE,AM,AM(M2),AM(M3),EX(1,KC),WV,RESU-073
     1JX,XZ,LO)                                                         RESU-074
      IF (DTHE.EQ.0.) GO TO 11                                          RESU-075
      GO TO ( 6 , 7 , 8 ),KC                                            RESU-076
    6 KC=2                                                              RESU-077
      THETA=THETB-DTHE                                                  RESU-078
      GO TO 5                                                           RESU-079
    7 KC=3                                                              RESU-080
      THETA=THETB+DTHE                                                  RESU-081
      GO TO 5                                                           RESU-082
    8 AA=EX(1,1)+EX(1,2)+EX(1,3)                                        RESU-083
      DO 10 K=2,I4                                                      RESU-084
      IF ((K.GT.I5).AND.(K.LE.I3)) GO TO 9                              RESU-085
      EX(K,1)=(EX(K,1)+EX(K,2)+EX(K,3))/3.D0                            RESU-086
      GO TO 10                                                          RESU-087
    9 EX(K,1)=(EX(K,1)*EX(1,1)+EX(K,2)*EX(1,2)+EX(K,3)*EX(1,3))/AA      RESU-088
   10 CONTINUE                                                          RESU-089
   11 THE(II,2)=EX(I5,1)                                                RESU-090
      I1=MIN0(I3,7)                                                     RESU-091
      WRITE (6,1005) THETB,(EX(K,1),K=2,I1)                             RESU-092
   12 IF (I1.GE.I3) GO TO 13                                            RESU-093
      I2=I1+1                                                           RESU-094
      I1=MIN0(I1+5,I3)                                                  RESU-095
      WRITE (6,1006) (EX(K,1),K=I2,I1)                                  RESU-096
      GO TO 12                                                          RESU-097
   13 IF (I7.LE.0) GO TO 15                                             RESU-098
      DO 14 K=1,I7                                                      RESU-099
   14 THE(II,K+2)=EX(K+I5,1)                                            RESU-100
   15 CONTINUE                                                          RESU-101
      IF (LO(3)) CALL GRAL(THE,THE(1,2),MTETA,MF(1,KCC-I7),1,.FALSE.)   RESU-102
      IF (LO(4).AND.I7.GT.0) CALL GRAL(THE,THE(1,3),MTETA,MF(1,KC1+I5-1)RESU-103
     1,I7,.TRUE.)                                                       RESU-104
   16 NZZ=NESP                                                          RESU-105
      RETURN                                                            RESU-106
   17 WRITE (6,1007)                                                    RESU-107
      GO TO 16                                                          RESU-108
 1000 FORMAT (1H1,5X,18A4//)                                            RESU-109
 1001 FORMAT (6X,25H==> TOTAL CROSS SECTION =,F14.6,11H MILLIBARNS)     RESU-110
 1002 FORMAT (/51H INELASTIC SCATTERING ON THE TARGET STATE OF SPIN =,F5RESU-111
     1.1,A1,11H  TO SPIN =,F5.1,A1)                                     RESU-112
 1003 FORMAT (/6X,6HANGLE ,6(4A4,A2))                                   RESU-113
 1004 FORMAT (30X,5(4A4,A2))                                            RESU-114
 1005 FORMAT (1X,F10.3,D16.5,2X,5F18.7)                                 RESU-115
 1006 FORMAT (29X,5F18.7)                                               RESU-116
 1007 FORMAT (//67H **** NOT ENOUGH STORAGE FOR THE COMPUTATION OF CROSSRESU-117
     1-SECTIONS ****//)                                                 RESU-118
      END                                                               RESU-119
