C 14/04/98                                                      DWBB98  GRAL-000
      SUBROUTINE GRAL(TGR,GRR,MTETA,MF,ID1,LT1)                         GRAL-001
C PLOTS OF CROSS-SECTION AND POLARISATIONS WITH OR WITHOUT EXPER. DATA  GRAL-002
C INPUT VARIABLES: TGR(I):    ANGLES FOR I=1,MTETA                      GRAL-003
C                  GRR(I,J):  CALC. VALUES FOR J=1,ID1 AND I=1,MTETA    GRAL-004
C                  MTETA:     NUMBER OF ANGLES                          GRAL-005
C                  MF:        DESCRIPTION OF DATA    SEE OBSE           GRAL-006
C                  ID1:       NUMBER OF DIFFERENT POLARISATIONS         GRAL-007
C                  LT1:       .TRUE. FOR POLARISATION,                  GRAL-008
C                             .FALSE. FOR CROSS SECTION                 GRAL-009
C MF(I,J) IS A TITLE FOR I=5,9                                          GRAL-010
C MF(2,J) IS THE NUMBER OF POWER OF 10 IN A LINE FOR CROSS SECTIONS     GRAL-011
C  AND MUST BE 1 TO PLOT A POLARISATION (ALWAYS BETWEEN -1 AND 1)       GRAL-012
C***********************************************************************GRAL-013
      LOGICAL LT1                                                       GRAL-014
      DOUBLE PRECISION TGR(1),GRR(MTETA,1)                              GRAL-015
      DIMENSION MF(9,1),VGR(112),GRA(17)                                GRAL-016
      DATA  GRA /1H+,1H*,1H,,1H:,1H-,1H1,1H2,1H3,1H4,1H5,1H6,1H7,1H8,1H9GRAL-017
     1,1H0,1H ,1H./                                                     GRAL-018
      IF (LT1) GO TO 13                                                 GRAL-019
C CROSS SECTIONS                                                        GRAL-020
      IF ((MF(2,1).LE.0).OR.(MF(2,1).GT.50)) RETURN                     GRAL-021
      NA2=100/MF(2,1)                                                   GRAL-022
      AA2=NA2                                                           GRAL-023
      WRITE (6,1000)                                                    GRAL-024
      WRITE (6,1001) GRA(1),(MF(J,1),J=5,9)                             GRAL-025
      AA3=AA2*((MF(2,1)+1)/2)                                           GRAL-026
      AA1=AA2/ALOG(10.)                                                 GRAL-027
      NA1=101-MF(2,1)*NA2                                               GRAL-028
      A5=101.5                                                          GRAL-029
      DO 1 I=1,112                                                      GRAL-030
    1 VGR(I)=GRA(16)                                                    GRAL-031
      DO 2 I=NA1,112,NA2                                                GRAL-032
    2 VGR(I)=GRA(6)                                                     GRAL-033
      WRITE (6,1002) VGR                                                GRAL-034
      DO 3 I=1,112                                                      GRAL-035
    3 VGR(I)=GRA(17)                                                    GRAL-036
      DO 4 I=NA1,112,NA2                                                GRAL-037
    4 VGR(I)=GRA(2)                                                     GRAL-038
      WRITE (6,1002) VGR                                                GRAL-039
      DO 10 I=1,MTETA                                                   GRAL-040
      DO 5 J=2,111                                                      GRAL-041
    5 VGR(J)=GRA(16)                                                    GRAL-042
      DO 6 J=NA1,111,NA2                                                GRAL-043
    6 VGR(J)=GRA(17)                                                    GRAL-044
      IF (GRR(I,1).LT.0.) GO TO 23                                      GRAL-045
      A4=AA1*DLOG(GRR(I,1))+A5                                          GRAL-046
      NG=0                                                              GRAL-047
    7 IF (NG.GT.20) GO TO 24                                            GRAL-048
      NG=NG+1                                                           GRAL-049
      IF (A4.GT.2.) GO TO 8                                             GRAL-050
      A4=A4+AA3                                                         GRAL-051
      A5=A5+AA3                                                         GRAL-052
      WRITE (6,1003)                                                    GRAL-053
      GO TO 7                                                           GRAL-054
    8 IF (A4.LT.112.) GO TO 9                                           GRAL-055
      A4=A4-AA3                                                         GRAL-056
      A5=A5-AA3                                                         GRAL-057
      WRITE (6,1004)                                                    GRAL-058
      GO TO 8                                                           GRAL-059
    9 L=A4                                                              GRAL-060
      VGR(L)=GRA(1)                                                     GRAL-061
   10 WRITE (6,1005) TGR(I),VGR                                         GRAL-062
      DO 11 I=1,112                                                     GRAL-063
   11 VGR(I)=GRA(17)                                                    GRAL-064
      DO 12 I=NA1,112,NA2                                               GRAL-065
   12 VGR(I)=GRA(2)                                                     GRAL-066
      WRITE (6,1002) VGR                                                GRAL-067
      RETURN                                                            GRAL-068
C POLARISATION                                                          GRAL-069
   13 NK=0                                                              GRAL-070
      DO 14 K=1,ID1                                                     GRAL-071
      IF (MF(2,K).NE.1) GO TO 14                                        GRAL-072
      KN=MOD(NK,15)+1                                                   GRAL-073
      NK=NK+1                                                           GRAL-074
      IF (NK.EQ.1) WRITE (6,1000)                                       GRAL-075
      WRITE (6,1001) GRA(KN),(MF(J,K),J=5,9)                            GRAL-076
   14 CONTINUE                                                          GRAL-077
      IF (NK.EQ.0) RETURN                                               GRAL-078
      WRITE (6,1006)                                                    GRAL-079
      DO 15 I=1,112                                                     GRAL-080
   15 VGR(I)=GRA(16)                                                    GRAL-081
      DO 16 I=1,103                                                     GRAL-082
   16 VGR(I)=GRA(17)                                                    GRAL-083
      DO 17 I=2,102,10                                                  GRAL-084
   17 VGR(I)=GRA(2)                                                     GRAL-085
      WRITE (6,1002) VGR                                                GRAL-086
      DO 20 I=1,MTETA                                                   GRAL-087
      DO 18 M=2,102                                                     GRAL-088
   18 VGR(M)=GRA(16)                                                    GRAL-089
      VGR(52)=GRA(17)                                                   GRAL-090
      NK=0                                                              GRAL-091
      DO 19 K=1,ID1                                                     GRAL-092
      IF (MF(2,K).NE.1) GO TO 19                                        GRAL-093
      NK=MOD(NK,15)+1                                                   GRAL-094
      M=50.*GRR(I,K)+52.5                                               GRAL-095
      IF (M.GT.1.AND.M.LE.102) VGR(M)=GRA(NK)                           GRAL-096
   19 CONTINUE                                                          GRAL-097
   20 WRITE (6,1005) TGR(I),VGR                                         GRAL-098
      DO 21 I=1,103                                                     GRAL-099
   21 VGR(I)=GRA(17)                                                    GRAL-100
      DO 22 I=2,102,10                                                  GRAL-101
   22 VGR(I)=GRA(2)                                                     GRAL-102
      WRITE (6,1002) VGR                                                GRAL-103
      RETURN                                                            GRAL-104
   23 WRITE (6,1007) I,GRR(I,1)                                         GRAL-105
      GO TO 25                                                          GRAL-106
   24 WRITE (6,1008) I,GRR(I,1)                                         GRAL-107
   25 WRITE (6,1009)                                                    GRAL-108
      RETURN                                                            GRAL-109
 1000 FORMAT (1H1)                                                      GRAL-110
 1001 FORMAT (45X,A1,4X,5A4/)                                           GRAL-111
 1002 FORMAT (7X,112A1)                                                 GRAL-112
 1003 FORMAT (40(3H -*))                                                GRAL-113
 1004 FORMAT (40(3H *-))                                                GRAL-114
 1005 FORMAT (F7.2,112A1)                                               GRAL-115
 1006 FORMAT (//6X,3H -1,7X,4H -.8,6X,4H -.6,6X,4H -.4,6X,4H -.2,7X,2H 0GRAL-116
     1,8X,3H .2,7X,3H .4,7X,3H .6,7X,3H .8,7X,2H 1)                     GRAL-117
 1007 FORMAT (8H FOR THE,I4,27HTH LINE, CALCULATED VALUE =,D15.8)       GRAL-118
 1008 FORMAT (8H FOR THE,I4,54HTH LINE, MORE THAN 20 TRANSLATIONS. CALCUGRAL-119
     1LATED VALUE =,D15.8)                                              GRAL-120
 1009 FORMAT (//25H **** GRAPH CANCELED ****)                           GRAL-121
      END                                                               GRAL-122
